////////////////////////////////////////////////////////////////////////
// edit_timer.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/convert.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.edit_timer")

// <%pre>
#line 1 "edit_timer.ecpp"

#include <memory>
#include <vdr/channels.h>
#include <vdr/config.h>
#include <vdr/epg.h>
#include <vdr/i18n.h>
#include "exception.h"
#include "tools.h"
#include "timers.h"
#include "setup.h"
#include "epg_events.h"
#include "timerconflict.h"
#include "i18n.h"

using namespace std;
using namespace vdrlive;


#line 1 "page_init.eh"

// do not add to Makefile
// and do not write a ecpp comment into this file. It must produce no
// html output not even a empty line.
#include <tnt/savepoint.h>
#include "exception.h"

#line 2 "page_exit.eh"

#include "exception.h"

// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
};

static tnt::ComponentFactoryImpl<_component_> Factory("edit_timer");

static const char* rawData = "\344\000\000\000\010\001\000\000\021\001\000\000\023\001\000\000\026\001\000\000\027\001"
  "\000\000(\001\000\000*\001\000\000-\001\000\000.\001\000\000r\001\000\000\275\001\000\000\354\001\000\000\253\002\000"
  "\000\021\003\000\000\213\003\000\000\300\003\000\000(\004\000\000]\004\000\000\316\004\000\000\016\005\000\000h\005"
  "\000\000\267\005\000\000\031\006\000\000\204\006\000\000\334\006\000\000h\007\000\000\212\007\000\000\004\010\000\000"
  "&\010\000\000\240\010\000\000\302\010\000\000<\t\000\000^\t\000\000\331\t\000\000\373\t\000\000u\n\000\000\227\n\000"
  "\000\021\013\000\0003\013\000\000\244\013\000\000\014\014\000\000S\014\000\000\253\014\000\000\021\015\000\000V\015"
  "\000\000\256\015\000\000\002\016\000\000X\016\000\000\301\016\000\000\031\017\000\000\202\017\000\0003\020\000\000"
  "\177\020\000\000\367\020\000\000\034\021\000\000\035\021\000\000\n<html>\n\t<head>\n\t\t<title>VDR Live - </title>\n"
  "\t\t\n\t\t\n\t</head>\n\t<body>\n\t\t\n\t\t\n\t\t<div class=\"inhalt\">\n\t\t\t<form method=\"post\" name=\"edit_time"
  "r\" id=\"\" action=\"edit_timer.ecpp\">\n\t\t\t\t<input type=\"hidden\" name=\"timerid\" value=\"\"/>\n\t\t\t\t<input"
  " type=\"hidden\" name=\"aux\" value=\"\"/>\n\t\t\t\t<table class=\"formular\" cellpadding=\"0\" cellspacing=\"0\">\n"
  "\t\t\t\t\t<tr class=\"head\">\n\t\t\t\t\t\t<td class=\"toprow leftcol rightcol\" colspan=\"2\"><div class=\"boxheader"
  "\"><div><div class=\"caption\"></div></div></div></td>\n\t\t\t\t\t</tr>\n\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class=\"la"
  "bel leftcol\"><div class=\"withmargin\">:</div></td>\n\t\t\t\t\t\t<td class=\"rightcol\">\n\t\t\t\t\t\t\t<div class="
  "\"dotted\">\n\t\t\t\t\t\t\t\t<input id=\"active_1\" name=\"active\" value=\"1\"  type=\"radio\"></input>\n\t\t\t\t\t"
  "\t\t\t<label for=\"active_1\"></label>\n\t\t\t\t\t\t\t</div>\n\t\t\t\t\t\t\t<div class=\"dotted\">\n\t\t\t\t\t\t\t\t<"
  "input id=\"active_0\" name=\"active\" value=\"0\"  type=\"radio\"></input>\n\t\t\t\t\t\t\t\t<label for=\"active_0\"><"
  "/label>\n\t\t\t\t\t\t\t</div>\n\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class=\"label le"
  "ftcol\"><div class=\"withmargin\">:</div></td>\n\t\t\t\t\t\t<td class=\"rightcol\"><div class=\"withmargin\"></div></"
  "td>\n\t\t\t\t\t</tr>\n\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class=\"label leftcol\"><div class=\"withmargin\">:</div></td"
  ">\n\t\t\t\t\t\t<td class=\"rightcol\"><input type=\"text\" name=\"title\" value=\"\" size=\"80\" /></td>\n\t\t\t\t\t<"
  "/tr>\n\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class=\"label leftcol\"><div class=\"withmargin\">:</div></td>\n\t\t\t\t\t\t<"
  "td class=\"rightcol\"><input id=\"date\" name=\"date\" type=\"text\" class=\"DatePicker\" value=\"\" /></td>\n\t\t\t"
  "\t\t</tr>\n\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class=\"label leftcol\"><div class=\"withmargin\">:</div></td>\n\t\t\t\t"
  "\t\t<td class=\"rightcol\">\n\t\t\t\t\t\t\t<div class=\"dotted\">\n\t\t\t\t\t\t\t\t<input id=\"wday_mon\" type=\"chec"
  "kbox\" name=\"wday_mon\" value=\"1\"  />\n\t\t\t\t\t\t\t\t<label for=\"wday_mon\"></label>\n\t\t\t\t\t\t\t</div>\n\t"
  "\t\t\t\t\t\t<div class=\"dotted\">\n\t\t\t\t\t\t\t\t<input id=\"wday_tue\" type=\"checkbox\" name=\"wday_tue\" value="
  "\"1\"  />\n\t\t\t\t\t\t\t\t<label for=\"wday_tue\"></label>\n\t\t\t\t\t\t\t</div>\n\t\t\t\t\t\t\t<div class=\"dotted"
  "\">\n\t\t\t\t\t\t\t\t<input id=\"wday_wed\" type=\"checkbox\" name=\"wday_wed\" value=\"1\"  />\n\t\t\t\t\t\t\t\t<lab"
  "el for=\"wday_wed\"></label>\n\t\t\t\t\t\t\t</div>\n\t\t\t\t\t\t\t<div class=\"dotted\">\n\t\t\t\t\t\t\t\t<input id="
  "\"wday_thu\" type=\"checkbox\" name=\"wday_thu\" value=\"1\"  />\n\t\t\t\t\t\t\t\t<label for=\"wday_thu\"></label>\n"
  "\t\t\t\t\t\t\t</div>\n\t\t\t\t\t\t\t<div class=\"dotted\">\n\t\t\t\t\t\t\t\t<input id =\"wday_fri\" type=\"checkbox\""
  " name=\"wday_fri\" value=\"1\"  />\n\t\t\t\t\t\t\t\t<label for=\"wday_fri\"></label>\n\t\t\t\t\t\t\t</div>\n\t\t\t\t"
  "\t\t\t<div class=\"dotted\">\n\t\t\t\t\t\t\t\t<input id=\"wday_sat\" type=\"checkbox\" name=\"wday_sat\" value=\"1\" "
  " />\n\t\t\t\t\t\t\t\t<label for=\"wday_sat\"></label>\n\t\t\t\t\t\t\t</div>\n\t\t\t\t\t\t\t<div class=\"dotted\">\n\t"
  "\t\t\t\t\t\t\t<input id=\"wday_sun\" type=\"checkbox\" name=\"wday_sun\" value=\"1\"  />\n\t\t\t\t\t\t\t\t<label for="
  "\"wday_sun\"></label>\n\t\t\t\t\t\t\t</div>\n\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td cl"
  "ass=\"label leftcol\"><div class=\"withmargin\">:</div></td>\n\t\t\t\t\t\t<td class=\"rightcol\"><input type=\"text\""
  " size=\"2\" maxlength=\"2\" name=\"start_h\" value=\"\" /> : <input type=\"text\" size=\"2\" maxlength=\"2\" name=\"s"
  "tart_m\" value=\"\" /></td>\n\t\t\t\t\t</tr>\n\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class=\"label leftcol\"><div class=\""
  "withmargin\">:</div></td>\n\t\t\t\t\t\t<td class=\"rightcol\"><input type=\"text\" size=\"2\" maxlength=\"2\" name=\""
  "end_h\" value=\"\" /> : <input type=\"text\" size=\"2\" maxlength=\"2\" name=\"end_m\" value=\"\" /></td>\n\t\t\t\t\t"
  "</tr>\n\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class=\"label leftcol\"><div class=\"withmargin\">:</div></td>\n\t\t\t\t\t\t"
  "<td class=\"rightcol\"><input type=\"checkbox\" name=\"vps\" value=\"1\" /></td>\n\t\t\t\t\t</tr>\n\n\t\t\t\t\t<tr>\n"
  "\t\t\t\t\t\t<td class=\"label leftcol\"><div class=\"withmargin\">:</div></td>\n\t\t\t\t\t\t<td class=\"rightcol\"><i"
  "nput type=\"text\" size=\"2\" maxlength=\"2\" name=\"priority\" value=\"\" /></td>\n\t\t\t\t\t</tr>\n\n\t\t\t\t\t<tr>"
  "\n\t\t\t\t\t\t<td class=\"label leftcol\"><div class=\"withmargin\">:</div></td>\n\t\t\t\t\t\t<td class=\"rightcol\">"
  "<input type=\"text\" size=\"2\" maxlength=\"2\" name=\"lifetime\" value=\"\" /></td>\n\t\t\t\t\t</tr>\n\n\t\t\t\t\t<t"
  "r>\n\t\t\t\t\t\t<td class=\"buttonpanel leftcol rightcol bottomrow\" colspan=\"2\">\n\t\t\t\t\t\t\t<div class=\"withm"
  "argin\">\n\t\t\t\t\t\t\t<button class=\"green\" type=\"submit\"></button>\n\t\t\t\t\t\t\t<button type=\"button\" clas"
  "s=\"red\" onclick=\"history.back()\"></button>\n\t\t\t\t\t\t\t</div>\n\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n\t\t\t\t</t"
  "able>\n\t\t\t</form>\n\t\t\t<div style=\"color: red; margin: 0 auto;\">\n\t\t\t\t\n\t\t\t</div>\n\t\t</div>\n\t</body"
  ">\n</html>\n\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

#define SET_LANG(lang) \
     do \
     { \
       request.setLang(lang); \
       reply.setLocale(request.getLocale()); \
     } while (false)

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl)
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("edit_timer " << qparam.getUrl());

  tnt::DataChunks data(rawData);

  // <%args>
string timerid = tnt::stringTo<string>("timerid", "string", qparam.param("timerid"), reply.out().getloc());
string epgid = tnt::stringTo<string>("epgid", "string", qparam.param("epgid"), reply.out().getloc());
string async = tnt::stringTo<string>("async", "string", qparam.param("async"), reply.out().getloc());
tChannelID channel = tnt::stringTo<tChannelID>("channel", "tChannelID", qparam.param("channel"), reply.out().getloc());
bool active = qparam.has("active") ? tnt::stringToWithDefault<bool>(qparam.param("active"), ( true), reply.out().getloc()) : ( true);
string title = qparam.has("title") ? tnt::stringToWithDefault<string>(qparam.param("title"), ( ""), reply.out().getloc()) : ( "");
string date = qparam.has("date") ? tnt::stringToWithDefault<string>(qparam.param("date"), ( ""), reply.out().getloc()) : ( "");
bool wday_mon = qparam.has("wday_mon") ? tnt::stringToWithDefault<bool>(qparam.param("wday_mon"), ( false), reply.out().getloc()) : ( false);
bool wday_tue = qparam.has("wday_tue") ? tnt::stringToWithDefault<bool>(qparam.param("wday_tue"), ( false), reply.out().getloc()) : ( false);
bool wday_wed = qparam.has("wday_wed") ? tnt::stringToWithDefault<bool>(qparam.param("wday_wed"), ( false), reply.out().getloc()) : ( false);
bool wday_thu = qparam.has("wday_thu") ? tnt::stringToWithDefault<bool>(qparam.param("wday_thu"), ( false), reply.out().getloc()) : ( false);
bool wday_fri = qparam.has("wday_fri") ? tnt::stringToWithDefault<bool>(qparam.param("wday_fri"), ( false), reply.out().getloc()) : ( false);
bool wday_sat = qparam.has("wday_sat") ? tnt::stringToWithDefault<bool>(qparam.param("wday_sat"), ( false), reply.out().getloc()) : ( false);
bool wday_sun = qparam.has("wday_sun") ? tnt::stringToWithDefault<bool>(qparam.param("wday_sun"), ( false), reply.out().getloc()) : ( false);
int start_h = qparam.has("start_h") ? tnt::stringToWithDefault<int>(qparam.param("start_h"), ( 0), reply.out().getloc()) : ( 0);
int start_m = qparam.has("start_m") ? tnt::stringToWithDefault<int>(qparam.param("start_m"), ( 0), reply.out().getloc()) : ( 0);
int end_h = qparam.has("end_h") ? tnt::stringToWithDefault<int>(qparam.param("end_h"), ( 0), reply.out().getloc()) : ( 0);
int end_m = qparam.has("end_m") ? tnt::stringToWithDefault<int>(qparam.param("end_m"), ( 0), reply.out().getloc()) : ( 0);
bool vps = qparam.has("vps") ? tnt::stringToWithDefault<bool>(qparam.param("vps"), ( 0), reply.out().getloc()) : ( 0);
int priority = qparam.has("priority") ? tnt::stringToWithDefault<int>(qparam.param("priority"), ( 0), reply.out().getloc()) : ( 0);
int lifetime = qparam.has("lifetime") ? tnt::stringToWithDefault<int>(qparam.param("lifetime"), ( 0), reply.out().getloc()) : ( 0);
string aux = qparam.has("aux") ? tnt::stringToWithDefault<string>(qparam.param("aux"), ( ""), reply.out().getloc()) : ( "");
  // </%args>

#line 46 "edit_timer.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_GLOBAL_VAR(logged_in_type, logged_in, "bool logged_in", (false));   // <%session> bool logged_in(false)
#line 47 "edit_timer.ecpp"
  typedef string edit_timerreferer_type;
  TNT_SESSION_GLOBAL_VAR(edit_timerreferer_type, edit_timerreferer, "string edit_timerreferer", ());   // <%session> string edit_timerreferer
#line 48 "edit_timer.ecpp"
  typedef TimerConflictNotifier timerNotifier_type;
  TNT_SESSION_GLOBAL_VAR(timerNotifier_type, timerNotifier, "TimerConflictNotifier timerNotifier", ());   // <%session> TimerConflictNotifier timerNotifier
#line 51 "edit_timer.ecpp"
  typedef cTimer* timer_type;
  TNT_REQUEST_PAGE_VAR(timer_type, timer, "cTimer* timer", ());   // <%request> cTimer* timer
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_GLOBAL_VAR(pageTitle_type, pageTitle, "std::string pageTitle", ());   // <%request> std::string pageTitle
  // <%cpp>
  // <%include> page_init.eh
#line 11 "page_init.eh"

try {
	reply.setHeader("Expires", "Mon, 26 Jul 1997 05:00:00 GMT");
	tnt::Savepoint spoint( reply );

  // </%include>
#line 54 "edit_timer.ecpp"

	if (!logged_in && LiveSetup().UseAuth()) return reply.redirect("login.html");

	bool ajaxReq = !async.empty() && (lexical_cast<int>(async) != 0);

	tChannelID channelid = tChannelID();
	tEventID eventid = tEventID();

	string message;
	cMutexLock timersLock( &LiveTimerManager() );
	SortedTimers& timers = LiveTimerManager().GetTimers();

	timer = 0;
	if ( !timerid.empty() ) {
		string tId = SortedTimers::DecodeDomId(timerid);
		// dsyslog("DEBUG: TIMER: tId = %s", tId.c_str());
		timer = timers.GetByTimerId(tId);
		if ( timer == 0 )
			throw HtmlError( tr("Couldn't find timer. Maybe you mistyped your request?") );
	}

	if ( request.getMethod() == "POST" ) {
		uint flags = ( active ? tfActive : 0 ) | ( vps ? tfVps : 0 );
		string weekdays = string( wday_mon ? "M" : "-" ) + ( wday_tue ? "T" : "-" ) + ( wday_wed ? "W" : "-" )
							  + ( wday_thu ? "T" : "-" ) + ( wday_fri ? "F" : "-" ) + ( wday_sat ? "S" : "-" )
							  + ( wday_sun ? "S" : "-" );
		int start = start_h * 100 + start_m;
		int stop = end_h * 100 + end_m;

		if (title.empty())
			message = tr("Please set a title for the timer!");
		else
		{
			time_t tdate = GetDateFromDatePicker(date, tr("mm/dd/yyyy"));
			string sdate = DatePickerToC(tdate, "yyyy-mm-dd");
			LiveTimerManager().UpdateTimer( timer, flags, channel, weekdays, sdate, start, stop, priority, lifetime, title, aux );
			timerNotifier.SetTimerModification();
			return reply.redirect(!edit_timerreferer.empty()?edit_timerreferer:"timers.html");
		}
	}

	if (message.empty())
		edit_timerreferer = request.getHeader("Referer:", "timers.html");

	auto_ptr< cTimer > eventTimer;
	if ( timer == 0 && !epgid.empty()) {
		EpgEvents::DecodeDomId(epgid, channelid, eventid);
		if ( channelid.Valid() && eventid != 0 ) {
			cerr << "grabbing event" << endl << endl;
			cSchedulesLock schedLock;
			cSchedules const* schedules = cSchedules::Schedules( schedLock );
			cSchedule const* schedule = schedules->GetSchedule( channelid );

			eventTimer.reset( new cTimer( schedule->GetEvent( eventid ) ) );
		} else {
			cerr << "grabbing new timer" << endl << endl;
			eventTimer.reset( new cTimer() );
			eventTimer->SetFlags( tfActive );
		}
		timer = eventTimer.get();
	}

	if ( timer != 0 ) {
		active = timer->Flags() & tfActive;
		channel = timer->Channel()->GetChannelID();
		title = timer->File() ? timer->File() : "";
		date = timer->Day() ? DatePickerToC(timer->Day(), tr("mm/dd/yyyy")) : "";
		wday_mon = timer->WeekDays() & 0x01;
		wday_tue = timer->WeekDays() & 0x02;
		wday_wed = timer->WeekDays() & 0x04;
		wday_thu = timer->WeekDays() & 0x08;
		wday_fri = timer->WeekDays() & 0x10;
		wday_sat = timer->WeekDays() & 0x20;
		wday_sun = timer->WeekDays() & 0x40;
		start_h = ( timer->Start() / 100 ) % 100;
		start_m = timer->Start() % 100;
		end_h = ( timer->Stop() / 100 ) % 100;
		end_m = timer->Stop() % 100;
		vps = timer->Flags() & tfVps;
		priority = timer->Priority();
		lifetime = timer->Lifetime();
		aux = timer->Aux() ? timer->Aux() : "";
	}

  // <& pageelems.doc_type ...
  { 
#line 138 "edit_timer.ecpp"
    tnt::QueryParams _tnt_cq0(qparam, false);
#line 138 "edit_timer.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "doc_type"), request, reply, _tnt_cq0);
    // &>
  }
  reply.out() << data[0]; // \n<html>\n\t<head>\n\t\t<title>VDR Live - 
#line 141 "edit_timer.ecpp"
  reply.sout() << ( timer ? tr("Edit timer") : tr("New timer") );
  reply.out() << data[1]; // </title>\n
#line 142 "edit_timer.ecpp"

	if (!ajaxReq) {

  reply.out() << data[2]; // \t\t
  // <& pageelems.stylesheets ...
  { 
#line 145 "edit_timer.ecpp"
    tnt::QueryParams _tnt_cq1(qparam, false);
#line 145 "edit_timer.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "stylesheets"), request, reply, _tnt_cq1);
    // &>
  }
  reply.out() << data[3]; // \n\t\t
  // <& pageelems.ajax_js ...
  { 
#line 146 "edit_timer.ecpp"
    tnt::QueryParams _tnt_cq2(qparam, false);
#line 146 "edit_timer.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_js"), request, reply, _tnt_cq2);
    // &>
  }
  reply.out() << data[4]; // \n
#line 147 "edit_timer.ecpp"

	}

  reply.out() << data[5]; // \t</head>\n\t<body>\n
#line 152 "edit_timer.ecpp"

	if (!ajaxReq) {

  reply.out() << data[6]; // \t\t
  // <& pageelems.logo ...
  { 
#line 155 "edit_timer.ecpp"
    tnt::QueryParams _tnt_cq3(qparam, false);
#line 155 "edit_timer.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "logo"), request, reply, _tnt_cq3);
    // &>
  }
  reply.out() << data[7]; // \n\t\t
  // <& menu ...
  { 
#line 156 "edit_timer.ecpp"
    tnt::QueryParams _tnt_cq4(qparam, false);
#line 156 "edit_timer.ecpp"
    _tnt_cq4.add( "active", tnt::toString(("timers"), reply.out().getloc() ) );
#line 156 "edit_timer.ecpp"
    callComp(tnt::Compident(std::string(), "menu"), request, reply, _tnt_cq4);
    // &>
  }
  reply.out() << data[8]; // \n
#line 157 "edit_timer.ecpp"

	}

  reply.out() << data[9]; // \t\t<div class="inhalt">\n\t\t\t<form method="post" name="edit_timer" id="
#line 161 "edit_timer.ecpp"
  reply.sout() << ( timerid );
  reply.out() << data[10]; // " action="edit_timer.ecpp">\n\t\t\t\t<input type="hidden" name="timerid" value="
#line 162 "edit_timer.ecpp"
  reply.sout() << ( timerid );
  reply.out() << data[11]; // "/>\n\t\t\t\t<input type="hidden" name="aux" value="
#line 163 "edit_timer.ecpp"
  reply.sout() << ( aux );
  reply.out() << data[12]; // "/>\n\t\t\t\t<table class="formular" cellpadding="0" cellspacing="0">\n\t\t\t\t\t<tr class="head">\n\t\t\t\t\t\t<td class="toprow leftcol rightcol" colspan="2"><div class="boxheader"><div><div class="caption">
#line 166 "edit_timer.ecpp"
  reply.sout() << ( timer ? tr("Edit timer") : tr("New timer") );
  reply.out() << data[13]; // </div></div></div></td>\n\t\t\t\t\t</tr>\n\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="label leftcol"><div class="withmargin">
#line 170 "edit_timer.ecpp"
  reply.sout() << ( trVDR("Active") );
  reply.out() << data[14]; // :</div></td>\n\t\t\t\t\t\t<td class="rightcol">\n\t\t\t\t\t\t\t<div class="dotted">\n\t\t\t\t\t\t\t\t<input id="active_1" name="active" value="1" 
#line 173 "edit_timer.ecpp"
 reply.out() << ( active ? "checked=\"checked\"" : "" ); 
  reply.out() << data[15]; //  type="radio"></input>\n\t\t\t\t\t\t\t\t<label for="active_1">
#line 174 "edit_timer.ecpp"
  reply.sout() << ( trVDR("yes") );
  reply.out() << data[16]; // </label>\n\t\t\t\t\t\t\t</div>\n\t\t\t\t\t\t\t<div class="dotted">\n\t\t\t\t\t\t\t\t<input id="active_0" name="active" value="0" 
#line 177 "edit_timer.ecpp"
 reply.out() << ( !active ? "checked=\"checked\"" : "" ); 
  reply.out() << data[17]; //  type="radio"></input>\n\t\t\t\t\t\t\t\t<label for="active_0">
#line 178 "edit_timer.ecpp"
  reply.sout() << ( trVDR("no") );
  reply.out() << data[18]; // </label>\n\t\t\t\t\t\t\t</div>\n\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="label leftcol"><div class="withmargin">
#line 184 "edit_timer.ecpp"
  reply.sout() << ( trVDR("Channel") );
  reply.out() << data[19]; // :</div></td>\n\t\t\t\t\t\t<td class="rightcol"><div class="withmargin">
  // <& channels_widget ...
  { 
#line 185 "edit_timer.ecpp"
    tnt::QueryParams _tnt_cq5(qparam, false);
#line 185 "edit_timer.ecpp"
    _tnt_cq5.add( "channelid", tnt::toString((true), reply.out().getloc() ) );
#line 185 "edit_timer.ecpp"
    _tnt_cq5.add( "name", tnt::toString(("channel"), reply.out().getloc() ) );
#line 185 "edit_timer.ecpp"
    _tnt_cq5.add( "selected", tnt::toString((channel), reply.out().getloc() ) );
#line 185 "edit_timer.ecpp"
    callComp(tnt::Compident(std::string(), "channels_widget"), request, reply, _tnt_cq5);
    // &>
  }
  reply.out() << data[20]; // </div></td>\n\t\t\t\t\t</tr>\n\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="label leftcol"><div class="withmargin">
#line 189 "edit_timer.ecpp"
  reply.sout() << ( tr("Title" ) );
  reply.out() << data[21]; // :</div></td>\n\t\t\t\t\t\t<td class="rightcol"><input type="text" name="title" value="
#line 190 "edit_timer.ecpp"
  reply.sout() << ( title );
  reply.out() << data[22]; // " size="80" /></td>\n\t\t\t\t\t</tr>\n\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="label leftcol"><div class="withmargin">
#line 194 "edit_timer.ecpp"
  reply.sout() << ( trVDR("Day") );
  reply.out() << data[23]; // :</div></td>\n\t\t\t\t\t\t<td class="rightcol"><input id="date" name="date" type="text" class="DatePicker" value="
#line 195 "edit_timer.ecpp"
  reply.sout() << ( date );
  reply.out() << data[24]; // " /></td>\n\t\t\t\t\t</tr>\n\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="label leftcol"><div class="withmargin">
#line 199 "edit_timer.ecpp"
  reply.sout() << ( tr("Weekday") );
  reply.out() << data[25]; // :</div></td>\n\t\t\t\t\t\t<td class="rightcol">\n\t\t\t\t\t\t\t<div class="dotted">\n\t\t\t\t\t\t\t\t<input id="wday_mon" type="checkbox" name="wday_mon" value="1" 
#line 202 "edit_timer.ecpp"
 reply.out() << ( wday_mon ? "checked=\"checked\"" : "" ); 
  reply.out() << data[26]; //  />\n\t\t\t\t\t\t\t\t<label for="wday_mon">
#line 203 "edit_timer.ecpp"
  reply.sout() << ( tr("Monday") );
  reply.out() << data[27]; // </label>\n\t\t\t\t\t\t\t</div>\n\t\t\t\t\t\t\t<div class="dotted">\n\t\t\t\t\t\t\t\t<input id="wday_tue" type="checkbox" name="wday_tue" value="1" 
#line 206 "edit_timer.ecpp"
 reply.out() << ( wday_tue ? "checked=\"checked\"" : "" ); 
  reply.out() << data[28]; //  />\n\t\t\t\t\t\t\t\t<label for="wday_tue">
#line 207 "edit_timer.ecpp"
  reply.sout() << ( tr("Tuesday") );
  reply.out() << data[29]; // </label>\n\t\t\t\t\t\t\t</div>\n\t\t\t\t\t\t\t<div class="dotted">\n\t\t\t\t\t\t\t\t<input id="wday_wed" type="checkbox" name="wday_wed" value="1" 
#line 210 "edit_timer.ecpp"
 reply.out() << ( wday_wed ? "checked=\"checked\"" : "" ); 
  reply.out() << data[30]; //  />\n\t\t\t\t\t\t\t\t<label for="wday_wed">
#line 211 "edit_timer.ecpp"
  reply.sout() << ( tr("Wednesday") );
  reply.out() << data[31]; // </label>\n\t\t\t\t\t\t\t</div>\n\t\t\t\t\t\t\t<div class="dotted">\n\t\t\t\t\t\t\t\t<input id="wday_thu" type="checkbox" name="wday_thu" value="1" 
#line 214 "edit_timer.ecpp"
 reply.out() << ( wday_thu ? "checked=\"checked\"" : "" ); 
  reply.out() << data[32]; //  />\n\t\t\t\t\t\t\t\t<label for="wday_thu">
#line 215 "edit_timer.ecpp"
  reply.sout() << ( tr("Thursday") );
  reply.out() << data[33]; // </label>\n\t\t\t\t\t\t\t</div>\n\t\t\t\t\t\t\t<div class="dotted">\n\t\t\t\t\t\t\t\t<input id ="wday_fri" type="checkbox" name="wday_fri" value="1" 
#line 218 "edit_timer.ecpp"
 reply.out() << ( wday_fri ? "checked=\"checked\"" : "" ); 
  reply.out() << data[34]; //  />\n\t\t\t\t\t\t\t\t<label for="wday_fri">
#line 219 "edit_timer.ecpp"
  reply.sout() << ( tr("Friday") );
  reply.out() << data[35]; // </label>\n\t\t\t\t\t\t\t</div>\n\t\t\t\t\t\t\t<div class="dotted">\n\t\t\t\t\t\t\t\t<input id="wday_sat" type="checkbox" name="wday_sat" value="1" 
#line 222 "edit_timer.ecpp"
 reply.out() << ( wday_sat ? "checked=\"checked\"" : "" ); 
  reply.out() << data[36]; //  />\n\t\t\t\t\t\t\t\t<label for="wday_sat">
#line 223 "edit_timer.ecpp"
  reply.sout() << ( tr("Saturday") );
  reply.out() << data[37]; // </label>\n\t\t\t\t\t\t\t</div>\n\t\t\t\t\t\t\t<div class="dotted">\n\t\t\t\t\t\t\t\t<input id="wday_sun" type="checkbox" name="wday_sun" value="1" 
#line 226 "edit_timer.ecpp"
 reply.out() << ( wday_sun ? "checked=\"checked\"" : "" ); 
  reply.out() << data[38]; //  />\n\t\t\t\t\t\t\t\t<label for="wday_sun">
#line 227 "edit_timer.ecpp"
  reply.sout() << ( tr("Sunday") );
  reply.out() << data[39]; // </label>\n\t\t\t\t\t\t\t</div>\n\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="label leftcol"><div class="withmargin">
#line 233 "edit_timer.ecpp"
  reply.sout() << ( trVDR("Start") );
  reply.out() << data[40]; // :</div></td>\n\t\t\t\t\t\t<td class="rightcol"><input type="text" size="2" maxlength="2" name="start_h" value="
#line 234 "edit_timer.ecpp"
  reply.sout() << ( ZeroPad(start_h) );
  reply.out() << data[41]; // " /> : <input type="text" size="2" maxlength="2" name="start_m" value="
#line 234 "edit_timer.ecpp"
  reply.sout() << ( ZeroPad(start_m) );
  reply.out() << data[42]; // " /></td>\n\t\t\t\t\t</tr>\n\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="label leftcol"><div class="withmargin">
#line 238 "edit_timer.ecpp"
  reply.sout() << ( trVDR("Stop") );
  reply.out() << data[43]; // :</div></td>\n\t\t\t\t\t\t<td class="rightcol"><input type="text" size="2" maxlength="2" name="end_h" value="
#line 239 "edit_timer.ecpp"
  reply.sout() << ( ZeroPad(end_h) );
  reply.out() << data[44]; // " /> : <input type="text" size="2" maxlength="2" name="end_m" value="
#line 239 "edit_timer.ecpp"
  reply.sout() << ( ZeroPad(end_m) );
  reply.out() << data[45]; // " /></td>\n\t\t\t\t\t</tr>\n\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="label leftcol"><div class="withmargin">
#line 243 "edit_timer.ecpp"
  reply.sout() << ( tr("Use VPS") );
  reply.out() << data[46]; // :</div></td>\n\t\t\t\t\t\t<td class="rightcol"><input type="checkbox" name="vps" value="1" 
#line 244 "edit_timer.ecpp"
 reply.out() << ( vps ? "checked=\"checked\"" : "" ); 
  reply.out() << data[47]; // /></td>\n\t\t\t\t\t</tr>\n\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="label leftcol"><div class="withmargin">
#line 248 "edit_timer.ecpp"
  reply.sout() << ( trVDR("Priority") );
  reply.out() << data[48]; // :</div></td>\n\t\t\t\t\t\t<td class="rightcol"><input type="text" size="2" maxlength="2" name="priority" value="
#line 249 "edit_timer.ecpp"
  reply.sout() << ( priority );
  reply.out() << data[49]; // " /></td>\n\t\t\t\t\t</tr>\n\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="label leftcol"><div class="withmargin">
#line 253 "edit_timer.ecpp"
  reply.sout() << ( trVDR("Lifetime") );
  reply.out() << data[50]; // :</div></td>\n\t\t\t\t\t\t<td class="rightcol"><input type="text" size="2" maxlength="2" name="lifetime" value="
#line 254 "edit_timer.ecpp"
  reply.sout() << ( lifetime );
  reply.out() << data[51]; // " /></td>\n\t\t\t\t\t</tr>\n\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="buttonpanel leftcol rightcol bottomrow" colspan="2">\n\t\t\t\t\t\t\t<div class="withmargin">\n\t\t\t\t\t\t\t<button class="green" type="submit">
#line 260 "edit_timer.ecpp"
  reply.sout() << ( tr("Save") );
  reply.out() << data[52]; // </button>\n\t\t\t\t\t\t\t<button type="button" class="red" onclick="history.back()">
#line 261 "edit_timer.ecpp"
  reply.sout() << ( tr("Cancel") );
  reply.out() << data[53]; // </button>\n\t\t\t\t\t\t\t</div>\n\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n\t\t\t\t</table>\n\t\t\t</form>\n\t\t\t<div style="color: red; margin: 0 auto;">\n\t\t\t\t
#line 268 "edit_timer.ecpp"
  reply.sout() << ( message );
  reply.out() << data[54]; // \n\t\t\t</div>\n\t\t</div>\n\t</body>\n</html>\n
  // <%include> page_exit.eh
  reply.out() << data[55]; // \n
#line 5 "page_exit.eh"

	spoint.commit();
} catch ( vdrlive::HtmlError const& ex ) {
#if TNTVERSION >= 1606
	tnt::QueryParams param = qparam;
#else
	cxxtools::QueryParams param = qparam;
#endif
	param.add( "pageTitle", pageTitle );
	param.add( "errorMessage", ex.what() );
	callComp( "error", request, reply, param );
}

  // </%include>
  // <%/cpp>
  return HTTP_OK;
}

} // namespace
