////////////////////////////////////////////////////////////////////////
// recordings.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/convert.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.recordings")

// <%pre>
#line 1 "recordings.ecpp"

#include <string>

#include <vdr/plugin.h>
#include <vdr/config.h>

#include "exception.h"
#include "tools.h"
#include "epg_events.h"

#include "setup.h"
#include "tasks.h"
#include "tools.h"

#include "recman.h"

using namespace vdrlive;
using namespace std;


#line 1 "page_init.eh"

// do not add to Makefile
// and do not write a ecpp comment into this file. It must produce no
// html output not even a empty line.
#include <tnt/savepoint.h>
#include "exception.h"

#line 2 "page_exit.eh"

#include "exception.h"

// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    class recordings_item_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        recordings_item_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class del_rec_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        del_rec_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class rec_tools_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        rec_tools_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class archived_disc_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        archived_disc_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class rec_item_dir_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        rec_item_dir_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class rec_item_file_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        rec_item_file_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class delete_error_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        delete_error_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    recordings_item_type recordings_item;
    del_rec_type del_rec;
    rec_tools_type rec_tools;
    archived_disc_type archived_disc;
    rec_item_dir_type rec_item_dir;
    rec_item_file_type rec_item_file;
    delete_error_type delete_error;
};

static tnt::ComponentFactoryImpl<_component_> Factory("recordings");

static const char* rawData = "D\001\000\000h\001\000\000s\001\000\000v\001\000\000\307\001\000\000\310\001\000\000\312"
  "\001\000\000\313\001\000\000\315\001\000\000\316\001\000\000\t\002\000\000\034\002\000\000\037\002\000\000 \002\000"
  "\000s\002\000\000\207\002\000\000\241\002\000\000\242\002\000\000\243\002\000\000\245\002\000\000\277\002\000\000\300"
  "\002\000\000\365\002\000\000\007\003\000\000#\003\000\000.\003\000\000/\003\000\0001\003\000\000P\003\000\000R\003"
  "\000\000]\003\000\000l\003\000\000m\003\000\000o\003\000\000p\003\000\000q\003\000\000r\003\000\000s\003\000\000u\003"
  "\000\000\177\003\000\000\216\003\000\000\222\003\000\000\223\003\000\000\224\003\000\000\226\003\000\000\351\003\000"
  "\000\016\004\000\000<\004\000\000\214\004\000\000\325\004\000\000\326\004\000\000\330\004\000\000\023\005\000\000\035"
  "\005\000\000,\005\000\000/\005\000\0009\005\000\000I\005\000\000\231\005\000\000\233\005\000\000\300\005\000\000\345"
  "\005\000\000\016\006\000\0006\006\000\0007\006\000\000=\006\000\000C\006\000\000J\006\000\000]\006\000\000\221\006"
  "\000\000\223\006\000\000\224\006\000\000\335\006\000\000\336\006\000\000\007\007\000\000'\007\000\000D\007\000\000K"
  "\007\000\000S\007\000\000T\007\000\000V\007\000\000\n<html>\n\t<head>\n\t\t<title>VDR-Live - </title>\n\t\t\n\t\t\n\t"
  "\t<script type=\"text/javascript\" src=\"treeview.js\"></script>\n\t</head>\n\t<body>\n\t\t\n\t\t\n\t\t\n\t\t<div cla"
  "ss=\"inhalt\">\n\t\t\t<div class=\"boxheader\"><div><div></div></div></div>\n\t\t\t\n\t\t\t<div class=\"recordings\">"
  "\n\t\t\t<ul class=\"recordingslist\" style=\"display: block;\">\n\n\t\t\t</ul>\n\t\t\t</div>\n\t\t</div>\n\t</body>\n"
  "</html>\n\n\n\n\n\t<li class=\"recording\">\n\t\t\n\t\t<ul class=\"recordingslist\" style=\"display: none;\">\n    \t"
  "</ul>\n\t</li>\n\t<li class=\"recording\">\n\t   \n    </li>\n\n\n\n<a href=\"recordings.html\?todel=\" ><img src=\""
  "\" alt=\"\" /></a>\n\n\n\n\n\n\n\n\n<img src=\"\" alt=\"on_dvd\"  />\n\n\n\n\n\t<div class=\"recording_item\" onclick"
  "=\"Toggle(this)\">\n\t\t<div class=\"recording_imgs\"><img class=\"recording_expander\" src=\"\" alt=\"\" /><img clas"
  "s=\"recording_folder\" src=\"\" alt=\"\" /></div>\n\t\t<div class=\"recording_spec\">\n\t\t\t<div class=\"recording_n"
  "ame\"></div>\n\t    </div>\n\t\t<div class=\"recording_actions\">&nbsp;</div>\n\t</div>\n\n\n\n\t<div class=\"recordi"
  "ng_item\">\n\t<div class=\"recording_imgs\"><img src=\"\" alt=\"on_dvd\"  /><img src=\"\" alt=\"movie\" /></div>\n\t<"
  "div class=\"recording_spec\">\n\t\t<div class=\"recording_day\" style=\"width: \"></div>\n\t\t<div class=\"recording_"
  "date\"></div>\n\t\t<div class=\"recording_time\"></div>\n\t\t<div class=\"recording_duration\"></div>\n\t\t<div class"
  "=\"recording_name\"><a ><br /><span></span><span>&nbsp;</span></a></div>\n\t</div>\n\t<div class=\"recording_actions"
  "\">\n\t\t\n\t\t<img src=\"/img/transparent.png\" alt=\"\" width=\"16px\" height=\"16px\" />\n\t\t\n\t\t<!-- not suppo"
  "rted yet ...\n\t\t<img src=\"\" alt=\"\" />\n        -->\n\t</div>\n\t<div class=\"recording_arch\"></div>\n\t</div>"
  "\n\n\n\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

#define SET_LANG(lang) \
     do \
     { \
       request.setLang(lang); \
       reply.setLocale(request.getLocale()); \
     } while (false)

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl),
    recordings_item(*this, "recordings_item"),
    del_rec(*this, "del_rec"),
    rec_tools(*this, "rec_tools"),
    archived_disc(*this, "archived_disc"),
    rec_item_dir(*this, "rec_item_dir"),
    rec_item_file(*this, "rec_item_file"),
    delete_error(*this, "delete_error")
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings " << qparam.getUrl());

  tnt::DataChunks data(rawData);

  // <%args>
string todel = tnt::stringTo<string>("todel", "string", qparam.param("todel"), reply.out().getloc());
  // </%args>

#line 25 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_GLOBAL_VAR(logged_in_type, logged_in, "bool logged_in", (false));   // <%session> bool logged_in(false)
#line 28 "recordings.ecpp"
  typedef string deleteResult_type;
  TNT_REQUEST_PAGE_VAR(deleteResult_type, deleteResult, "string deleteResult", ());   // <%request> string deleteResult
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_GLOBAL_VAR(pageTitle_type, pageTitle, "std::string pageTitle", ());   // <%request> std::string pageTitle
  // <%cpp>
  // <%include> page_init.eh
#line 11 "page_init.eh"

try {
	reply.setHeader("Expires", "Mon, 26 Jul 1997 05:00:00 GMT");
	tnt::Savepoint spoint( reply );

  // </%include>
#line 31 "recordings.ecpp"

if (!logged_in && LiveSetup().UseAuth()) return reply.redirect("login.html");

pageTitle = tr("Recordings");

if (!todel.empty()) {
	RemoveRecordingTask task(todel);
	LiveTaskManager().Execute(task);
	if (!task.Result())
		deleteResult = string() + tr("ERROR:") + " " + task.Error();
	else
		deleteResult = string() + tr("Deleted recording:") + " " + StringReplace(task.RecName(), "~", "/");
}

  // <& pageelems.doc_type ...
  { 
#line 45 "recordings.ecpp"
    tnt::QueryParams _tnt_cq0(qparam, false);
#line 45 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "doc_type"), request, reply, _tnt_cq0);
    // &>
  }
  reply.out() << data[0]; // \n<html>\n\t<head>\n\t\t<title>VDR-Live - 
#line 48 "recordings.ecpp"
  reply.sout() << ( pageTitle );
  reply.out() << data[1]; // </title>\n\t\t
  // <& pageelems.stylesheets ...
  { 
#line 49 "recordings.ecpp"
    tnt::QueryParams _tnt_cq1(qparam, false);
#line 49 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "stylesheets"), request, reply, _tnt_cq1);
    // &>
  }
  reply.out() << data[2]; // \n\t\t
  // <& pageelems.ajax_js ...
  { 
#line 50 "recordings.ecpp"
    tnt::QueryParams _tnt_cq2(qparam, false);
#line 50 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_js"), request, reply, _tnt_cq2);
    // &>
  }
  reply.out() << data[3]; // \n\t\t<script type="text/javascript" src="treeview.js"></script>\n\t</head>\n\t<body>\n\t\t
  // <& pageelems.logo ...
  { 
#line 54 "recordings.ecpp"
    tnt::QueryParams _tnt_cq3(qparam, false);
#line 54 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "logo"), request, reply, _tnt_cq3);
    // &>
  }
  reply.out() << data[4]; // \n
#line 55 "recordings.ecpp"

if (! deleteResult.empty()) {

  reply.out() << data[5]; // \t\t
  // <& menu ...
  { 
#line 58 "recordings.ecpp"
    tnt::QueryParams _tnt_cq4(qparam, false);
#line 58 "recordings.ecpp"
    _tnt_cq4.add( "active", tnt::toString(("recordings"), reply.out().getloc() ) );
#line 58 "recordings.ecpp"
    _tnt_cq4.add( "component", tnt::toString(("recordings.delete_error"), reply.out().getloc() ) );
#line 58 "recordings.ecpp"
    callComp(tnt::Compident(std::string(), "menu"), request, reply, _tnt_cq4);
    // &>
  }
  reply.out() << data[6]; // \n
#line 59 "recordings.ecpp"

} else {

  reply.out() << data[7]; // \t\t
  // <& menu ...
  { 
#line 62 "recordings.ecpp"
    tnt::QueryParams _tnt_cq5(qparam, false);
#line 62 "recordings.ecpp"
    _tnt_cq5.add( "active", tnt::toString(("recordings"), reply.out().getloc() ) );
#line 62 "recordings.ecpp"
    callComp(tnt::Compident(std::string(), "menu"), request, reply, _tnt_cq5);
    // &>
  }
  reply.out() << data[8]; // \n
#line 63 "recordings.ecpp"

}

  reply.out() << data[9]; // \t\t<div class="inhalt">\n\t\t\t<div class="boxheader"><div><div>
#line 67 "recordings.ecpp"
  reply.sout() << ( tr("List of recordings") );
  reply.out() << data[10]; // </div></div></div>\n
#line 68 "recordings.ecpp"

			if (Recordings.Count() == 0) {

  reply.out() << data[11]; // \t\t\t
#line 71 "recordings.ecpp"
  reply.sout() << ( tr("No recordings found") );
  reply.out() << data[12]; // \n
#line 72 "recordings.ecpp"

			} else {

  reply.out() << data[13]; // \t\t\t<div class="recordings">\n\t\t\t<ul class="recordingslist" style="display: block;">\n
  // <& recordings.recordings_item ...
  { 
#line 77 "recordings.ecpp"
    tnt::QueryParams _tnt_cq6(qparam, false);
#line 77 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "recordings", "recordings_item"), request, reply, _tnt_cq6);
    // &>
  }
  reply.out() << data[14]; // \n\t\t\t</ul>\n\t\t\t</div>\n
#line 80 "recordings.ecpp"

			}

  reply.out() << data[15]; // \t\t</div>\n\t</body>\n</html>\n
  // <%include> page_exit.eh
  reply.out() << data[16]; // \n
#line 5 "page_exit.eh"

	spoint.commit();
} catch ( vdrlive::HtmlError const& ex ) {
#if TNTVERSION >= 1606
	tnt::QueryParams param = qparam;
#else
	cxxtools::QueryParams param = qparam;
#endif
	param.add( "pageTitle", pageTitle );
	param.add( "errorMessage", ex.what() );
	callComp( "error", request, reply, param );
}

  // </%include>
  reply.out() << data[17]; // \n
  reply.out() << data[18]; // \n\n
  reply.out() << data[25]; // \n
  reply.out() << data[26]; // \n\n
  reply.out() << data[31]; // \n
  reply.out() << data[32]; // \n\n
  reply.out() << data[36]; // \n
  reply.out() << data[37]; // \n\n
  reply.out() << data[42]; // \n
  reply.out() << data[43]; // \n\n
  reply.out() << data[49]; // \n
  reply.out() << data[50]; // \n\n
  reply.out() << data[78]; // \n
  reply.out() << data[79]; // \n\n
  // <%/cpp>
  return HTTP_OK;
}

unsigned _component_::recordings_item_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::recordings_item " << qparam.getUrl());
  tnt::DataChunks data(rawData);
  // <%args>
typedef std::vector<std::string> path_type;
path_type path;
std::copy(qparam.begin("path"), qparam.end(), std::back_inserter(path));
int level = qparam.has("level") ? tnt::stringToWithDefault<int>(qparam.param("level"), ( 0), reply.out().getloc()) : ( 0);
  // </%args>

#line 28 "recordings.ecpp"
  typedef string deleteResult_type;
  TNT_REQUEST_PAGE_VAR(deleteResult_type, deleteResult, "string deleteResult", ());   // <%request> string deleteResult
#line 25 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_GLOBAL_VAR(logged_in_type, logged_in, "bool logged_in", (false));   // <%session> bool logged_in(false)
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_GLOBAL_VAR(pageTitle_type, pageTitle, "std::string pageTitle", ());   // <%request> std::string pageTitle
  // <%cpp>
#line 95 "recordings.ecpp"

RecordingsTreePtr recordingsTree(LiveRecordingsManager()->GetRecordingsTree());
RecordingsMap::iterator iter;
RecordingsMap::iterator end = recordingsTree->end(path);

for (iter = recordingsTree->begin(path); iter != end; ++iter) {
	RecordingsItemPtr recItem = iter->second;
	string folderimg("folder_closed.png");
	string collapseimg("plus.png");
	if (recItem->IsDir()) {

  reply.out() << data[19]; // \t<li class="recording">\n\t\t
  // <& rec_item_dir ...
  { 
#line 107 "recordings.ecpp"
    tnt::QueryParams _tnt_cq7(qparam, false);
#line 107 "recordings.ecpp"
    _tnt_cq7.add( "level", tnt::toString((level), reply.out().getloc() ) );
#line 107 "recordings.ecpp"
    _tnt_cq7.add( "name", tnt::toString((recItem->Name()), reply.out().getloc() ) );
#line 107 "recordings.ecpp"
  main().rec_item_dir(request, reply, _tnt_cq7);
    // &>
  }
  reply.out() << data[20]; // \n
#line 108 "recordings.ecpp"

#if TNTVERSION >= 1606
		tnt::QueryParams recItemParams(qparam, false);
#else
		cxxtools::QueryParams recItemParams(qparam, false);
#endif
		for (path_type::const_iterator i = path.begin(); i != path.end(); ++i) {
			recItemParams.add("path", *i);
		}
		recItemParams.add("path", recItem->Name());
		recItemParams.add("level", lexical_cast<string, int>(level + 1));

  reply.out() << data[21]; // \t\t<ul class="recordingslist" style="display: none;">\n
#line 121 "recordings.ecpp"

		callComp("recordings.recordings_item", request, reply, recItemParams);

  reply.out() << data[22]; //     \t</ul>\n\t</li>\n
#line 126 "recordings.ecpp"

	}
}
for (iter = recordingsTree->begin(path); iter != end; ++iter) {
	RecordingsItemPtr recItem = iter->second;
    if (!recItem->IsDir()) {
		string day(FormatDateTime("%a,", recItem->StartTime()));
		string dayLen(lexical_cast<string, int>(day.length() - 1) + ".25em;");
		string duration(lexical_cast<string, int>(recItem->Duration()) + "'");
		string shortDescr(recItem->RecInfo()->ShortText() ? recItem->RecInfo()->ShortText() : "");
		string hint(tr("Click to view details.")); if (!shortDescr.empty()) hint = shortDescr + "<br />" + hint;

  reply.out() << data[23]; // \t<li class="recording">\n\t   
  // <& rec_item_file ...
  { 
#line 139 "recordings.ecpp"
    tnt::QueryParams _tnt_cq8(qparam, false);
#line 139 "recordings.ecpp"
    _tnt_cq8.add( "archived", tnt::toString((RecordingsManager::GetArchiveDescr(recItem->Recording())), reply.out().getloc() ) );
#line 139 "recordings.ecpp"
    _tnt_cq8.add( "day", tnt::toString((day), reply.out().getloc() ) );
#line 139 "recordings.ecpp"
    _tnt_cq8.add( "dayLen", tnt::toString((dayLen), reply.out().getloc() ) );
#line 139 "recordings.ecpp"
    _tnt_cq8.add( "duration", tnt::toString((duration), reply.out().getloc() ) );
#line 139 "recordings.ecpp"
    _tnt_cq8.add( "hint", tnt::toString((hint), reply.out().getloc() ) );
#line 139 "recordings.ecpp"
    _tnt_cq8.add( "id", tnt::toString((recItem->Id()), reply.out().getloc() ) );
#line 139 "recordings.ecpp"
    _tnt_cq8.add( "level", tnt::toString((level), reply.out().getloc() ) );
#line 139 "recordings.ecpp"
    _tnt_cq8.add( "name", tnt::toString((recItem->Name()), reply.out().getloc() ) );
#line 139 "recordings.ecpp"
    _tnt_cq8.add( "shortDescr", tnt::toString((shortDescr), reply.out().getloc() ) );
#line 139 "recordings.ecpp"
    _tnt_cq8.add( "startTime", tnt::toString((recItem->StartTime()), reply.out().getloc() ) );
#line 139 "recordings.ecpp"
  main().rec_item_file(request, reply, _tnt_cq8);
    // &>
  }
  reply.out() << data[24]; // \n    </li>\n
#line 141 "recordings.ecpp"

	}
}

  // <%/cpp>
  return HTTP_OK;
}

unsigned _component_::del_rec_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::del_rec " << qparam.getUrl());
  tnt::DataChunks data(rawData);
  // <%args>
string id = tnt::stringTo<string>("id", "string", qparam.param("id"), reply.out().getloc());
  // </%args>

#line 28 "recordings.ecpp"
  typedef string deleteResult_type;
  TNT_REQUEST_PAGE_VAR(deleteResult_type, deleteResult, "string deleteResult", ());   // <%request> string deleteResult
#line 25 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_GLOBAL_VAR(logged_in_type, logged_in, "bool logged_in", (false));   // <%session> bool logged_in(false)
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_GLOBAL_VAR(pageTitle_type, pageTitle, "std::string pageTitle", ());   // <%request> std::string pageTitle
  // <%cpp>
#line 153 "recordings.ecpp"
 { 
  reply.out() << data[27]; // <a href="recordings.html\?todel=
#line 153 "recordings.ecpp"
  reply.sout() << ( id );
  reply.out() << data[28]; // " 
  // <& tooltip.hint ...
  { 
#line 153 "recordings.ecpp"
    tnt::QueryParams _tnt_cq9(qparam, false);
#line 153 "recordings.ecpp"
    _tnt_cq9.add( "text", tnt::toString((tr("Delete this recording from hard disc!")), reply.out().getloc() ) );
#line 153 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq9);
    // &>
  }
  reply.out() << data[29]; // ><img src="
#line 153 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "del.png") );
  reply.out() << data[30]; // " alt="" /></a>
#line 153 "recordings.ecpp"
 } 
  // <%/cpp>
  return HTTP_OK;
}

unsigned _component_::rec_tools_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::rec_tools " << qparam.getUrl());
  tnt::DataChunks data(rawData);
  // <%args>
string id = tnt::stringTo<string>("id", "string", qparam.param("id"), reply.out().getloc());
string title = tnt::stringTo<string>("title", "string", qparam.param("title"), reply.out().getloc());
  // </%args>

#line 28 "recordings.ecpp"
  typedef string deleteResult_type;
  TNT_REQUEST_PAGE_VAR(deleteResult_type, deleteResult, "string deleteResult", ());   // <%request> string deleteResult
#line 25 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_GLOBAL_VAR(logged_in_type, logged_in, "bool logged_in", (false));   // <%session> bool logged_in(false)
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_GLOBAL_VAR(pageTitle_type, pageTitle, "std::string pageTitle", ());   // <%request> std::string pageTitle
  // <%cpp>
  // <& pageelems.ajax_action_href ...
  { 
#line 163 "recordings.ecpp"
    tnt::QueryParams _tnt_cq10(qparam, false);
#line 163 "recordings.ecpp"
    _tnt_cq10.add( "action", tnt::toString("play_recording", reply.out().getloc() ) );
#line 163 "recordings.ecpp"
    _tnt_cq10.add( "alt", tnt::toString("", reply.out().getloc() ) );
#line 163 "recordings.ecpp"
    _tnt_cq10.add( "image", tnt::toString("play.png", reply.out().getloc() ) );
#line 163 "recordings.ecpp"
    _tnt_cq10.add( "param", tnt::toString((id), reply.out().getloc() ) );
#line 163 "recordings.ecpp"
    _tnt_cq10.add( "tip", tnt::toString((tr("play this recording.")), reply.out().getloc() ) );
#line 163 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_action_href"), request, reply, _tnt_cq10);
    // &>
  }
  reply.out() << data[33]; // \n
  // <& pageelems.imdb_info_href ...
  { 
#line 164 "recordings.ecpp"
    tnt::QueryParams _tnt_cq11(qparam, false);
#line 164 "recordings.ecpp"
    _tnt_cq11.add( "title", tnt::toString((title), reply.out().getloc() ) );
#line 164 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "imdb_info_href"), request, reply, _tnt_cq11);
    // &>
  }
  reply.out() << data[34]; // \n
  // <& recordings.del_rec ...
  { 
#line 165 "recordings.ecpp"
    tnt::QueryParams _tnt_cq12(qparam, false);
#line 165 "recordings.ecpp"
    _tnt_cq12.add( "id", tnt::toString((id), reply.out().getloc() ) );
#line 165 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "recordings", "del_rec"), request, reply, _tnt_cq12);
    // &>
  }
  reply.out() << data[35]; // \n
  // <%/cpp>
  return HTTP_OK;
}

unsigned _component_::archived_disc_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::archived_disc " << qparam.getUrl());
  tnt::DataChunks data(rawData);
  // <%args>
string archived = tnt::stringTo<string>("archived", "string", qparam.param("archived"), reply.out().getloc());
string title = tnt::stringTo<string>("title", "string", qparam.param("title"), reply.out().getloc());
  // </%args>

#line 28 "recordings.ecpp"
  typedef string deleteResult_type;
  TNT_REQUEST_PAGE_VAR(deleteResult_type, deleteResult, "string deleteResult", ());   // <%request> string deleteResult
#line 25 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_GLOBAL_VAR(logged_in_type, logged_in, "bool logged_in", (false));   // <%session> bool logged_in(false)
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_GLOBAL_VAR(pageTitle_type, pageTitle, "std::string pageTitle", ());   // <%request> std::string pageTitle
  // <%cpp>
  reply.out() << data[38]; // <img src="
#line 175 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "on_dvd.png") );
  reply.out() << data[39]; // " alt="on_dvd" 
  // <& tooltip.hint ...
  { 
#line 175 "recordings.ecpp"
    tnt::QueryParams _tnt_cq13(qparam, false);
#line 175 "recordings.ecpp"
    _tnt_cq13.add( "text", tnt::toString((archived), reply.out().getloc() ) );
#line 175 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq13);
    // &>
  }
  reply.out() << data[40]; //  />\n
  // <& pageelems.imdb_info_href ...
  { 
#line 176 "recordings.ecpp"
    tnt::QueryParams _tnt_cq14(qparam, false);
#line 176 "recordings.ecpp"
    _tnt_cq14.add( "title", tnt::toString((title), reply.out().getloc() ) );
#line 176 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "imdb_info_href"), request, reply, _tnt_cq14);
    // &>
  }
  reply.out() << data[41]; // \n
  // <%/cpp>
  return HTTP_OK;
}

unsigned _component_::rec_item_dir_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::rec_item_dir " << qparam.getUrl());
  tnt::DataChunks data(rawData);
  // <%args>
string name = tnt::stringTo<string>("name", "string", qparam.param("name"), reply.out().getloc());
int level = tnt::stringTo<int>("level", "int", qparam.param("level"), reply.out().getloc());
string collapseimg = qparam.has("collapseimg") ? tnt::stringToWithDefault<string>(qparam.param("collapseimg"), ( "plus.png"), reply.out().getloc()) : ( "plus.png");
string folderimg = qparam.has("folderimg") ? tnt::stringToWithDefault<string>(qparam.param("folderimg"), ( "folder_closed.png"), reply.out().getloc()) : ( "folder_closed.png");
  // </%args>

#line 28 "recordings.ecpp"
  typedef string deleteResult_type;
  TNT_REQUEST_PAGE_VAR(deleteResult_type, deleteResult, "string deleteResult", ());   // <%request> string deleteResult
#line 25 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_GLOBAL_VAR(logged_in_type, logged_in, "bool logged_in", (false));   // <%session> bool logged_in(false)
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_GLOBAL_VAR(pageTitle_type, pageTitle, "std::string pageTitle", ());   // <%request> std::string pageTitle
  // <%cpp>
  reply.out() << data[44]; // \t<div class="recording_item" onclick="Toggle(this)">\n\t\t<div class="recording_imgs">
#line 189 "recordings.ecpp"
 reply.out() << StringRepeat(level, "<img src=\"/img/transparent.png\" alt=\"\" width=\"16px\" height=\"16px\" />"); 
  reply.out() << data[45]; // <img class="recording_expander" src="
#line 189 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", collapseimg) );
  reply.out() << data[46]; // " alt="" /><img class="recording_folder" src="
#line 189 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", folderimg) );
  reply.out() << data[47]; // " alt="" /></div>\n\t\t<div class="recording_spec">\n\t\t\t<div class="recording_name">
#line 191 "recordings.ecpp"
  reply.sout() << ( name );
  reply.out() << data[48]; // </div>\n\t    </div>\n\t\t<div class="recording_actions">&nbsp;</div>\n\t</div>\n
  // <%/cpp>
  return HTTP_OK;
}

unsigned _component_::rec_item_file_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::rec_item_file " << qparam.getUrl());
  tnt::DataChunks data(rawData);
  // <%args>
string name = tnt::stringTo<string>("name", "string", qparam.param("name"), reply.out().getloc());
int level = tnt::stringTo<int>("level", "int", qparam.param("level"), reply.out().getloc());
string id = tnt::stringTo<string>("id", "string", qparam.param("id"), reply.out().getloc());
string day = tnt::stringTo<string>("day", "string", qparam.param("day"), reply.out().getloc());
string dayLen = tnt::stringTo<string>("dayLen", "string", qparam.param("dayLen"), reply.out().getloc());
time_t startTime = tnt::stringTo<time_t>("startTime", "time_t", qparam.param("startTime"), reply.out().getloc());
string duration = tnt::stringTo<string>("duration", "string", qparam.param("duration"), reply.out().getloc());
string hint = tnt::stringTo<string>("hint", "string", qparam.param("hint"), reply.out().getloc());
string shortDescr = tnt::stringTo<string>("shortDescr", "string", qparam.param("shortDescr"), reply.out().getloc());
string archived = tnt::stringTo<string>("archived", "string", qparam.param("archived"), reply.out().getloc());
  // </%args>

#line 28 "recordings.ecpp"
  typedef string deleteResult_type;
  TNT_REQUEST_PAGE_VAR(deleteResult_type, deleteResult, "string deleteResult", ());   // <%request> string deleteResult
#line 25 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_GLOBAL_VAR(logged_in_type, logged_in, "bool logged_in", (false));   // <%session> bool logged_in(false)
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_GLOBAL_VAR(pageTitle_type, pageTitle, "std::string pageTitle", ());   // <%request> std::string pageTitle
  // <%cpp>
  reply.out() << data[51]; // \t<div class="recording_item">\n\t<div class="recording_imgs">
#line 213 "recordings.ecpp"
 reply.out() << StringRepeat(level + 1, "<img src=\"/img/transparent.png\" alt=\"\" width=\"16px\" height=\"16px\" />"); 
#line 213 "recordings.ecpp"
 if (!archived.empty()) { 
  reply.out() << data[52]; // <img src="
#line 213 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "on_dvd.png") );
  reply.out() << data[53]; // " alt="on_dvd" 
  // <& tooltip.hint ...
  { 
#line 213 "recordings.ecpp"
    tnt::QueryParams _tnt_cq15(qparam, false);
#line 213 "recordings.ecpp"
    _tnt_cq15.add( "text", tnt::toString((archived), reply.out().getloc() ) );
#line 213 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq15);
    // &>
  }
  reply.out() << data[54]; //  />
#line 213 "recordings.ecpp"
 } else { 
  reply.out() << data[55]; // <img src="
#line 213 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "movie.png") );
  reply.out() << data[56]; // " alt="movie" />
#line 213 "recordings.ecpp"
 } 
  reply.out() << data[57]; // </div>\n\t<div class="recording_spec">\n\t\t<div class="recording_day" style="width: 
#line 215 "recordings.ecpp"
  reply.sout() << ( dayLen );
  reply.out() << data[58]; // ">
#line 215 "recordings.ecpp"
  reply.sout() << ( day );
  reply.out() << data[59]; // </div>\n\t\t<div class="recording_date">
#line 216 "recordings.ecpp"
  reply.sout() << ( FormatDateTime(tr("%b %d %y"), startTime) );
  reply.out() << data[60]; // </div>\n\t\t<div class="recording_time">
#line 217 "recordings.ecpp"
  reply.sout() << ( FormatDateTime(tr("%I:%M %p"), startTime) );
  reply.out() << data[61]; // </div>\n\t\t<div class="recording_duration">
#line 218 "recordings.ecpp"
  reply.sout() << ( duration );
  reply.out() << data[62]; // </div>\n\t\t<div class="recording_name"><a 
  // <& tooltip.hint ...
  { 
#line 219 "recordings.ecpp"
    tnt::QueryParams _tnt_cq16(qparam, false);
#line 219 "recordings.ecpp"
    _tnt_cq16.add( "text", tnt::toString((hint), reply.out().getloc() ) );
#line 219 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq16);
    // &>
  }
  // <& tooltip.display ...
  { 
#line 219 "recordings.ecpp"
    tnt::QueryParams _tnt_cq17(qparam, false);
#line 219 "recordings.ecpp"
    _tnt_cq17.add( "domId", tnt::toString((id), reply.out().getloc() ) );
#line 219 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "display"), request, reply, _tnt_cq17);
    // &>
  }
  reply.out() << data[63]; // >
#line 219 "recordings.ecpp"
  reply.sout() << ( name );
  reply.out() << data[64]; // <br />
#line 219 "recordings.ecpp"
if ((name != shortDescr) && (!shortDescr.empty())) {
  reply.out() << data[65]; // <span>
#line 219 "recordings.ecpp"
  reply.sout() << ( shortDescr );
  reply.out() << data[66]; // </span>
#line 219 "recordings.ecpp"
 } else { 
  reply.out() << data[67]; // <span>&nbsp;</span>
#line 219 "recordings.ecpp"
 } 
  reply.out() << data[68]; // </a></div>\n\t</div>\n\t<div class="recording_actions">\n
#line 222 "recordings.ecpp"

		if (archived.empty()) {

  reply.out() << data[69]; // \t\t
  // <& recordings.rec_tools ...
  { 
#line 225 "recordings.ecpp"
    tnt::QueryParams _tnt_cq18(qparam, false);
#line 225 "recordings.ecpp"
    _tnt_cq18.add( "id", tnt::toString((id), reply.out().getloc() ) );
#line 225 "recordings.ecpp"
    _tnt_cq18.add( "title", tnt::toString((name), reply.out().getloc() ) );
#line 225 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "recordings", "rec_tools"), request, reply, _tnt_cq18);
    // &>
  }
  reply.out() << data[70]; // \n
#line 226 "recordings.ecpp"

	    }
		else {

  reply.out() << data[71]; // \t\t<img src="/img/transparent.png" alt="" width="16px" height="16px" />\n\t\t
  // <& pageelems.imdb_info_href ...
  { 
#line 231 "recordings.ecpp"
    tnt::QueryParams _tnt_cq19(qparam, false);
#line 231 "recordings.ecpp"
    _tnt_cq19.add( "title", tnt::toString((name), reply.out().getloc() ) );
#line 231 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "imdb_info_href"), request, reply, _tnt_cq19);
    // &>
  }
  reply.out() << data[72]; // \n
#line 232 "recordings.ecpp"

		}

  reply.out() << data[73]; // \t\t<!-- not supported yet ...\n\t\t<img src="
#line 236 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "edit.png") );
  reply.out() << data[74]; // " alt="" />\n        -->\n\t</div>\n
#line 239 "recordings.ecpp"

	if (! archived.empty()) {

  reply.out() << data[75]; // \t<div class="recording_arch">
#line 242 "recordings.ecpp"
  reply.sout() << ( archived );
  reply.out() << data[76]; // </div>\n
#line 243 "recordings.ecpp"

	}

  reply.out() << data[77]; // \t</div>\n
  // <%/cpp>
  return HTTP_OK;
}

unsigned _component_::delete_error_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::delete_error " << qparam.getUrl());
  tnt::DataChunks data(rawData);
  // <%args>
  // </%args>

#line 28 "recordings.ecpp"
  typedef string deleteResult_type;
  TNT_REQUEST_PAGE_VAR(deleteResult_type, deleteResult, "string deleteResult", ());   // <%request> string deleteResult
#line 25 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_GLOBAL_VAR(logged_in_type, logged_in, "bool logged_in", (false));   // <%session> bool logged_in(false)
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_GLOBAL_VAR(pageTitle_type, pageTitle, "std::string pageTitle", ());   // <%request> std::string pageTitle
  // <%cpp>
#line 252 "recordings.ecpp"
 { 
#line 252 "recordings.ecpp"
  reply.sout() << ( deleteResult );
#line 252 "recordings.ecpp"
 } 
  // <%/cpp>
  return HTTP_OK;
}

} // namespace
