////////////////////////////////////////////////////////////////////////
// remote.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/convert.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.remote")

// <%pre>
#line 1 "remote.ecpp"

#include <locale>
#include <vdr/i18n.h>
#include <vdr/keys.h>
#include "grab.h"
#include "setup.h"
#include "tools.h"

using namespace std;
using namespace vdrlive;


#line 1 "page_init.eh"

// do not add to Makefile
// and do not write a ecpp comment into this file. It must produce no
// html output not even a empty line.
#include <tnt/savepoint.h>
#include "exception.h"

#line 2 "page_exit.eh"

#include "exception.h"

// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    class remote_actions_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        remote_actions_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    remote_actions_type remote_actions;
};

static tnt::ComponentFactoryImpl<_component_> Factory("remote");

static const char* rawData = "\264\000\000\000\265\000\000\000\331\000\000\000\344\000\000\000\347\000\000\000Z\005\000"
  "\000\226\005\000\000\321\005\000\000\324\005\000\000\010\006\000\000\024\006\000\000L\006\000\000m\006\000\000#\007"
  "\000\000\221\007\000\000\377\007\000\000o\010\000\000\335\010\000\000K\t\000\000\273\t\000\000,\n\000\000\234\n\000"
  "\000\016\013\000\000~\013\000\000\357\013\000\000`\014\000\000\320\014\000\000@\015\000\000\260\015\000\000#\016\000"
  "\000\271\016\000\000^\017\000\000\017\020\000\000\315\020\000\000\201\021\000\000,\022\000\000\233\022\000\000\015"
  "\023\000\000\201\023\000\000\367\023\000\000l\024\000\000\274\024\000\000\275\024\000\000\276\024\000\000\376\024\000"
  "\000\n\n<html>\n\t<head>\n\t\t<title>VDR-Live - </title>\n\t\t\n\t\t\n\t\t<script type=\"text/javascript\"><!--\n\t\t"
  "var newImg = new Image();\n\t\tvar imgsrc = \"\";\n\t\tvar interval = -1;\n\n\t\tfunction StreamLoad()\n\t\t{\n\t\t\t"
  "uniq = new Date();\n\t\t\tuniq = uniq.getTime();\n\t\t\tdocument.images.vdrlive.src=newImg.src;\n\t\t\tnewImg.src=img"
  "src+\"\?\"+uniq;\n\t\t}\n\n\t\tfunction StreamInit()\n\t\t{\n\t\t\timgsrc = document.images.vdrlive.src;\n\t\t\tuniq "
  "= new Date();\n\t\t\tuniq = uniq.getTime();\n\t\t\tnewImg.src=imgsrc+\"\?\"+uniq;\n\t\t\tinterval = window.setInterva"
  "l(\"StreamLoad()\", 1000);\n\t\t}\n\n\t\tfunction ChangeInterval()\n\t\t{\n\t\t\tvar element = document.getElementsBy"
  "Name('interval').item(0);\n\t\t\tvar timeout = element.value;\n\t\t\twindow.clearInterval(interval);\n\t\t\tinterval "
  "= window.setInterval(\"StreamLoad()\", timeout);\n\t\t}\n\n\t\tfunction KeyPress(keycode)\n\t\t{\n\t\t\tLiveSimpleAja"
  "xRequest('keypress.xml', 'keycode', keycode);\n\t\t}\n\n\t\tfunction FillIntervals()\n\t\t{\n\t\t\tvar element = docu"
  "ment.getElementsByName('interval').item(0);\n\t\t\tvar items = new Array(1000, 2000, 5000);\n\t\t\telement.options.le"
  "ngth = items.length;\n\t\t\tfor (i = 0; i < items.length; ++i) {\n\t\t\t\telement.options[i].value = items[i];\n\t\t"
  "\t\telement.options[i].text = (items[i] / 1000) + \" s\";\n\t\t\t\tif (items[i] == )\n\t\t\t\t\telement.selectedIndex"
  " = i;\n\t\t\t}\n\t\t}\n\t\t//--></script>\n\t</head>\n\t<body onload=\"StreamInit(); FillIntervals();\">\n\t\t\n\t\t"
  "\n\t\t<div class=\"inhalt\">\n\t\t\t<div class=\"screenshot\">\n\n\t\t\t\t\tbloek\n\n\t\t\t\t\t<img src=\"screenshot."
  "jpg\" name=\"vdrlive\" /><br />\n\n\t\t\t</div>\n\t\t\t<div>\n\t\t\t<img src=\"\" width=\"162\" height=\"363\" border"
  "=\"0\" usemap=\"#remote\" alt=\"\" />\n\t\t\t     <map name=\"remote\">\n\t\t\t     \t  <area href=\"#\" shape=\"circ"
  "le\" coords=\"37,36,10\" alt=\"Power\" onclick=\"KeyPress()\" nohref=\"nohref\" alt=\"\" />\n\t\t\t\t  <area href=\"#"
  "\" shape=\"rect\" coords=\"27,60,59,75\" alt=\"1\" onclick=\"KeyPress()\" nohref=\"nohref\" alt=\"\" />\n\t\t\t\t  <a"
  "rea href=\"#\" shape=\"rect\" coords=\"64,59,98,75\" alt=\"2\" onclick=\"KeyPress()\" nohref=\"nohref\" alt=\"\" />\n"
  "\t\t\t\t  <area href=\"#\" shape=\"rect\" coords=\"103,59,137,75\" alt=\"3\" onclick=\"KeyPress()\" nohref=\"nohref\""
  " alt=\"\" />\n\t\t\t\t  <area href=\"#\" shape=\"rect\" coords=\"25,82,60,98\" alt=\"4\" onclick=\"KeyPress()\" nohre"
  "f=\"nohref\" alt=\"\" />\n\t\t\t\t  <area href=\"#\" shape=\"rect\" coords=\"65,82,98,99\" alt=\"5\" onclick=\"KeyPre"
  "ss()\" nohref=\"nohref\" alt=\"\" />\n\t\t\t\t  <area href=\"#\" shape=\"rect\" coords=\"103,83,137,99\" alt=\"6\" on"
  "click=\"KeyPress()\" nohref=\"nohref\" alt=\"\" />\n\t\t\t\t  <area href=\"#\" shape=\"rect\" coords=\"26,106,60,121"
  "\" alt=\"7\"  onclick=\"KeyPress()\" nohref=\"nohref\" alt=\"\" />\n\t\t\t\t  <area href=\"#\" shape=\"rect\" coords="
  "\"65,105,97,121\" alt=\"8\" onclick=\"KeyPress()\" nohref=\"nohref\" alt=\"\" />\n\t\t\t\t  <area href=\"#\" shape=\""
  "rect\" coords=\"104,106,137,122\" alt=\"9\" onclick=\"KeyPress()\" nohref=\"nohref\" alt=\"\" />\n\t\t\t\t  <area hre"
  "f=\"#\" shape=\"rect\" coords=\"66,128,98,144\" alt=\"0\" onclick=\"KeyPress()\" nohref=\"nohref\" alt=\"\" />\n\t\t"
  "\t\t  <area href=\"#\" shape=\"circle\" coords=\"37,157,13\" alt=\"Vol+\" onclick=\"KeyPress()\" nohref=\"nohref\" al"
  "t=\"\" />\n\t\t\t\t  <area href=\"#\" shape=\"circle\" coords=\"37,190,13\" alt=\"Vol-\" onclick=\"KeyPress()\" nohre"
  "f=\"nohref\" alt=\"\" />\n\t\t\t\t  <area href=\"#\" shape=\"circle\" coords=\"125,157,13\" alt=\"P+\" onclick=\"KeyP"
  "ress()\" nohref=\"nohref\" alt=\"\" />\n\t\t\t\t  <area href=\"#\" shape=\"circle\" coords=\"125,190,13\" alt=\"P-\" "
  "onclick=\"KeyPress()\" nohref=\"nohref\" alt=\"\" />\n\t\t\t\t  <area href=\"#\" shape=\"circle\" coords=\"81,174,8\""
  " alt=\"Mute\" onclick=\"KeyPress()\" nohref=\"nohref\" alt=\"\" />\n\t\t\t\t  <area href=\"#\" shape=\"circle\" coord"
  "s=\"81,202,11\" alt=\"Record\" onclick=\"KeyPress()\" nohref=\"nohref\" alt=\"\" />\n\t\t\t\t  <area href=\"#\" shape"
  "=\"poly\" coords=\"39,215,29,227,30,235,39,236,51,222,49,215,43,213\" alt=\"Menu\" onclick=\"KeyPress()\" nohref=\"no"
  "href\" alt=\"\" />\n\t\t\t\t  <area href=\"#\" shape=\"poly\" coords=\"119,213,127,219,135,230,132,235,127,236,119,23"
  "1,114,223,113,215\" alt=\"Exit\" onclick=\"KeyPress()\" nohref=\"nohref\" alt=\"\" />\n\t\t\t\t  <area href=\"#\" sha"
  "pe=\"poly\" coords=\"58,230,70,223,82,223,91,223,105,231,96,240,87,237,78,236,69,240,66,241,58,232\" alt=\"Up\" oncli"
  "ck=\"KeyPress()\" nohref=\"nohref\" alt=\"\" />\n\t\t\t\t  <area href=\"#\" shape=\"poly\" coords=\"111,237,119,249,1"
  "21,259,119,275,113,285,109,284,101,276,104,270,107,260,106,253,101,245\" alt=\"Right\" onclick=\"KeyPress()\" nohref="
  "\"nohref\" alt=\"\" />\n\t\t\t\t  <area href=\"#\" shape=\"poly\" coords=\"66,281,75,285,86,285,95,281,106,291,100,29"
  "5,87,300,73,300,58,291,57,289,58,289\" alt=\"Down\" onclick=\"KeyPress()\" nohref=\"nohref\" alt=\"\" />\n\t\t\t\t  <"
  "area href=\"#\" shape=\"poly\" coords=\"51,236,61,245,56,256,57,266,61,277,52,285,47,278,42,264,43,252,49,240\" alt="
  "\"Left\" onclick=\"KeyPress()\" nohref=\"nohref\" alt=\"\" />\n\t\t\t\t  <area href=\"#\" shape=\"circle\" coords=\"8"
  "1,261,17\" alt=\"Ok\" onclick=\"KeyPress()\" nohref=\"nohref\" alt=\"\" />\n\t\t\t\t  <area href=\"#\" shape=\"rect\""
  " coords=\"25,309,52,324\" alt=\"Red\" onclick=\"KeyPress()\" nohref=\"nohref\" alt=\"\" />\n\t\t\t\t  <area href=\"#"
  "\" shape=\"rect\" coords=\"53,309,81,324\" alt=\"Green\" onclick=\"KeyPress()\" nohref=\"nohref\" alt=\"\" />\n\t\t\t"
  "\t  <area href=\"#\" shape=\"rect\" coords=\"83,309,109,324\" alt=\"Yellow\" onclick=\"KeyPress()\" nohref=\"nohref\""
  " alt=\"\" />\n\t\t\t\t  <area href=\"#\" shape=\"rect\" coords=\"110,310,137,323\" alt=\"Blue\" onclick=\"KeyPress()"
  "\" nohref=\"nohref\" alt=\"\" />\n\t\t\t     </map>\n\t\t\t</div>\n\t\t</div>\n\t</body>\n</html>\n\n\n: <select name"
  "=\"interval\" onchange=\"ChangeInterval()\"></select>\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

#define SET_LANG(lang) \
     do \
     { \
       request.setLang(lang); \
       reply.setLocale(request.getLocale()); \
     } while (false)

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl),
    remote_actions(*this, "remote_actions")
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("remote " << qparam.getUrl());

  tnt::DataChunks data(rawData);

  // <%args>
  // </%args>

#line 14 "remote.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_GLOBAL_VAR(logged_in_type, logged_in, "bool logged_in", (false));   // <%session> bool logged_in(false)
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_GLOBAL_VAR(pageTitle_type, pageTitle, "std::string pageTitle", ());   // <%request> std::string pageTitle
  // <%cpp>
  // <%include> page_init.eh
#line 11 "page_init.eh"

try {
	reply.setHeader("Expires", "Mon, 26 Jul 1997 05:00:00 GMT");
	tnt::Savepoint spoint( reply );

  // </%include>
#line 17 "remote.ecpp"

if (!logged_in && LiveSetup().UseAuth()) return reply.redirect("login.html");

  reply.out() << data[0]; // \n
#line 20 "remote.ecpp"

	pageTitle = tr("Remote Control");


  // <& pageelems.doc_type ...
  { 
#line 24 "remote.ecpp"
    tnt::QueryParams _tnt_cq0(qparam, false);
#line 24 "remote.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "doc_type"), request, reply, _tnt_cq0);
    // &>
  }
  reply.out() << data[1]; // \n<html>\n\t<head>\n\t\t<title>VDR-Live - 
#line 27 "remote.ecpp"
  reply.sout() << ( pageTitle );
  reply.out() << data[2]; // </title>\n\t\t
  // <& pageelems.stylesheets ...
  { 
#line 28 "remote.ecpp"
    tnt::QueryParams _tnt_cq1(qparam, false);
#line 28 "remote.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "stylesheets"), request, reply, _tnt_cq1);
    // &>
  }
  reply.out() << data[3]; // \n\t\t
  // <& pageelems.ajax_js ...
  { 
#line 29 "remote.ecpp"
    tnt::QueryParams _tnt_cq2(qparam, false);
#line 29 "remote.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_js"), request, reply, _tnt_cq2);
    // &>
  }
  reply.out() << data[4]; // \n\t\t<script type="text/javascript"><!--\n\t\tvar newImg = new Image();\n\t\tvar imgsrc = "";\n\t\tvar interval = -1;\n\n\t\tfunction StreamLoad()\n\t\t{\n\t\t\tuniq = new Date();\n\t\t\tuniq = uniq.getTime();\n\t\t\tdocument.images.vdrlive.src=newImg.src;\n\t\t\tnewImg.src=imgsrc+"\?"+uniq;\n\t\t}\n\n\t\tfunction StreamInit()\n\t\t{\n\t\t\timgsrc = document.images.vdrlive.src;\n\t\t\tuniq = new Date();\n\t\t\tuniq = uniq.getTime();\n\t\t\tnewImg.src=imgsrc+"\?"+uniq;\n\t\t\tinterval = window.setInterval("StreamLoad()", 1000);\n\t\t}\n\n\t\tfunction ChangeInterval()\n\t\t{\n\t\t\tvar element = document.getElementsByName('interval').item(0);\n\t\t\tvar timeout = element.value;\n\t\t\twindow.clearInterval(interval);\n\t\t\tinterval = window.setInterval("StreamLoad()", timeout);\n\t\t}\n\n\t\tfunction KeyPress(keycode)\n\t\t{\n\t\t\tLiveSimpleAjaxRequest('keypress.xml', 'keycode', keycode);\n\t\t}\n\n\t\tfunction FillIntervals()\n\t\t{\n\t\t\tvar element = document.getElementsByName('interval').item(0);\n\t\t\tvar items = new Array(1000, 2000, 5000);\n\t\t\telement.options.length = items.length;\n\t\t\tfor (i = 0; i < items.length; ++i) {\n\t\t\t\telement.options[i].value = items[i];\n\t\t\t\telement.options[i].text = (items[i] / 1000) + " s";\n\t\t\t\tif (items[i] == 
#line 73 "remote.ecpp"
  reply.sout() << ( ConvertToString( LiveSetup().GetScreenshotInterval(), locale("C") ) );
  reply.out() << data[5]; // )\n\t\t\t\t\telement.selectedIndex = i;\n\t\t\t}\n\t\t}\n\t\t//--></script>\n
#line 78 "remote.ecpp"
 reply.sout().imbue(locale());

  reply.out() << data[6]; // \t</head>\n\t<body onload="StreamInit(); FillIntervals();">\n\t\t
  // <& pageelems.logo ...
  { 
#line 81 "remote.ecpp"
    tnt::QueryParams _tnt_cq3(qparam, false);
#line 81 "remote.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "logo"), request, reply, _tnt_cq3);
    // &>
  }
  reply.out() << data[7]; // \n\t\t
  // <& menu ...
  { 
#line 82 "remote.ecpp"
    tnt::QueryParams _tnt_cq4(qparam, false);
#line 82 "remote.ecpp"
    _tnt_cq4.add( "active", tnt::toString("remote", reply.out().getloc() ) );
#line 82 "remote.ecpp"
    _tnt_cq4.add( "component", tnt::toString(("remote.remote_actions"), reply.out().getloc() ) );
#line 82 "remote.ecpp"
    callComp(tnt::Compident(std::string(), "menu"), request, reply, _tnt_cq4);
    // &>
  }
  reply.out() << data[8]; // \n\t\t<div class="inhalt">\n\t\t\t<div class="screenshot">\n
#line 85 "remote.ecpp"
				if (!LiveGrabImageManager().CanGrab()) {	
  reply.out() << data[9]; // \n\t\t\t\t\tbloek\n
#line 87 "remote.ecpp"
				} else {									
  reply.out() << data[10]; // \n\t\t\t\t\t<img src="screenshot.jpg" name="vdrlive" /><br />\n
#line 89 "remote.ecpp"
				}											
  reply.out() << data[11]; // \n\t\t\t</div>\n\t\t\t<div>\n\t\t\t<img src="
#line 92 "remote.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "remotecontrol.jpg") );
  reply.out() << data[12]; // " width="162" height="363" border="0" usemap="#remote" alt="" />\n\t\t\t     <map name="remote">\n\t\t\t     \t  <area href="#" shape="circle" coords="37,36,10" alt="Power" onclick="KeyPress(
#line 94 "remote.ecpp"
  reply.sout() << ( kPower );
  reply.out() << data[13]; // )" nohref="nohref" alt="" />\n\t\t\t\t  <area href="#" shape="rect" coords="27,60,59,75" alt="1" onclick="KeyPress(
#line 95 "remote.ecpp"
  reply.sout() << ( k1 );
  reply.out() << data[14]; // )" nohref="nohref" alt="" />\n\t\t\t\t  <area href="#" shape="rect" coords="64,59,98,75" alt="2" onclick="KeyPress(
#line 96 "remote.ecpp"
  reply.sout() << ( k2 );
  reply.out() << data[15]; // )" nohref="nohref" alt="" />\n\t\t\t\t  <area href="#" shape="rect" coords="103,59,137,75" alt="3" onclick="KeyPress(
#line 97 "remote.ecpp"
  reply.sout() << ( k3 );
  reply.out() << data[16]; // )" nohref="nohref" alt="" />\n\t\t\t\t  <area href="#" shape="rect" coords="25,82,60,98" alt="4" onclick="KeyPress(
#line 98 "remote.ecpp"
  reply.sout() << ( k4 );
  reply.out() << data[17]; // )" nohref="nohref" alt="" />\n\t\t\t\t  <area href="#" shape="rect" coords="65,82,98,99" alt="5" onclick="KeyPress(
#line 99 "remote.ecpp"
  reply.sout() << ( k5 );
  reply.out() << data[18]; // )" nohref="nohref" alt="" />\n\t\t\t\t  <area href="#" shape="rect" coords="103,83,137,99" alt="6" onclick="KeyPress(
#line 100 "remote.ecpp"
  reply.sout() << ( k6 );
  reply.out() << data[19]; // )" nohref="nohref" alt="" />\n\t\t\t\t  <area href="#" shape="rect" coords="26,106,60,121" alt="7"  onclick="KeyPress(
#line 101 "remote.ecpp"
  reply.sout() << ( k7 );
  reply.out() << data[20]; // )" nohref="nohref" alt="" />\n\t\t\t\t  <area href="#" shape="rect" coords="65,105,97,121" alt="8" onclick="KeyPress(
#line 102 "remote.ecpp"
  reply.sout() << ( k8 );
  reply.out() << data[21]; // )" nohref="nohref" alt="" />\n\t\t\t\t  <area href="#" shape="rect" coords="104,106,137,122" alt="9" onclick="KeyPress(
#line 103 "remote.ecpp"
  reply.sout() << ( k9 );
  reply.out() << data[22]; // )" nohref="nohref" alt="" />\n\t\t\t\t  <area href="#" shape="rect" coords="66,128,98,144" alt="0" onclick="KeyPress(
#line 104 "remote.ecpp"
  reply.sout() << ( k0 );
  reply.out() << data[23]; // )" nohref="nohref" alt="" />\n\t\t\t\t  <area href="#" shape="circle" coords="37,157,13" alt="Vol+" onclick="KeyPress(
#line 105 "remote.ecpp"
  reply.sout() << ( kVolUp );
  reply.out() << data[24]; // )" nohref="nohref" alt="" />\n\t\t\t\t  <area href="#" shape="circle" coords="37,190,13" alt="Vol-" onclick="KeyPress(
#line 106 "remote.ecpp"
  reply.sout() << ( kVolDn );
  reply.out() << data[25]; // )" nohref="nohref" alt="" />\n\t\t\t\t  <area href="#" shape="circle" coords="125,157,13" alt="P+" onclick="KeyPress(
#line 107 "remote.ecpp"
  reply.sout() << ( kChanUp );
  reply.out() << data[26]; // )" nohref="nohref" alt="" />\n\t\t\t\t  <area href="#" shape="circle" coords="125,190,13" alt="P-" onclick="KeyPress(
#line 108 "remote.ecpp"
  reply.sout() << ( kChanDn );
  reply.out() << data[27]; // )" nohref="nohref" alt="" />\n\t\t\t\t  <area href="#" shape="circle" coords="81,174,8" alt="Mute" onclick="KeyPress(
#line 109 "remote.ecpp"
  reply.sout() << ( kMute );
  reply.out() << data[28]; // )" nohref="nohref" alt="" />\n\t\t\t\t  <area href="#" shape="circle" coords="81,202,11" alt="Record" onclick="KeyPress(
#line 110 "remote.ecpp"
  reply.sout() << ( kRecord );
  reply.out() << data[29]; // )" nohref="nohref" alt="" />\n\t\t\t\t  <area href="#" shape="poly" coords="39,215,29,227,30,235,39,236,51,222,49,215,43,213" alt="Menu" onclick="KeyPress(
#line 111 "remote.ecpp"
  reply.sout() << ( kMenu );
  reply.out() << data[30]; // )" nohref="nohref" alt="" />\n\t\t\t\t  <area href="#" shape="poly" coords="119,213,127,219,135,230,132,235,127,236,119,231,114,223,113,215" alt="Exit" onclick="KeyPress(
#line 112 "remote.ecpp"
  reply.sout() << ( kBack );
  reply.out() << data[31]; // )" nohref="nohref" alt="" />\n\t\t\t\t  <area href="#" shape="poly" coords="58,230,70,223,82,223,91,223,105,231,96,240,87,237,78,236,69,240,66,241,58,232" alt="Up" onclick="KeyPress(
#line 113 "remote.ecpp"
  reply.sout() << ( kUp );
  reply.out() << data[32]; // )" nohref="nohref" alt="" />\n\t\t\t\t  <area href="#" shape="poly" coords="111,237,119,249,121,259,119,275,113,285,109,284,101,276,104,270,107,260,106,253,101,245" alt="Right" onclick="KeyPress(
#line 114 "remote.ecpp"
  reply.sout() << ( kRight );
  reply.out() << data[33]; // )" nohref="nohref" alt="" />\n\t\t\t\t  <area href="#" shape="poly" coords="66,281,75,285,86,285,95,281,106,291,100,295,87,300,73,300,58,291,57,289,58,289" alt="Down" onclick="KeyPress(
#line 115 "remote.ecpp"
  reply.sout() << ( kDown );
  reply.out() << data[34]; // )" nohref="nohref" alt="" />\n\t\t\t\t  <area href="#" shape="poly" coords="51,236,61,245,56,256,57,266,61,277,52,285,47,278,42,264,43,252,49,240" alt="Left" onclick="KeyPress(
#line 116 "remote.ecpp"
  reply.sout() << ( kLeft );
  reply.out() << data[35]; // )" nohref="nohref" alt="" />\n\t\t\t\t  <area href="#" shape="circle" coords="81,261,17" alt="Ok" onclick="KeyPress(
#line 117 "remote.ecpp"
  reply.sout() << ( kOk );
  reply.out() << data[36]; // )" nohref="nohref" alt="" />\n\t\t\t\t  <area href="#" shape="rect" coords="25,309,52,324" alt="Red" onclick="KeyPress(
#line 118 "remote.ecpp"
  reply.sout() << ( kRed );
  reply.out() << data[37]; // )" nohref="nohref" alt="" />\n\t\t\t\t  <area href="#" shape="rect" coords="53,309,81,324" alt="Green" onclick="KeyPress(
#line 119 "remote.ecpp"
  reply.sout() << ( kGreen );
  reply.out() << data[38]; // )" nohref="nohref" alt="" />\n\t\t\t\t  <area href="#" shape="rect" coords="83,309,109,324" alt="Yellow" onclick="KeyPress(
#line 120 "remote.ecpp"
  reply.sout() << ( kYellow );
  reply.out() << data[39]; // )" nohref="nohref" alt="" />\n\t\t\t\t  <area href="#" shape="rect" coords="110,310,137,323" alt="Blue" onclick="KeyPress(
#line 121 "remote.ecpp"
  reply.sout() << ( kBlue );
  reply.out() << data[40]; // )" nohref="nohref" alt="" />\n\t\t\t     </map>\n\t\t\t</div>\n\t\t</div>\n\t</body>\n</html>\n
  // <%include> page_exit.eh
  reply.out() << data[41]; // \n
#line 5 "page_exit.eh"

	spoint.commit();
} catch ( vdrlive::HtmlError const& ex ) {
#if TNTVERSION >= 1606
	tnt::QueryParams param = qparam;
#else
	cxxtools::QueryParams param = qparam;
#endif
	param.add( "pageTitle", pageTitle );
	param.add( "errorMessage", ex.what() );
	callComp( "error", request, reply, param );
}

  // </%include>
  reply.out() << data[42]; // \n
  // <%/cpp>
  return HTTP_OK;
}

unsigned _component_::remote_actions_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("remote::remote_actions " << qparam.getUrl());
  tnt::DataChunks data(rawData);
  // <%args>
  // </%args>

#line 14 "remote.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_GLOBAL_VAR(logged_in_type, logged_in, "bool logged_in", (false));   // <%session> bool logged_in(false)
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_GLOBAL_VAR(pageTitle_type, pageTitle, "std::string pageTitle", ());   // <%request> std::string pageTitle
  // <%cpp>
#line 130 "remote.ecpp"
  reply.sout() << ( tr("Interval") );
  reply.out() << data[43]; // : <select name="interval" onchange="ChangeInterval()"></select>\n
  // <%/cpp>
  return HTTP_OK;
}

} // namespace
