////////////////////////////////////////////////////////////////////////
// schedule.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/convert.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.schedule")

// <%pre>
#line 1 "schedule.ecpp"

#include <vdr/plugin.h>
#include <vdr/channels.h>
#include <vdr/epg.h>
#include <vdr/config.h>
#include <vdr/device.h>
#include "exception.h"
#include "livefeatures.h"
#include "setup.h"
#include "tools.h"
#include "epg_events.h"
#include "i18n.h"

using namespace std;
using namespace vdrlive;


#line 1 "page_init.eh"

// do not add to Makefile
// and do not write a ecpp comment into this file. It must produce no
// html output not even a empty line.
#include <tnt/savepoint.h>
#include "exception.h"

#line 2 "page_exit.eh"

#include "exception.h"

// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    class channel_selection_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        channel_selection_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    channel_selection_type channel_selection;
};

static tnt::ComponentFactoryImpl<_component_> Factory("schedule");

static const char* rawData = "\250\000\000\000\314\000\000\000\327\000\000\000\332\000\000\000\356\000\000\000\361\000"
  "\000\000\t\001\000\000\014\001\000\000\016\001\000\000H\001\000\000\201\001\000\000\323\001\000\000\365\001\000\000 "
  "\002\000\000\"\002\000\000\?\002\000\000A\002\000\000i\002\000\000u\002\000\000~\002\000\000\211\002\000\000\273\002"
  "\000\000\330\002\000\000\332\002\000\000\373\002\000\000\025\003\000\000\030\003\000\0004\003\000\000I\003\000\000k"
  "\003\000\000\200\003\000\000\241\003\000\000\247\003\000\000\310\003\000\000\324\003\000\000\356\003\000\000\357\003"
  "\000\000\360\003\000\000C\004\000\000M\004\000\000N\004\000\000]\004\000\000\n<html>\n\t<head>\n\t\t<title>VDR Live -"
  " </title>\n\t\t\n\t\t\n\t</head>\n\t<body>\n\t\t\n\t\t\n\t\t<div class=\"inhalt\">\n\t\t\t.\n\t\t<table class=\"listi"
  "ng\" cellspacing=\"0\" cellpadding=\"0\">\n\t\t\t\t<tr class=\"spacer\">\n\t\t\t\t\t<td colspan=\"5\"/>\n\t\t\t\t</tr"
  ">\n\t   \t\t\t<tr class=\"head\">\n\t   \t\t\t\t<td colspan=\"5\"><div class=\"boxheader\"><div><div></div></div></di"
  "v></td>\n\t\t\t\t</tr>\n\t\t\t\t<tr>\n\t   \t\t\t\t<td class=\"action leftcol \"></td>\n\t\t\t\t\t<td class=\"action "
  "\"><a href=\"searchresults.html\?searchplain=\"><img src=\"\" alt=\"\" ></img></a><img src=\"transparent.png\" width="
  "\"16\" height=\"16\"></td>\n\t\t\t\t\t<td class=\"action \"></td>\n\t\t\t\t\t<td class=\"topaligned \"><div class=\"w"
  "ithmargin\"> - </div></td>\n\t\t\t\t\t<td class=\" topaligned rightcol \"><div class=\"more withmargin\"><a ><span cl"
  "ass=\"title\"></span><br /><span class=\"short\">&nbsp;</span></a></div></td>\n\t\t\t\t</tr>\n\t\t\t</table>\n\t\t</d"
  "iv>\n\t</body>\n</html>\n\n\n<form action=\"schedule.html\" method=\"get\" id=\"channels\"><span><label for=\"channel"
  "\">: </label> </span></form>\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

#define SET_LANG(lang) \
     do \
     { \
       request.setLang(lang); \
       reply.setLocale(request.getLocale()); \
     } while (false)

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl),
    channel_selection(*this, "channel_selection")
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("schedule " << qparam.getUrl());

  tnt::DataChunks data(rawData);

  // <%args>
int channel = qparam.has("channel") ? tnt::stringToWithDefault<int>(qparam.param("channel"), ( -1), reply.out().getloc()) : ( -1);
  // </%args>

#line 22 "schedule.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_GLOBAL_VAR(logged_in_type, logged_in, "bool logged_in", (false));   // <%session> bool logged_in(false)
#line 25 "schedule.ecpp"
  typedef cChannel* Channel_type;
  TNT_REQUEST_PAGE_VAR(Channel_type, Channel, "cChannel* Channel", ());   // <%request> cChannel* Channel
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_GLOBAL_VAR(pageTitle_type, pageTitle, "std::string pageTitle", ());   // <%request> std::string pageTitle
  // <%cpp>
  // <%include> page_init.eh
#line 11 "page_init.eh"

try {
	reply.setHeader("Expires", "Mon, 26 Jul 1997 05:00:00 GMT");
	tnt::Savepoint spoint( reply );

  // </%include>
#line 28 "schedule.ecpp"

if (!logged_in && LiveSetup().UseAuth()) return reply.redirect("login.html");

#line 31 "schedule.ecpp"

	pageTitle = trVDR("Schedule");

	cSchedulesLock schedulesLock;
	cSchedules const* schedules = cSchedules::Schedules( schedulesLock );

	ReadLock channelsLock( Channels );
	if ( !channelsLock )
		throw HtmlError( tr("Couldn't aquire access to channels, please try again later.") );

	// cChannel* Channel; (see %request above)
	if ( channel > 0 ) {
		Channel = Channels.GetByNumber( channel );
	}
	else {
		if (cDevice::CurrentChannel()) {
			Channel = Channels.GetByNumber(cDevice::CurrentChannel());
		}
		else {
			Channel = Channels.Get( Channels.GetNextNormal( -1 ) );
		}
	}
	if ( Channel == 0 )
		throw HtmlError( tr("Couldn't find channel or no channels available. Maybe you mistyped your request?") );

	cSchedule const* Schedule = schedules->GetSchedule( Channel );

  // <& pageelems.doc_type ...
  { 
#line 58 "schedule.ecpp"
    tnt::QueryParams _tnt_cq0(qparam, false);
#line 58 "schedule.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "doc_type"), request, reply, _tnt_cq0);
    // &>
  }
  reply.out() << data[0]; // \n<html>\n\t<head>\n\t\t<title>VDR Live - 
#line 61 "schedule.ecpp"
  reply.sout() << ( pageTitle );
  reply.out() << data[1]; // </title>\n\t\t
  // <& pageelems.stylesheets ...
  { 
#line 62 "schedule.ecpp"
    tnt::QueryParams _tnt_cq1(qparam, false);
#line 62 "schedule.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "stylesheets"), request, reply, _tnt_cq1);
    // &>
  }
  reply.out() << data[2]; // \n\t\t
  // <& pageelems.ajax_js ...
  { 
#line 63 "schedule.ecpp"
    tnt::QueryParams _tnt_cq2(qparam, false);
#line 63 "schedule.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_js"), request, reply, _tnt_cq2);
    // &>
  }
  reply.out() << data[3]; // \n\t</head>\n\t<body>\n\t\t
  // <& pageelems.logo ...
  { 
#line 66 "schedule.ecpp"
    tnt::QueryParams _tnt_cq3(qparam, false);
#line 66 "schedule.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "logo"), request, reply, _tnt_cq3);
    // &>
  }
  reply.out() << data[4]; // \n\t\t
  // <& menu ...
  { 
#line 67 "schedule.ecpp"
    tnt::QueryParams _tnt_cq4(qparam, false);
#line 67 "schedule.ecpp"
    _tnt_cq4.add( "active", tnt::toString(("schedule"), reply.out().getloc() ) );
#line 67 "schedule.ecpp"
    _tnt_cq4.add( "component", tnt::toString(("schedule.channel_selection"), reply.out().getloc() ) );
#line 67 "schedule.ecpp"
    callComp(tnt::Compident(std::string(), "menu"), request, reply, _tnt_cq4);
    // &>
  }
  reply.out() << data[5]; // \n\t\t<div class="inhalt">\n
#line 69 "schedule.ecpp"

	if ( Schedule == 0 ) {

  reply.out() << data[6]; // \t\t\t
#line 72 "schedule.ecpp"
  reply.sout() << ( tr("No schedules available for this channel") );
  reply.out() << data[7]; // .\n
#line 73 "schedule.ecpp"

	}
	else {

  reply.out() << data[8]; // \t\t<table class="listing" cellspacing="0" cellpadding="0">\n
#line 78 "schedule.ecpp"

		string current_day = "";
		const cEvent* PresentEvent = Schedule->GetPresentEvent();
		time_t now = time(NULL) - ::Setup.EPGLinger * 60;
		// tChannelID channel_id(Channel->GetChannelID());
		// int evntNr = 0;
		for (const cEvent *Event = Schedule->Events()->First(); Event; Event = Schedule->Events()->Next(Event)) {
			if (Event->EndTime() <= now && Event != PresentEvent)
				continue;

			EpgInfoPtr epgEvent = EpgEvents::CreateEpgInfo(Channel, Event);

			string title(epgEvent->Title());
			string short_description(epgEvent->ShortDescr());
			string description(epgEvent->LongDescr());
			string start(epgEvent->StartTime(tr("%I:%M %p")));
			string end(epgEvent->EndTime(tr("%I:%M %p")));
			string day(epgEvent->StartTime(tr("%A, %b %d %Y")));
			string epgid = EpgEvents::EncodeDomId(Channel->GetChannelID(), Event->EventID());
			// string strEventID = lexical_cast<string>(Event->EventID());

			bool truncated = false;
			bool lastEventCurrentDay = false;
			{
				cEvent* NextEvent = Schedule->Events()->Next(Event);
				if (!NextEvent) {
					lastEventCurrentDay = true;
				}
				else {
					string nday(NextEvent->StartTime() ? FormatDateTime(tr("%A, %b %d %Y"), NextEvent->StartTime()) : "");
					lastEventCurrentDay = (day != nday);
				}
			}

			if (current_day != day) {
				if (current_day != "") {

  reply.out() << data[9]; // \t\t\t\t<tr class="spacer">\n\t\t\t\t\t<td colspan="5"/>\n\t\t\t\t</tr>\n
#line 118 "schedule.ecpp"

				}

  reply.out() << data[10]; // \t   \t\t\t<tr class="head">\n\t   \t\t\t\t<td colspan="5"><div class="boxheader"><div><div>
#line 122 "schedule.ecpp"
  reply.sout() << ( day );
  reply.out() << data[11]; // </div></div></div></td>\n\t\t\t\t</tr>\n
#line 124 "schedule.ecpp"

	   			current_day = day;
			}

  reply.out() << data[12]; // \t\t\t\t<tr>\n\t   \t\t\t\t<td class="action leftcol 
#line 129 "schedule.ecpp"
  if ( lastEventCurrentDay )
    reply.sout() <<  "bottomrow" ;
  reply.out() << data[13]; // ">
  // <& pageelems.event_timer ...
  { 
#line 129 "schedule.ecpp"
    tnt::QueryParams _tnt_cq5(qparam, false);
#line 129 "schedule.ecpp"
    _tnt_cq5.add( "epgid", tnt::toString((epgid), reply.out().getloc() ) );
#line 129 "schedule.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "event_timer"), request, reply, _tnt_cq5);
    // &>
  }
  reply.out() << data[14]; // </td>\n\t\t\t\t\t<td class="action 
#line 130 "schedule.ecpp"
  if ( lastEventCurrentDay )
    reply.sout() <<  "bottomrow" ;
  reply.out() << data[15]; // ">
#line 130 "schedule.ecpp"
if (LiveFeatures<features::epgsearch>().Recent() ) { 
  reply.out() << data[16]; // <a href="searchresults.html\?searchplain=
#line 130 "schedule.ecpp"
  reply.sout() << ( StringUrlEncode(title) );
  reply.out() << data[17]; // "><img src="
#line 130 "schedule.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "search.png") );
  reply.out() << data[18]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 130 "schedule.ecpp"
    tnt::QueryParams _tnt_cq6(qparam, false);
#line 130 "schedule.ecpp"
    _tnt_cq6.add( "text", tnt::toString((tr("Search for repeats.")), reply.out().getloc() ) );
#line 130 "schedule.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq6);
    // &>
  }
  reply.out() << data[19]; // ></img></a>
#line 130 "schedule.ecpp"
 } else { 
  reply.out() << data[20]; // <img src="transparent.png" width="16" height="16">
#line 130 "schedule.ecpp"
 } 
  reply.out() << data[21]; // </td>\n\t\t\t\t\t<td class="action 
#line 131 "schedule.ecpp"
  if ( lastEventCurrentDay )
    reply.sout() <<  "bottomrow" ;
  reply.out() << data[22]; // ">
  // <& pageelems.imdb_info_href ...
  { 
#line 131 "schedule.ecpp"
    tnt::QueryParams _tnt_cq7(qparam, false);
#line 131 "schedule.ecpp"
    _tnt_cq7.add( "title", tnt::toString((title), reply.out().getloc() ) );
#line 131 "schedule.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "imdb_info_href"), request, reply, _tnt_cq7);
    // &>
  }
  reply.out() << data[23]; // </td>\n\t\t\t\t\t<td class="topaligned 
#line 132 "schedule.ecpp"
  if ( lastEventCurrentDay )
    reply.sout() <<  "bottomrow" ;
  reply.out() << data[24]; // "><div class="withmargin">
#line 132 "schedule.ecpp"
  reply.sout() << ( start );
  reply.out() << data[25]; //  - 
#line 132 "schedule.ecpp"
  reply.sout() << ( end );
  reply.out() << data[26]; // </div></td>\n\t\t\t\t\t<td class="
#line 133 "schedule.ecpp"
  if ( (Event == PresentEvent) )
    reply.sout() <<  "current" ;
  reply.out() << data[27]; //  topaligned rightcol 
#line 133 "schedule.ecpp"
  if ( lastEventCurrentDay )
    reply.sout() <<  "bottomrow" ;
  reply.out() << data[28]; // "><div class="more withmargin"><a 
  // <& tooltip.hint ...
  { 
#line 133 "schedule.ecpp"
    tnt::QueryParams _tnt_cq8(qparam, false);
#line 133 "schedule.ecpp"
    _tnt_cq8.add( "text", tnt::toString((StringEscapeAndBreak(StringWordTruncate(description, 300, truncated)) + "<br />" + tr("Click to view details.")), reply.out().getloc() ) );
#line 133 "schedule.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq8);
    // &>
  }
  // <& tooltip.display ...
  { 
#line 133 "schedule.ecpp"
    tnt::QueryParams _tnt_cq9(qparam, false);
#line 133 "schedule.ecpp"
    _tnt_cq9.add( "domId", tnt::toString((epgEvent->Id()), reply.out().getloc() ) );
#line 133 "schedule.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "display"), request, reply, _tnt_cq9);
    // &>
  }
  reply.out() << data[29]; // ><span class="title">
#line 133 "schedule.ecpp"
  reply.sout() << ( title );
  reply.out() << data[30]; // </span><br /><span class="short">
#line 133 "schedule.ecpp"
if (short_description.empty()) { 
  reply.out() << data[31]; // &nbsp;
#line 133 "schedule.ecpp"
 } 
#line 133 "schedule.ecpp"
  reply.sout() << ( short_description );
  reply.out() << data[32]; // </span></a></div></td>\n\t\t\t\t</tr>\n
#line 135 "schedule.ecpp"

		}

  reply.out() << data[33]; // \t\t\t</table>\n
#line 139 "schedule.ecpp"

	}

  reply.out() << data[34]; // \t\t</div>\n\t</body>\n</html>\n
  // <%include> page_exit.eh
  reply.out() << data[35]; // \n
#line 5 "page_exit.eh"

	spoint.commit();
} catch ( vdrlive::HtmlError const& ex ) {
#if TNTVERSION >= 1606
	tnt::QueryParams param = qparam;
#else
	cxxtools::QueryParams param = qparam;
#endif
	param.add( "pageTitle", pageTitle );
	param.add( "errorMessage", ex.what() );
	callComp( "error", request, reply, param );
}

  // </%include>
  reply.out() << data[36]; // \n
  // <%/cpp>
  return HTTP_OK;
}

unsigned _component_::channel_selection_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("schedule::channel_selection " << qparam.getUrl());
  tnt::DataChunks data(rawData);
  // <%args>
  // </%args>

#line 25 "schedule.ecpp"
  typedef cChannel* Channel_type;
  TNT_REQUEST_PAGE_VAR(Channel_type, Channel, "cChannel* Channel", ());   // <%request> cChannel* Channel
#line 22 "schedule.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_GLOBAL_VAR(logged_in_type, logged_in, "bool logged_in", (false));   // <%session> bool logged_in(false)
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_GLOBAL_VAR(pageTitle_type, pageTitle, "std::string pageTitle", ());   // <%request> std::string pageTitle
  // <%cpp>
  reply.out() << data[37]; // <form action="schedule.html" method="get" id="channels"><span><label for="channel">
#line 148 "schedule.ecpp"
  reply.sout() << ( tr("Show schedule of channel") );
  reply.out() << data[38]; // : </label>
  // <& channels_widget ...
  { 
#line 148 "schedule.ecpp"
    tnt::QueryParams _tnt_cq10(qparam, false);
#line 148 "schedule.ecpp"
    _tnt_cq10.add( "name", tnt::toString(("channel"), reply.out().getloc() ) );
#line 148 "schedule.ecpp"
    _tnt_cq10.add( "onchange", tnt::toString(("document.forms.channels.submit()"), reply.out().getloc() ) );
#line 148 "schedule.ecpp"
    _tnt_cq10.add( "selected", tnt::toString((Channel ? *Channel->GetChannelID().ToString() : ""), reply.out().getloc() ) );
#line 148 "schedule.ecpp"
    callComp(tnt::Compident(std::string(), "channels_widget"), request, reply, _tnt_cq10);
    // &>
  }
  reply.out() << data[39]; //  
  // <& pageelems.vlc_stream_channel ...
  { 
#line 148 "schedule.ecpp"
    tnt::QueryParams _tnt_cq11(qparam, false);
#line 148 "schedule.ecpp"
    _tnt_cq11.add( "channelId", tnt::toString((Channel->GetChannelID()), reply.out().getloc() ) );
#line 148 "schedule.ecpp"
    _tnt_cq11.add( "linkText", tnt::toString((tr("Stream into browser")), reply.out().getloc() ) );
#line 148 "schedule.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "vlc_stream_channel"), request, reply, _tnt_cq11);
    // &>
  }
  reply.out() << data[40]; // </span></form>\n
  // <%/cpp>
  return HTTP_OK;
}

} // namespace
