////////////////////////////////////////////////////////////////////////
// setup.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/convert.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.setup")

// <%pre>
#line 1 "setup.ecpp"

#include <sys/stat.h>
#include <vdr/tools.h>
#include "setup.h"
#include "tools.h"
#include "i18n.h"

using namespace vdrlive;
using namespace std;


#line 1 "page_init.eh"

// do not add to Makefile
// and do not write a ecpp comment into this file. It must produce no
// html output not even a empty line.
#include <tnt/savepoint.h>
#include "exception.h"

#line 2 "page_exit.eh"

#include "exception.h"

// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
};

static tnt::ComponentFactoryImpl<_component_> Factory("setup");

static const char* rawData = "\364\000\000\000\030\001\000\000#\001\000\000&\001\000\000\327\004\000\000\332\004\000"
  "\000Q\005\000\000\225\005\000\000R\006\000\000\267\006\000\000\014\007\000\000t\007\000\000\341\007\000\000\301\010"
  "\000\000\001\t\000\000\201\t\000\000\305\t\000\000D\n\000\000\214\n\000\000,\013\000\000\233\013\000\000\367\013\000"
  "\000d\014\000\000D\015\000\000\242\015\000\000.\016\000\000\245\016\000\000\217\017\000\000\352\017\000\000\?\020\000"
  "\000\277\020\000\000\351\020\000\000\023\021\000\000<\021\000\000i\021\000\000\025\022\000\000\204\022\000\000\340"
  "\022\000\000/\023\000\000F\023\000\000\231\023\000\000\031\024\000\000\032\024\000\000G\024\000\000H\024\000\000r\024"
  "\000\000s\024\000\000\237\024\000\000\240\024\000\000\310\024\000\000\311\024\000\0005\025\000\000\207\025\000\000"
  "\235\025\000\000\237\025\000\000\240\025\000\000\252\025\000\000r\026\000\000\324\026\000\000\325\026\000\000\327\026"
  "\000\000\n<html>\n\t<head>\n\t\t<title>VDR-Live - </title>\n\t\t\n\t\t\n\t\t<script type=\"text/javascript\"><!--\n\t"
  "\tfunction initform()\n\t\t{\n\t\t\tchangeduseauth(document.getElementById(\"useauth\"));\n\t\t\tchangeduseajax(docum"
  "ent.getElementById(\"useAjax\"));\n\t\t\tchangedusestreamdev(document.getElementById(\"useStreamdev\"));\n\t\t\tif (d"
  "ocument.getElementById(\"message\").value != \"\")\n\t\t\t\talert(document.getElementById(\"message\").value);\n\t\t}"
  "\n\t\tfunction changeduseauth(selection)\n\t\t{\n\t\t\tdocument.getElementById(\"authsection\").style.display = (sele"
  "ction.checked \? \"block\" : \"none\");\n\t\t}\n\t\tfunction setauthchanged(selection)\n\t\t{\n\t\t\tdocument.getElem"
  "entById(\"authchanged\").value = 1;\n\t\t}\n\t\tfunction changeduseajax(selection)\n\t\t{\n\t\t\tdocument.getElementB"
  "yId(\"ajaxsection\").style.display = (selection.checked \? \"block\" : \"none\");\n\t\t}\n\t\tfunction changedusestre"
  "amdev(selection)\n\t\t{\n\t\t\tdocument.getElementById(\"streamdevsection\").style.display = (selection.checked \? \""
  "block\" : \"none\");\n\t\t}\n\t\t//--></script>\n\t</head>\n\t<body onload=\"initform()\">\n\t\t\n\t\t\n\t\t<div clas"
  "s=\"inhalt\">\n\t\t\t<form method=\"post\" action=\"setup.html\">\n\t\t\t\t<input type=\"hidden\" name=\"authchanged"
  "\" value=\"\" id=\"authchanged\"/>\n\t\t\t\t<input type=\"hidden\" name=\"message\" value=\"\" id=\"message\"/>\n\t\t"
  "\t\t<table class=\"formular\" cellpadding=\"0\" cellspacing=\"0\">\n\t\t\t\t\t<tr class=\"head\">\n\t\t\t\t\t\t<td  c"
  "lass=\"toprow leftcol rightcol\" colspan=\"2\"><div class=\"boxheader\"><div><div></div></div></div></td>\n\t\t\t\t\t"
  "</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class=\"label leftcol\"><div class=\"withmargin\">:</div></td>\n\t\t\t\t\t\t<t"
  "d class=\"rightcol\"><input type=\"text\" name=\"lastchannel\" value=\"\" id=\"lastchannel\" /></td>\n\t\t\t\t\t</tr>"
  "\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class=\"label leftcol\"><div class=\"withmargin\">:</div></td>\n\t\t\t\t\t\t<td cla"
  "ss=\"rightcol\">\n\t\t\t\t\t\t\t<input type=\"checkbox\" name=\"useauth\" id=\"useauth\" value=\"1\"  onclick=\"chang"
  "eduseauth(this)\"/>\n\t\t\t\t\t\t\t<div id=\"authsection\" style=\"display: none\">\n\t\t\t\t\t\t\t<table border=\"0"
  "\" cellpadding=\"0\" cellspacing=\"0\" class=\"dependent\">\n\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t<td class=\"label\">"
  "<div class=\"withmargin\">:</div></td>\n\t\t\t\t\t\t\t\t<td><input type=\"text\" name=\"login\" value=\"\" id=\"login"
  "\" onchange=\"setauthchanged(this)\" /></td>\n\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t<td class=\"la"
  "bel\"><div class=\"withmargin\">:</div></td>\n\t\t\t\t\t\t\t\t<td><input  type=\"password\" name=\"pass\" value=\"\" "
  "id=\"pass\" onchange=\"setauthchanged(this)\" /></td>\n\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t<td c"
  "lass=\"label\"><div class=\"withmargin\">:</div></td>\n\t\t\t\t\t\t\t\t<td><input  type=\"text\" name=\"localnetmask"
  "\" value=\"\" id=\"localnetmask\" /></td>\n\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t</table>\n\t\t\t\t\t\t\t</div>\n\t\t\t"
  "\t\t\t</td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class=\"label leftcol\"><div class=\"withmargin\">:</di"
  "v></td>\n\t\t\t\t\t\t<td class=\"rightcol\">\n\t\t\t\t\t\t\t<input type=\"checkbox\" name=\"showLogo\" id=\"showLogo"
  "\" value=\"1\" />\n\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class=\"label leftcol\"><div c"
  "lass=\"withmargin\">:</div></td>\n\t\t\t\t\t\t<td class=\"rightcol\">\n\t\t\t\t\t\t\t<input type=\"checkbox\" name=\""
  "useAjax\" id=\"useAjax\" value=\"1\"  onclick=\"changeduseajax(this)\"/>\n\t\t\t\t\t\t\t<div id=\"ajaxsection\" style"
  "=\"display: none\">\n\t\t\t\t\t\t\t<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\" class=\"dependent\">\n\t\t"
  "\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t<td class=\"label\"><div class=\"withmargin\">:</div></td>\n\t\t\t\t\t\t\t\t<td><inpu"
  "t type=\"checkbox\" name=\"showInfoBox\" id=\"showInfoBox\" value=\"1\" /></td>\n\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t<"
  "/table>\n\t\t\t\t\t\t\t</div>\n\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class=\"label left"
  "col\"><div class=\"withmargin\">:</div></td>\n\t\t\t\t\t\t<td class=\"rightcol\">\n\t\t\t\t\t\t\t<input type=\"checkb"
  "ox\" name=\"useStreamdev\" id=\"useStreamdev\" value=\"1\"  onclick=\"changedusestreamdev(this)\"/>\n\t\t\t\t\t\t\t<d"
  "iv id=\"streamdevsection\" style=\"display: none\">\n\t\t\t\t\t\t\t<table border=\"0\" cellpadding=\"0\" cellspacing="
  "\"0\" class=\"dependent\">\n\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t<td class=\"label\"><div class=\"withmargin\">:</div>"
  "</td>\n\t\t\t\t\t\t\t\t<td><input type=\"text\" name=\"streamdevport\" id=\"streamdevport\" value=\"\" /></td>\n\t\t"
  "\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t<td class=\"label\"><div class=\"withmargin\">:</div></td>\n\t\t"
  "\t\t\t\t\t\t<td class=\"rightcol\"><select name=\"streamdevtype\" size=\"1\" id=\"streamdevtype\">\n\t\t\t\t\t\t\t\t"
  "\t<option value=\"TS\" >TS</option>\n\t\t\t\t\t\t\t\t\t<option value=\"PES\" >PES</option>\n\t\t\t\t\t\t\t\t\t<option"
  " value=\"PS\" >PS</option>\n\t\t\t\t\t\t\t\t\t<option value=\"ES\" >ES</option>\n\t\t\t\t\t\t\t\t\t<option value=\"Ex"
  "tern\" >Extern</option>\n\t\t\t\t\t\t\t\t</select></td>\n\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t</table>\n\t\t\t\t\t\t\t<"
  "/div>\n\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class=\"label leftcol\"><div class=\"withm"
  "argin\">:</div></td>\n\t\t\t\t\t\t<td class=\"rightcol\">\n\t\t\t\t\t\t\t<input type=\"checkbox\" name=\"showIMDb\" i"
  "d=\"showIMDb\" value=\"1\" />\n\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class=\"label left"
  "col\"><div class=\"withmargin\">:</div></td>\n\t\t\t\t\t\t<td class=\"rightcol\"><input type=\"text\" name=\"times\" "
  "value=\"\" id=\"times\" />\n\t\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class=\"label leftc"
  "ol\"><div class=\"withmargin\">:</div></td>\n\t\t\t\t\t\t<td class=\"rightcol\"><select name=\"startscreen\" size=\"1"
  "\" id=\"startscreen\">\n\t\t\t\t\t\t\t<option value=\"whatsonnow\" ></option>\n\t\t\t\t\t\t\t<option value=\"whatsonn"
  "ext\" ></option>\n\t\t\t\t\t\t\t<option value=\"schedule\" ></option>\n\t\t\t\t\t\t\t<option value=\"recordings\" ></"
  "option>\n\t\t\t\t\t\t\t<option value=\"timers\" ></option>\n\t\t\t\t\t\t</select></td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<t"
  "r>\n\t\t\t\t\t\t<td class=\"label leftcol\"><div class=\"withmargin\">:</div></td>\n\t\t\t\t\t\t<td class=\"rightcol"
  "\"><select name=\"theme\" size=\"1\" id=\"theme\">\n\t\t\t\t\t\t\t<option value=\"\" ></option>\n\t\t\t\t\t\t</select"
  "></td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class=\"buttonpanel leftcol rightcol bottomrow\" colspan=\"2"
  "\">\n\t\t\t\t\t\t\t<div class=\"withmargin\">\n\t\t\t\t\t\t\t<button class=\"green\" type=\"submit\" name=\"save\" ><"
  "/button>\n\t\t\t\t\t\t\t</div>\n\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n\t\t\t\t</table>\n\t\t\t</form>\n\t\t</div>\n\t</"
  "body>\n</html>\n\n\n\n\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

#define SET_LANG(lang) \
     do \
     { \
       request.setLang(lang); \
       reply.setLocale(request.getLocale()); \
     } while (false)

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl)
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("setup " << qparam.getUrl());

  tnt::DataChunks data(rawData);

  // <%args>
string lastchannel = tnt::stringTo<string>("lastchannel", "string", qparam.param("lastchannel"), reply.out().getloc());
bool useauth = qparam.has("useauth") ? tnt::stringToWithDefault<bool>(qparam.param("useauth"), ( false), reply.out().getloc()) : ( false);
string login = tnt::stringTo<string>("login", "string", qparam.param("login"), reply.out().getloc());
string pass = tnt::stringTo<string>("pass", "string", qparam.param("pass"), reply.out().getloc());
string times = tnt::stringTo<string>("times", "string", qparam.param("times"), reply.out().getloc());
string startscreen = tnt::stringTo<string>("startscreen", "string", qparam.param("startscreen"), reply.out().getloc());
string theme = tnt::stringTo<string>("theme", "string", qparam.param("theme"), reply.out().getloc());
string localnetmask = tnt::stringTo<string>("localnetmask", "string", qparam.param("localnetmask"), reply.out().getloc());
string showLogo = tnt::stringTo<string>("showLogo", "string", qparam.param("showLogo"), reply.out().getloc());
string useAjax = tnt::stringTo<string>("useAjax", "string", qparam.param("useAjax"), reply.out().getloc());
string showInfoBox = tnt::stringTo<string>("showInfoBox", "string", qparam.param("showInfoBox"), reply.out().getloc());
string useStreamdev = tnt::stringTo<string>("useStreamdev", "string", qparam.param("useStreamdev"), reply.out().getloc());
string showIMDb = tnt::stringTo<string>("showIMDb", "string", qparam.param("showIMDb"), reply.out().getloc());
string streamdevport = tnt::stringTo<string>("streamdevport", "string", qparam.param("streamdevport"), reply.out().getloc());
string streamdevtype = tnt::stringTo<string>("streamdevtype", "string", qparam.param("streamdevtype"), reply.out().getloc());
int authchanged = qparam.has("authchanged") ? tnt::stringToWithDefault<int>(qparam.param("authchanged"), ( 0), reply.out().getloc()) : ( 0);
  // </%args>

#line 31 "setup.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_GLOBAL_VAR(logged_in_type, logged_in, "bool logged_in", (false));   // <%session> bool logged_in(false)
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_GLOBAL_VAR(pageTitle_type, pageTitle, "std::string pageTitle", ());   // <%request> std::string pageTitle
  // <%cpp>
  // <%include> page_init.eh
#line 11 "page_init.eh"

try {
	reply.setHeader("Expires", "Mon, 26 Jul 1997 05:00:00 GMT");
	tnt::Savepoint spoint( reply );

  // </%include>
#line 34 "setup.ecpp"

if (!logged_in && LiveSetup().UseAuth()) return reply.redirect("login.html");

#define SELECTIF(x) reply.out() << ( (x) ? "selected=\"selected\"" : "" );
#define CHECKIF(x) reply.out() << ( (x) ? "checked=\"checked\"" : "" );

	std::string message;

	if ( request.getMethod() == "POST") {
		if (authchanged && useauth && (login.empty() || pass.empty()))
			message = tr("Please set login and password!");
		else
		{
			LiveSetup().SetLastChannel(lastchannel != "" ? lexical_cast< int >(lastchannel):0);
			LiveSetup().SetUseAuth(useauth);
			if (useauth) {
				LiveSetup().SetAdminLogin(login);
				if (pass != "")
					LiveSetup().SetAdminPassword(pass);
				LiveSetup().SetLocalNetMask(localnetmask);
				LiveSetup().CheckLocalNet(request.getPeerIp());
			}
			LiveSetup().SetTimes(times);
			LiveSetup().SetStartScreen(startscreen);
			LiveSetup().SetTheme(theme);
			LiveSetup().SetShowLogo(!showLogo.empty());
			LiveSetup().SetUseAjax(!useAjax.empty());
			if (LiveSetup().GetUseAjax()) {
				LiveSetup().SetShowInfoBox(!showInfoBox.empty());
			}
			LiveSetup().SetUseStreamdev(!useStreamdev.empty());
			LiveSetup().SetStreamdevPort(streamdevport.empty() ? 3000 : lexical_cast<int>(streamdevport));
			LiveSetup().SetStreamdevType(streamdevtype.empty() ? "PES" : streamdevtype);
			LiveSetup().SetShowIMDb(!showIMDb.empty());
			LiveSetup().SaveSetup();
			message = tr("Setup saved.");
		}
	}
	pageTitle = tr("Setup");
	int ilastchannel = LiveSetup().GetLastChannel();
	if (ilastchannel == std::numeric_limits< int >::max())
		lastchannel = "";
	else
		lastchannel = lexical_cast<std::string, int>(ilastchannel);

	login = LiveSetup().GetAdminLogin();
	useauth = LiveSetup().GetUseAuth();
	times = LiveSetup().GetTimes();
	startscreen = LiveSetup().GetStartScreen();
	theme = LiveSetup().GetTheme();
	localnetmask = LiveSetup().GetLocalNetMask();
	showLogo = LiveSetup().GetShowLogo() ? "1" : "";
	useAjax = LiveSetup().GetUseAjax() ? "1" : "";
	showInfoBox = LiveSetup().GetShowInfoBox() ? "1" : "";
	useStreamdev = LiveSetup().GetUseStreamdev() ? "1" : "";
	streamdevport = lexical_cast<std::string, int>(LiveSetup().GetStreamdevPort());
	streamdevtype = LiveSetup().GetStreamdevType();
	showIMDb = LiveSetup().GetShowIMDb() ? "1" : "";


  // <& pageelems.doc_type ...
  { 
#line 94 "setup.ecpp"
    tnt::QueryParams _tnt_cq0(qparam, false);
#line 94 "setup.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "doc_type"), request, reply, _tnt_cq0);
    // &>
  }
  reply.out() << data[0]; // \n<html>\n\t<head>\n\t\t<title>VDR-Live - 
#line 97 "setup.ecpp"
  reply.sout() << ( pageTitle );
  reply.out() << data[1]; // </title>\n\t\t
  // <& pageelems.stylesheets ...
  { 
#line 98 "setup.ecpp"
    tnt::QueryParams _tnt_cq1(qparam, false);
#line 98 "setup.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "stylesheets"), request, reply, _tnt_cq1);
    // &>
  }
  reply.out() << data[2]; // \n\t\t
  // <& pageelems.ajax_js ...
  { 
#line 99 "setup.ecpp"
    tnt::QueryParams _tnt_cq2(qparam, false);
#line 99 "setup.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_js"), request, reply, _tnt_cq2);
    // &>
  }
  reply.out() << data[3]; // \n\t\t<script type="text/javascript"><!--\n\t\tfunction initform()\n\t\t{\n\t\t\tchangeduseauth(document.getElementById("useauth"));\n\t\t\tchangeduseajax(document.getElementById("useAjax"));\n\t\t\tchangedusestreamdev(document.getElementById("useStreamdev"));\n\t\t\tif (document.getElementById("message").value != "")\n\t\t\t\talert(document.getElementById("message").value);\n\t\t}\n\t\tfunction changeduseauth(selection)\n\t\t{\n\t\t\tdocument.getElementById("authsection").style.display = (selection.checked \? "block" : "none");\n\t\t}\n\t\tfunction setauthchanged(selection)\n\t\t{\n\t\t\tdocument.getElementById("authchanged").value = 1;\n\t\t}\n\t\tfunction changeduseajax(selection)\n\t\t{\n\t\t\tdocument.getElementById("ajaxsection").style.display = (selection.checked \? "block" : "none");\n\t\t}\n\t\tfunction changedusestreamdev(selection)\n\t\t{\n\t\t\tdocument.getElementById("streamdevsection").style.display = (selection.checked \? "block" : "none");\n\t\t}\n\t\t//--></script>\n\t</head>\n\t<body onload="initform()">\n\t\t
  // <& pageelems.logo ...
  { 
#line 128 "setup.ecpp"
    tnt::QueryParams _tnt_cq3(qparam, false);
#line 128 "setup.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "logo"), request, reply, _tnt_cq3);
    // &>
  }
  reply.out() << data[4]; // \n\t\t
  // <& menu ...
  { 
#line 129 "setup.ecpp"
    tnt::QueryParams _tnt_cq4(qparam, false);
#line 129 "setup.ecpp"
    _tnt_cq4.add( "active", tnt::toString(("setup"), reply.out().getloc() ) );
#line 129 "setup.ecpp"
    callComp(tnt::Compident(std::string(), "menu"), request, reply, _tnt_cq4);
    // &>
  }
  reply.out() << data[5]; // \n\t\t<div class="inhalt">\n\t\t\t<form method="post" action="setup.html">\n\t\t\t\t<input type="hidden" name="authchanged" value="
#line 132 "setup.ecpp"
  reply.sout() << ( authchanged );
  reply.out() << data[6]; // " id="authchanged"/>\n\t\t\t\t<input type="hidden" name="message" value="
#line 133 "setup.ecpp"
  reply.sout() << ( message );
  reply.out() << data[7]; // " id="message"/>\n\t\t\t\t<table class="formular" cellpadding="0" cellspacing="0">\n\t\t\t\t\t<tr class="head">\n\t\t\t\t\t\t<td  class="toprow leftcol rightcol" colspan="2"><div class="boxheader"><div><div>
#line 136 "setup.ecpp"
  reply.sout() << ( tr("Setup") );
  reply.out() << data[8]; // </div></div></div></td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="label leftcol"><div class="withmargin">
#line 139 "setup.ecpp"
  reply.sout() << ( tr("Last channel to display") );
  reply.out() << data[9]; // :</div></td>\n\t\t\t\t\t\t<td class="rightcol"><input type="text" name="lastchannel" value="
#line 140 "setup.ecpp"
  reply.sout() << ( lastchannel );
  reply.out() << data[10]; // " id="lastchannel" /></td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="label leftcol"><div class="withmargin">
#line 143 "setup.ecpp"
  reply.sout() << ( tr("Use authentication") );
  reply.out() << data[11]; // :</div></td>\n\t\t\t\t\t\t<td class="rightcol">\n\t\t\t\t\t\t\t<input type="checkbox" name="useauth" id="useauth" value="1" 
#line 145 "setup.ecpp"
 CHECKIF(useauth); 
  reply.out() << data[12]; //  onclick="changeduseauth(this)"/>\n\t\t\t\t\t\t\t<div id="authsection" style="display: none">\n\t\t\t\t\t\t\t<table border="0" cellpadding="0" cellspacing="0" class="dependent">\n\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t<td class="label"><div class="withmargin">
#line 149 "setup.ecpp"
  reply.sout() << ( tr("Admin login") );
  reply.out() << data[13]; // :</div></td>\n\t\t\t\t\t\t\t\t<td><input type="text" name="login" value="
#line 150 "setup.ecpp"
  reply.sout() << ( login );
  reply.out() << data[14]; // " id="login" onchange="setauthchanged(this)" /></td>\n\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t<td class="label"><div class="withmargin">
#line 153 "setup.ecpp"
  reply.sout() << ( tr("Admin password") );
  reply.out() << data[15]; // :</div></td>\n\t\t\t\t\t\t\t\t<td><input  type="password" name="pass" value="
#line 154 "setup.ecpp"
  reply.sout() << ( pass );
  reply.out() << data[16]; // " id="pass" onchange="setauthchanged(this)" /></td>\n\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t<td class="label"><div class="withmargin">
#line 157 "setup.ecpp"
  reply.sout() << ( tr("Local net (no login required)") );
  reply.out() << data[17]; // :</div></td>\n\t\t\t\t\t\t\t\t<td><input  type="text" name="localnetmask" value="
#line 158 "setup.ecpp"
  reply.sout() << ( localnetmask );
  reply.out() << data[18]; // " id="localnetmask" /></td>\n\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t</table>\n\t\t\t\t\t\t\t</div>\n\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="label leftcol"><div class="withmargin">
#line 165 "setup.ecpp"
  reply.sout() << ( tr("Show live logo image") );
  reply.out() << data[19]; // :</div></td>\n\t\t\t\t\t\t<td class="rightcol">\n\t\t\t\t\t\t\t<input type="checkbox" name="showLogo" id="showLogo" value="1" 
#line 167 "setup.ecpp"
 CHECKIF(!showLogo.empty()); 
  reply.out() << data[20]; // />\n\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="label leftcol"><div class="withmargin">
#line 171 "setup.ecpp"
  reply.sout() << ( tr("Use ajax technology") );
  reply.out() << data[21]; // :</div></td>\n\t\t\t\t\t\t<td class="rightcol">\n\t\t\t\t\t\t\t<input type="checkbox" name="useAjax" id="useAjax" value="1" 
#line 173 "setup.ecpp"
 CHECKIF(!useAjax.empty()); 
  reply.out() << data[22]; //  onclick="changeduseajax(this)"/>\n\t\t\t\t\t\t\t<div id="ajaxsection" style="display: none">\n\t\t\t\t\t\t\t<table border="0" cellpadding="0" cellspacing="0" class="dependent">\n\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t<td class="label"><div class="withmargin">
#line 177 "setup.ecpp"
  reply.sout() << ( tr("Show dynamic VDR information box") );
  reply.out() << data[23]; // :</div></td>\n\t\t\t\t\t\t\t\t<td><input type="checkbox" name="showInfoBox" id="showInfoBox" value="1" 
#line 178 "setup.ecpp"
 CHECKIF(!showInfoBox.empty()); 
  reply.out() << data[24]; // /></td>\n\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t</table>\n\t\t\t\t\t\t\t</div>\n\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="label leftcol"><div class="withmargin">
#line 185 "setup.ecpp"
  reply.sout() << ( tr("Allow video streaming") );
  reply.out() << data[25]; // :</div></td>\n\t\t\t\t\t\t<td class="rightcol">\n\t\t\t\t\t\t\t<input type="checkbox" name="useStreamdev" id="useStreamdev" value="1" 
#line 187 "setup.ecpp"
 CHECKIF(!useStreamdev.empty()); 
  reply.out() << data[26]; //  onclick="changedusestreamdev(this)"/>\n\t\t\t\t\t\t\t<div id="streamdevsection" style="display: none">\n\t\t\t\t\t\t\t<table border="0" cellpadding="0" cellspacing="0" class="dependent">\n\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t<td class="label"><div class="withmargin">
#line 191 "setup.ecpp"
  reply.sout() << ( tr("Streamdev server port") );
  reply.out() << data[27]; // :</div></td>\n\t\t\t\t\t\t\t\t<td><input type="text" name="streamdevport" id="streamdevport" value="
#line 192 "setup.ecpp"
  reply.sout() << ( streamdevport );
  reply.out() << data[28]; // " /></td>\n\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t<td class="label"><div class="withmargin">
#line 195 "setup.ecpp"
  reply.sout() << ( tr("Streamdev stream type") );
  reply.out() << data[29]; // :</div></td>\n\t\t\t\t\t\t\t\t<td class="rightcol"><select name="streamdevtype" size="1" id="streamdevtype">\n\t\t\t\t\t\t\t\t\t<option value="TS" 
#line 197 "setup.ecpp"
 SELECTIF(streamdevtype == "TS") 
  reply.out() << data[30]; // >TS</option>\n\t\t\t\t\t\t\t\t\t<option value="PES" 
#line 198 "setup.ecpp"
 SELECTIF(streamdevtype == "PES") 
  reply.out() << data[31]; // >PES</option>\n\t\t\t\t\t\t\t\t\t<option value="PS" 
#line 199 "setup.ecpp"
 SELECTIF(streamdevtype == "PS") 
  reply.out() << data[32]; // >PS</option>\n\t\t\t\t\t\t\t\t\t<option value="ES" 
#line 200 "setup.ecpp"
 SELECTIF(streamdevtype == "ES") 
  reply.out() << data[33]; // >ES</option>\n\t\t\t\t\t\t\t\t\t<option value="Extern" 
#line 201 "setup.ecpp"
 SELECTIF(streamdevtype == "Extern") 
  reply.out() << data[34]; // >Extern</option>\n\t\t\t\t\t\t\t\t</select></td>\n\t\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t</table>\n\t\t\t\t\t\t\t</div>\n\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="label leftcol"><div class="withmargin">
#line 209 "setup.ecpp"
  reply.sout() << ( tr("Add links to IMDb") );
  reply.out() << data[35]; // :</div></td>\n\t\t\t\t\t\t<td class="rightcol">\n\t\t\t\t\t\t\t<input type="checkbox" name="showIMDb" id="showIMDb" value="1" 
#line 211 "setup.ecpp"
 CHECKIF(!showIMDb.empty()); 
  reply.out() << data[36]; // />\n\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="label leftcol"><div class="withmargin">
#line 215 "setup.ecpp"
  reply.sout() << ( tr("additional fixed times in 'What's on?'") );
  reply.out() << data[37]; // :</div></td>\n\t\t\t\t\t\t<td class="rightcol"><input type="text" name="times" value="
#line 216 "setup.ecpp"
  reply.sout() << ( times );
  reply.out() << data[38]; // " id="times" />\n\t\t\t\t\t\t\t
  // <& tooltip.help ...
  { 
#line 217 "setup.ecpp"
    tnt::QueryParams _tnt_cq5(qparam, false);
#line 217 "setup.ecpp"
    _tnt_cq5.add( "text", tnt::toString((tr("Format is HH:MM. Separate multiple times with a semicolon")), reply.out().getloc() ) );
#line 217 "setup.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "help"), request, reply, _tnt_cq5);
    // &>
  }
  reply.out() << data[39]; // </td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="label leftcol"><div class="withmargin">
#line 220 "setup.ecpp"
  reply.sout() << ( tr("Start page") );
  reply.out() << data[40]; // :</div></td>\n\t\t\t\t\t\t<td class="rightcol"><select name="startscreen" size="1" id="startscreen">\n\t\t\t\t\t\t\t<option value="whatsonnow" 
#line 222 "setup.ecpp"
 SELECTIF(startscreen == "whatsonnow") 
  reply.out() << data[41]; // >
#line 222 "setup.ecpp"
  reply.sout() << ( trVDR("What's on now?") );
  reply.out() << data[42]; // </option>\n\t\t\t\t\t\t\t<option value="whatsonnext" 
#line 223 "setup.ecpp"
 SELECTIF(startscreen == "whatsonnext") 
  reply.out() << data[43]; // >
#line 223 "setup.ecpp"
  reply.sout() << ( trVDR("What's on next?") );
  reply.out() << data[44]; // </option>\n\t\t\t\t\t\t\t<option value="schedule" 
#line 224 "setup.ecpp"
 SELECTIF(startscreen == "schedule") 
  reply.out() << data[45]; // >
#line 224 "setup.ecpp"
  reply.sout() << ( trVDR("Schedule") );
  reply.out() << data[46]; // </option>\n\t\t\t\t\t\t\t<option value="recordings" 
#line 225 "setup.ecpp"
 SELECTIF(startscreen == "recordings") 
  reply.out() << data[47]; // >
#line 225 "setup.ecpp"
  reply.sout() << ( trVDR("Recordings") );
  reply.out() << data[48]; // </option>\n\t\t\t\t\t\t\t<option value="timers" 
#line 226 "setup.ecpp"
 SELECTIF(startscreen == "timers") 
  reply.out() << data[49]; // >
#line 226 "setup.ecpp"
  reply.sout() << ( trVDR("Timers") );
  reply.out() << data[50]; // </option>\n\t\t\t\t\t\t</select></td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="label leftcol"><div class="withmargin">
#line 230 "setup.ecpp"
  reply.sout() << ( tr("Theme") );
  reply.out() << data[51]; // :</div></td>\n\t\t\t\t\t\t<td class="rightcol"><select name="theme" size="1" id="theme">\n
#line 232 "setup.ecpp"

{
	const string dirPath(Plugin::GetConfigDirectory() + "/themes");
	cReadDir d(dirPath.c_str());
	struct dirent* e;
	string parent("..");
	string current(".");
	string cvsDir("CVS");
	while ((e = d.Next())) {
		if ((current == e->d_name) || (parent == e->d_name) || (cvsDir == e->d_name)) {
			continue;
		}
		/* Check if entry is a directory: I do not rely on e->d_type
		   here because on some systems it is allways DT_UNKNOWN. Also
		   testing for DT_DIR does not take into account symbolic
		   links to directories.
		*/
		struct stat buf;
		if ((stat((dirPath + "/" + e->d_name).c_str(), &buf) != 0) || (!S_ISDIR(buf.st_mode))) {
			continue;
		}

  reply.out() << data[52]; // \t\t\t\t\t\t\t<option value="
#line 254 "setup.ecpp"
  reply.sout() << ( e->d_name );
  reply.out() << data[53]; // " 
#line 254 "setup.ecpp"
 SELECTIF(theme == e->d_name) 
  reply.out() << data[54]; // >
#line 254 "setup.ecpp"
  reply.sout() << ( e->d_name );
  reply.out() << data[55]; // </option>\n
#line 255 "setup.ecpp"

	}
}

  reply.out() << data[56]; // \t\t\t\t\t\t</select></td>\n\t\t\t\t\t</tr>\n\t\t\t\t\t<tr>\n\t\t\t\t\t\t<td class="buttonpanel leftcol rightcol bottomrow" colspan="2">\n\t\t\t\t\t\t\t<div class="withmargin">\n\t\t\t\t\t\t\t<button class="green" type="submit" name="save" >
#line 264 "setup.ecpp"
  reply.sout() << ( tr("Save") );
  reply.out() << data[57]; // </button>\n\t\t\t\t\t\t\t</div>\n\t\t\t\t\t\t</td>\n\t\t\t\t\t</tr>\n\t\t\t\t</table>\n\t\t\t</form>\n\t\t</div>\n\t</body>\n</html>\n\n
  // <%include> page_exit.eh
  reply.out() << data[58]; // \n
#line 5 "page_exit.eh"

	spoint.commit();
} catch ( vdrlive::HtmlError const& ex ) {
#if TNTVERSION >= 1606
	tnt::QueryParams param = qparam;
#else
	cxxtools::QueryParams param = qparam;
#endif
	param.add( "pageTitle", pageTitle );
	param.add( "errorMessage", ex.what() );
	callComp( "error", request, reply, param );
}

  // </%include>
  reply.out() << data[59]; // \n\n
  // <%/cpp>
  return HTTP_OK;
}

} // namespace
