////////////////////////////////////////////////////////////////////////
// timerconflicts.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/convert.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.timerconflicts")

// <%pre>
#line 1 "timerconflicts.ecpp"

#include <vdr/channels.h>
#include <vdr/i18n.h>
#include "timerconflict.h"
#include "tools.h"
#include "setup.h"
#include "epg_events.h"
#include "timers.h"
#include "i18n.h"

using namespace vdrlive;
using namespace std;

static const size_t maximumDescriptionLength = 300;


#line 1 "page_init.eh"

// do not add to Makefile
// and do not write a ecpp comment into this file. It must produce no
// html output not even a empty line.
#include <tnt/savepoint.h>
#include "exception.h"

#line 2 "page_exit.eh"

#include "exception.h"

// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
};

static tnt::ComponentFactoryImpl<_component_> Factory("timerconflicts");

static const char* rawData = "\340\000\000\000\004\001\000\000\017\001\000\000\022\001\000\000&\001\000\000)\001\000"
  "\000A\001\000\000E\001\000\000F\001\000\000\201\001\000\000\333\001\000\000\256\002\000\000\335\002\000\000\014\003"
  "\000\000;\003\000\000j\003\000\000\033\005\000\000B\005\000\000N\005\000\000W\005\000\000w\005\000\000\260\005\000"
  "\000\262\005\000\000\325\005\000\000\357\005\000\000\016\006\000\000(\006\000\000G\006\000\000a\006\000\000\200\006"
  "\000\000\235\006\000\000\246\006\000\000\247\006\000\000\260\006\000\000\332\006\000\000\004\007\000\000\020\007\000"
  "\000\031\007\000\000D\007\000\000c\007\000\000}\007\000\000\206\007\000\000\261\007\000\000\324\007\000\000\340\007"
  "\000\000\351\007\000\000\035\010\000\000<\010\000\000V\010\000\000_\010\000\000}\010\000\000\304\010\000\000\320\010"
  "\000\000\352\010\000\000\353\010\000\000\355\010\000\000\n<html>\n\t<head>\n\t\t<title>VDR-Live - </title>\n\t\t\n\t"
  "\t\n\t</head>\n\t<body>\n\t\t\n\t\t\n\t\t<div class=\"inhalt\">\n\t\t\t\t\n\t\t\t<table class=\"listing\" cellspacing"
  "=\"0\" cellpadding=\"0\">\n\t\t\t\t\t\t<tr class=\"head\">\n\t\t\t\t\t\t\t<td colspan=\"10\">\n\t\t\t\t\t\t\t\t<div c"
  "lass=\"boxheader\"><div><div></div></div></div>\n\t\t\t\t\t\t\t</td>\n\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t<tr class=\"desc"
  "ription\">\n\t\t\t\t\t\t\t<td class=\"leftcol\"><img src=\"/img/transparent.png\" alt=\"\" width=\"16px\" height=\"16"
  "px\" /></td>\n\t\t\t\t\t\t\t<td><div class=\"withmargin\"></div></td>\n\t\t\t\t\t\t\t<td><div class=\"withmargin\"></"
  "div></td>\n\t\t\t\t\t\t\t<td><div class=\"withmargin\"></div></td>\n\t\t\t\t\t\t\t<td><div class=\"withmargin\"></div"
  "></td>\n\t\t\t\t\t\t\t<td><div class=\"withmargin\"></div></td>\n\t\t\t\t\t\t\t<td class=\"action\"><img src=\"/img/t"
  "ransparent.png\" alt=\"\" width=\"16px\" height=\"16px\" /></td>\n\t\t\t\t\t\t\t<td class=\"action\"><img src=\"/img/"
  "transparent.png\" alt=\"\" width=\"16px\" height=\"16px\" /></td>\n\t\t\t\t\t\t\t<td class=\"action\"><img src=\"/img"
  "/transparent.png\" alt=\"\" width=\"16px\" height=\"16px\" /></td>\n\t\t\t\t\t\t\t<td class=\"action rightcol\"><img "
  "src=\"/img/transparent.png\" alt=\"\" width=\"16px\" height=\"16px\" /></td>\n\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t\t<tr>\n"
  "\t\t\t\t\t\t\t\t<td class=\"leftcol \"><img src=\"\" alt=\"\" ></img></td>\n\t\t\t\t\t\t\t\t<td class=\"\"><div class"
  "=\"withmargin\"><a href=\"schedule.html\?channel=\"></a></div></td>\n\t\t\t\t\t\t\t\t<td class=\"\"><div class=\"with"
  "margin\"></div></td>\n\t\t\t\t\t\t\t\t<td class=\"\"><div class=\"withmargin\"></div></td>\n\t\t\t\t\t\t\t\t<td class"
  "=\"\"><div class=\"withmargin\"></div></td>\n\t\t\t\t\t\t\t\t<td class=\"\"><div class=\"withmargin\"><a\n\t\t\t\t\t"
  "\t\t\t\t\n\t\t\t\t\t\t\t\t></a></div></td>\n\t\t\t\t\t\t\t\t<td class=\"action \"><a href=\"searchresults.html\?searc"
  "hplain=\"><img src=\"\" alt=\"\" ></img></a></td>\n\t\t\t\t\t\t\t\t<td class=\"action \"><a href=\"timers.html\?timer"
  "id=&action=toggle\"><img src=\"\" alt=\"\" ></img></a></td>\n\t\t\t\t\t\t\t\t<td class=\"action \"><a href=\"edit_tim"
  "er.html\?timerid=\"><img src=\"\" alt=\"\" ></img></a></td>\n\t\t\t\t\t\t\t\t<td class=\"action rightcol \"><a href="
  "\"timers.html\?timerid=&action=delete\"><img src=\"\" alt=\"\" ></img></a></td>\n\t\t\t\t\t\t\t</tr>\n</%cpp\n\t\t\t"
  "\t\t\t<tr class=\"spacer\">\n\t\t\t\t\t\t\t<td colspan=\"10\"/>\n\t\t\t\t\t\t</tr>\n\t\t\t</table>\n\t\t</div>\n\t</b"
  "ody>\n</html>\n\n\n\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

#define SET_LANG(lang) \
     do \
     { \
       request.setLang(lang); \
       reply.setLocale(request.getLocale()); \
     } while (false)

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl)
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("timerconflicts " << qparam.getUrl());

  tnt::DataChunks data(rawData);

  // <%args>
  // </%args>

#line 21 "timerconflicts.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_GLOBAL_VAR(logged_in_type, logged_in, "bool logged_in", (false));   // <%session> bool logged_in(false)
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_GLOBAL_VAR(pageTitle_type, pageTitle, "std::string pageTitle", ());   // <%request> std::string pageTitle
  // <%cpp>
  // <%include> page_init.eh
#line 11 "page_init.eh"

try {
	reply.setHeader("Expires", "Mon, 26 Jul 1997 05:00:00 GMT");
	tnt::Savepoint spoint( reply );

  // </%include>
#line 24 "timerconflicts.ecpp"

if (!logged_in && LiveSetup().UseAuth()) return reply.redirect("login.html");

#line 27 "timerconflicts.ecpp"

	pageTitle = tr("Timer conflicts");
	TimerConflicts timerConflicts;
	cMutexLock timersLock( &LiveTimerManager() );
	SortedTimers& timers = LiveTimerManager().GetTimers();

  // <& pageelems.doc_type ...
  { 
#line 33 "timerconflicts.ecpp"
    tnt::QueryParams _tnt_cq0(qparam, false);
#line 33 "timerconflicts.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "doc_type"), request, reply, _tnt_cq0);
    // &>
  }
  reply.out() << data[0]; // \n<html>\n\t<head>\n\t\t<title>VDR-Live - 
#line 36 "timerconflicts.ecpp"
  reply.sout() << ( pageTitle );
  reply.out() << data[1]; // </title>\n\t\t
  // <& pageelems.stylesheets ...
  { 
#line 37 "timerconflicts.ecpp"
    tnt::QueryParams _tnt_cq1(qparam, false);
#line 37 "timerconflicts.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "stylesheets"), request, reply, _tnt_cq1);
    // &>
  }
  reply.out() << data[2]; // \n\t\t
  // <& pageelems.ajax_js ...
  { 
#line 38 "timerconflicts.ecpp"
    tnt::QueryParams _tnt_cq2(qparam, false);
#line 38 "timerconflicts.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_js"), request, reply, _tnt_cq2);
    // &>
  }
  reply.out() << data[3]; // \n\t</head>\n\t<body>\n\t\t
  // <& pageelems.logo ...
  { 
#line 41 "timerconflicts.ecpp"
    tnt::QueryParams _tnt_cq3(qparam, false);
#line 41 "timerconflicts.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "logo"), request, reply, _tnt_cq3);
    // &>
  }
  reply.out() << data[4]; // \n\t\t
  // <& menu ...
  { 
#line 42 "timerconflicts.ecpp"
    tnt::QueryParams _tnt_cq4(qparam, false);
#line 42 "timerconflicts.ecpp"
    _tnt_cq4.add( "active", tnt::toString(("timersconflicts"), reply.out().getloc() ) );
#line 42 "timerconflicts.ecpp"
    callComp(tnt::Compident(std::string(), "menu"), request, reply, _tnt_cq4);
    // &>
  }
  reply.out() << data[5]; // \n\t\t<div class="inhalt">\n
#line 44 "timerconflicts.ecpp"
			if (timerConflicts.size() == 0) {

  reply.out() << data[6]; // \t\t\t\t
#line 45 "timerconflicts.ecpp"
  reply.sout() << ( tr("No timer conflicts") );
  reply.out() << data[7]; // \n
#line 46 "timerconflicts.ecpp"
			} else {

  reply.out() << data[8]; // \t\t\t<table class="listing" cellspacing="0" cellpadding="0">\n
#line 48 "timerconflicts.ecpp"

				for (TimerConflicts::iterator conflict = timerConflicts.begin(); conflict != timerConflicts.end(); ++conflict) {
					const std::list< TimerInConflict >& conflTimers = conflict->ConflictingTimers();
					for (std::list< TimerInConflict >::const_iterator confltimer = conflTimers.begin(); confltimer != conflTimers.end(); ++confltimer) {

  reply.out() << data[9]; // \t\t\t\t\t\t<tr class="head">\n\t\t\t\t\t\t\t<td colspan="10">\n\t\t\t\t\t\t\t\t<div class="boxheader"><div><div>
#line 55 "timerconflicts.ecpp"
  reply.sout() << ( FormatDateTime(tr("%A, %x"), conflict->ConflictTime()) + " " + FormatDateTime(tr("%I:%M %p"), conflict->ConflictTime()) + " - " + lexical_cast<string, int>(confltimer->percentage) + "%" );
  reply.out() << data[10]; // </div></div></div>\n\t\t\t\t\t\t\t</td>\n\t\t\t\t\t\t</tr>\n\t\t\t\t\t\t<tr class="description">\n\t\t\t\t\t\t\t<td class="leftcol"><img src="/img/transparent.png" alt="" width="16px" height="16px" /></td>\n\t\t\t\t\t\t\t<td><div class="withmargin">
#line 60 "timerconflicts.ecpp"
  reply.sout() << ( trVDR("Channel") );
  reply.out() << data[11]; // </div></td>\n\t\t\t\t\t\t\t<td><div class="withmargin">
#line 61 "timerconflicts.ecpp"
  reply.sout() << ( trVDR("Start") );
  reply.out() << data[12]; // </div></td>\n\t\t\t\t\t\t\t<td><div class="withmargin">
#line 62 "timerconflicts.ecpp"
  reply.sout() << ( trVDR("Stop") );
  reply.out() << data[13]; // </div></td>\n\t\t\t\t\t\t\t<td><div class="withmargin">
#line 63 "timerconflicts.ecpp"
  reply.sout() << ( trVDR("Priority") );
  reply.out() << data[14]; // </div></td>\n\t\t\t\t\t\t\t<td><div class="withmargin">
#line 64 "timerconflicts.ecpp"
  reply.sout() << ( trVDR("File") );
  reply.out() << data[15]; // </div></td>\n\t\t\t\t\t\t\t<td class="action"><img src="/img/transparent.png" alt="" width="16px" height="16px" /></td>\n\t\t\t\t\t\t\t<td class="action"><img src="/img/transparent.png" alt="" width="16px" height="16px" /></td>\n\t\t\t\t\t\t\t<td class="action"><img src="/img/transparent.png" alt="" width="16px" height="16px" /></td>\n\t\t\t\t\t\t\t<td class="action rightcol"><img src="/img/transparent.png" alt="" width="16px" height="16px" /></td>\n\t\t\t\t\t\t</tr>\n
#line 70 "timerconflicts.ecpp"

						for (std::list<int>::const_iterator timerIndex = confltimer->concurrentTimerIndices.begin(); timerIndex != confltimer->concurrentTimerIndices.end(); ++timerIndex) {
							cTimer* timer = Timers.Get(*timerIndex-1);
							if (!timer) continue;

							std::list< int >::const_iterator nexttimerIndex = timerIndex;
							++nexttimerIndex;
							bool bottom = (nexttimerIndex == confltimer->concurrentTimerIndices.end());

							std::string timerStateImg = "transparent.png";
							std::string timerStateHint;
							if (timer->Index() == confltimer->timerIndex-1) {
								timerStateImg = "timerconflict.gif";
								timerStateHint = tr("Timer has a conflict.");
							}
							else if (timer->Flags() & tfActive) {
								timerStateImg = "arrow.png";
								timerStateHint = tr("Timer is active.");
							}

	        		        EpgInfoPtr epgEvent;
							string longDescription;
							string title;
							if (!timer->Event()) timer->SetEventFromSchedule();
							if (timer->Event()) {
								epgEvent = EpgEvents::CreateEpgInfo(timer->Channel(), timer->Event());
								longDescription = StringEscapeAndBreak(SortedTimers::GetTimerInfo(*timer)) + "<hr>"
													+ StringEscapeAndBreak(StringWordTruncate(epgEvent->LongDescr(), maximumDescriptionLength))
													+ "<br/><br/>" + tr("Click to view details.");
								title = epgEvent->Title();
							}

  reply.out() << data[16]; // \t\t\t\t\t\t\t<tr>\n\t\t\t\t\t\t\t\t<td class="leftcol 
#line 103 "timerconflicts.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << data[17]; // "><img src="
#line 103 "timerconflicts.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", timerStateImg) );
  reply.out() << data[18]; // " alt="" 
#line 103 "timerconflicts.ecpp"
 if (!timerStateHint.empty()) { 
  // <& tooltip.hint ...
  { 
#line 103 "timerconflicts.ecpp"
    tnt::QueryParams _tnt_cq5(qparam, false);
#line 103 "timerconflicts.ecpp"
    _tnt_cq5.add( "text", tnt::toString((timerStateHint), reply.out().getloc() ) );
#line 103 "timerconflicts.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq5);
    // &>
  }
#line 103 "timerconflicts.ecpp"
 } 
  reply.out() << data[19]; // ></img></td>\n\t\t\t\t\t\t\t\t<td class="
#line 104 "timerconflicts.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << data[20]; // "><div class="withmargin"><a href="schedule.html\?channel=
#line 104 "timerconflicts.ecpp"
  reply.sout() << ( timer->Channel()->Number());
  reply.out() << data[21]; // ">
#line 104 "timerconflicts.ecpp"
  reply.sout() << ( timer->Channel()->Name() );
  reply.out() << data[22]; // </a></div></td>\n\t\t\t\t\t\t\t\t<td class="
#line 105 "timerconflicts.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << data[23]; // "><div class="withmargin">
#line 105 "timerconflicts.ecpp"
  reply.sout() << ( FormatDateTime(tr("%I:%M %p"), timer->StartTime()) );
  reply.out() << data[24]; // </div></td>\n\t\t\t\t\t\t\t\t<td class="
#line 106 "timerconflicts.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << data[25]; // "><div class="withmargin">
#line 106 "timerconflicts.ecpp"
  reply.sout() << ( FormatDateTime(tr("%I:%M %p"), timer->StopTime()) );
  reply.out() << data[26]; // </div></td>\n\t\t\t\t\t\t\t\t<td class="
#line 107 "timerconflicts.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << data[27]; // "><div class="withmargin">
#line 107 "timerconflicts.ecpp"
  reply.sout() << ( timer->Priority() );
  reply.out() << data[28]; // </div></td>\n\t\t\t\t\t\t\t\t<td class="
#line 108 "timerconflicts.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << data[29]; // "><div class="withmargin"><a\n
#line 109 "timerconflicts.ecpp"
								if (!longDescription.empty()) {

  reply.out() << data[30]; // \t\t\t\t\t\t\t\t\t
  // <& tooltip.hint ...
  { 
#line 110 "timerconflicts.ecpp"
    tnt::QueryParams _tnt_cq6(qparam, false);
#line 110 "timerconflicts.ecpp"
    _tnt_cq6.add( "text", tnt::toString((longDescription), reply.out().getloc() ) );
#line 110 "timerconflicts.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq6);
    // &>
  }
  // <& tooltip.display ...
  { 
#line 110 "timerconflicts.ecpp"
    tnt::QueryParams _tnt_cq7(qparam, false);
#line 110 "timerconflicts.ecpp"
    _tnt_cq7.add( "domId", tnt::toString((epgEvent->Id()), reply.out().getloc() ) );
#line 110 "timerconflicts.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "display"), request, reply, _tnt_cq7);
    // &>
  }
  reply.out() << data[31]; // \n
#line 111 "timerconflicts.ecpp"
								}

  reply.out() << data[32]; // \t\t\t\t\t\t\t\t>
#line 112 "timerconflicts.ecpp"
  reply.sout() << ( timer->File() );
  reply.out() << data[33]; // </a></div></td>\n\t\t\t\t\t\t\t\t<td class="action 
#line 113 "timerconflicts.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << data[34]; // "><a href="searchresults.html\?searchplain=
#line 113 "timerconflicts.ecpp"
  reply.sout() << ( StringEscapeAndBreak(title) );
  reply.out() << data[35]; // "><img src="
#line 113 "timerconflicts.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "search.png") );
  reply.out() << data[36]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 113 "timerconflicts.ecpp"
    tnt::QueryParams _tnt_cq8(qparam, false);
#line 113 "timerconflicts.ecpp"
    _tnt_cq8.add( "text", tnt::toString((tr("Search for repeats.")), reply.out().getloc() ) );
#line 113 "timerconflicts.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq8);
    // &>
  }
  reply.out() << data[37]; // ></img></a></td>\n\t\t\t\t\t\t\t\t<td class="action 
#line 114 "timerconflicts.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << data[38]; // "><a href="timers.html\?timerid=
#line 114 "timerconflicts.ecpp"
  reply.sout() << ( SortedTimers::EncodeDomId(timers.GetTimerId(*timer)) );
  reply.out() << data[39]; // &action=toggle"><img src="
#line 114 "timerconflicts.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", (timer->Flags() & tfActive) ? "active.png" : "inactive.png") );
  reply.out() << data[40]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 114 "timerconflicts.ecpp"
    tnt::QueryParams _tnt_cq9(qparam, false);
#line 114 "timerconflicts.ecpp"
    _tnt_cq9.add( "text", tnt::toString((tr("Toggle timer active/inactive")), reply.out().getloc() ) );
#line 114 "timerconflicts.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq9);
    // &>
  }
  reply.out() << data[41]; // ></img></a></td>\n\t\t\t\t\t\t\t\t<td class="action 
#line 115 "timerconflicts.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << data[42]; // "><a href="edit_timer.html\?timerid=
#line 115 "timerconflicts.ecpp"
  reply.sout() << ( SortedTimers::EncodeDomId(timers.GetTimerId(*timer)) );
  reply.out() << data[43]; // "><img src="
#line 115 "timerconflicts.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "edit.png") );
  reply.out() << data[44]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 115 "timerconflicts.ecpp"
    tnt::QueryParams _tnt_cq10(qparam, false);
#line 115 "timerconflicts.ecpp"
    _tnt_cq10.add( "text", tnt::toString((tr("Edit timer")), reply.out().getloc() ) );
#line 115 "timerconflicts.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq10);
    // &>
  }
  reply.out() << data[45]; // ></img></a></td>\n\t\t\t\t\t\t\t\t<td class="action rightcol 
#line 116 "timerconflicts.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << data[46]; // "><a href="timers.html\?timerid=
#line 116 "timerconflicts.ecpp"
  reply.sout() << ( SortedTimers::EncodeDomId(timers.GetTimerId(*timer)) );
  reply.out() << data[47]; // &action=delete"><img src="
#line 116 "timerconflicts.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "del.png") );
  reply.out() << data[48]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 116 "timerconflicts.ecpp"
    tnt::QueryParams _tnt_cq11(qparam, false);
#line 116 "timerconflicts.ecpp"
    _tnt_cq11.add( "text", tnt::toString((tr("Delete timer")), reply.out().getloc() ) );
#line 116 "timerconflicts.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq11);
    // &>
  }
  reply.out() << data[49]; // ></img></a></td>\n\t\t\t\t\t\t\t</tr>\n
#line 118 "timerconflicts.ecpp"
						}

  reply.out() << data[50]; // </%cpp\n\t\t\t\t\t\t<tr class="spacer">\n\t\t\t\t\t\t\t<td colspan="10"/>\n\t\t\t\t\t\t</tr>\n
#line 123 "timerconflicts.ecpp"

					}
				}

  reply.out() << data[51]; // \t\t\t</table>\n
#line 128 "timerconflicts.ecpp"
			}

  reply.out() << data[52]; // \t\t</div>\n\t</body>\n</html>\n
  // <%include> page_exit.eh
  reply.out() << data[53]; // \n
#line 5 "page_exit.eh"

	spoint.commit();
} catch ( vdrlive::HtmlError const& ex ) {
#if TNTVERSION >= 1606
	tnt::QueryParams param = qparam;
#else
	cxxtools::QueryParams param = qparam;
#endif
	param.add( "pageTitle", pageTitle );
	param.add( "errorMessage", ex.what() );
	callComp( "error", request, reply, param );
}

  // </%include>
  reply.out() << data[54]; // \n\n
  // <%/cpp>
  return HTTP_OK;
}

} // namespace
