////////////////////////////////////////////////////////////////////////
// timers.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/convert.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.timers")

// <%pre>
#line 1 "timers.ecpp"

#include <set>
#include <vdr/i18n.h>
#include "timers.h"
#include "tools.h"
#include "setup.h"
#include "i18n.h"
#include "epg_events.h"
#include "timerconflict.h"
#include "livefeatures.h"

using namespace std;
using namespace vdrlive;

static const size_t maximumDescriptionLength = 300;


#line 1 "page_init.eh"

// do not add to Makefile
// and do not write a ecpp comment into this file. It must produce no
// html output not even a empty line.
#include <tnt/savepoint.h>
#include "exception.h"

#line 2 "page_exit.eh"

#include "exception.h"

// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    class timer_actions_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        timer_actions_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    timer_actions_type timer_actions;
};

static tnt::ComponentFactoryImpl<_component_> Factory("timers");

static const char* rawData = "\320\000\000\000\364\000\000\000\377\000\000\000\002\001\000\000\026\001\000\000\031\001"
  "\000\0001\001\000\0005\001\000\0006\001\000\000q\001\000\000\260\001\000\000\013\002\000\000\333\002\000\000\010\003"
  "\000\0005\003\000\000b\003\000\000\247\004\000\000\310\004\000\000\324\004\000\000\335\004\000\000\372\004\000\0003"
  "\005\000\0005\005\000\000U\005\000\000o\005\000\000\213\005\000\000\245\005\000\000\301\005\000\000\336\005\000\000"
  "\344\005\000\000\345\005\000\000\354\005\000\000\031\006\000\0008\006\000\000R\006\000\000[\006\000\000\203\006\000"
  "\000\246\006\000\000\262\006\000\000\273\006\000\000\354\006\000\000\013\007\000\000%\007\000\000.\007\000\000I\007"
  "\000\000o\007\000\000p\007\000\000q\007\000\000\213\007\000\000\220\007\000\000\311\007\000\000\316\007\000\000\n<htm"
  "l>\n\t<head>\n\t\t<title>VDR-Live - </title>\n\t\t\n\t\t\n\t</head>\n\t<body>\n\t\t\n\t\t\n\t\t<div class=\"inhalt\">"
  "\n\t\t\t\t\n\t\t\t<table class=\"listing\" cellspacing=\"0\" cellpadding=\"0\">\n\t\t\t\t\t\t<tr class=\"spacer\">\n"
  "\t\t\t\t\t\t\t<td colspan=\"8\"/>\n\t\t\t\t\t\t</tr>\n\t\t\t\t<tr class=\"head\">\n\t\t\t\t\t<td colspan=\"8\">\n\t\t"
  "\t\t\t\t<div class=\"boxheader\"><div><div>\n\t\t\t\t\t\t\t\n\t\t\t\t\t\t</div></div></div>\n\t\t\t\t\t</td>\n\t\t\t"
  "\t</tr>\n\t\t\t\t<tr class=\"description\">\n\t\t\t\t\t<td class=\"leftcol\"><img src=\"/img/transparent.png\" alt=\""
  "\" width=\"16px\" height=\"16px\" /></td>\n\t\t\t\t\t<td><div class=\"withmargin\"></div></td>\n\t\t\t\t\t<td><div cl"
  "ass=\"withmargin\"></div></td>\n\t\t\t\t\t<td><div class=\"withmargin\"></div></td>\n\t\t\t\t\t<td><div class=\"withm"
  "argin\"></div></td>\n\t\t\t\t\t<td class=\"action\"><img src=\"/img/transparent.png\" alt=\"\" width=\"16px\" height="
  "\"16px\" /></td>\n\t\t\t\t\t<td class=\"action\"><img src=\"/img/transparent.png\" alt=\"\" width=\"16px\" height=\"1"
  "6px\" /></td>\n\t\t\t\t\t<td class=\"action rightcol\"><img src=\"/img/transparent.png\" alt=\"\" width=\"16px\" heig"
  "ht=\"16px\" /></td>\n\t\t\t\t</tr>\n\t\t\t\t<tr>\n\n\t\t\t\t<td class=\"leftcol \"><img src=\"\" alt=\"\" ></img></td"
  ">\n\t\t\t\t\t<td class=\"\"><div class=\"withmargin\"><a href=\"schedule.html\?channel=\"></a></div></td>\n\t\t\t\t\t"
  "<td class=\"\"><div class=\"withmargin\"></div></td>\n\t\t\t\t\t<td class=\"\"><div class=\"withmargin\"></div></td>"
  "\n\t\t\t\t\t<td class=\"\"><div class=\"withmargin\"><a\n\t\t\t\t\t\t\n\t\t\t\t\t\t></a></div>\n\t\t\t\t\t</td>\n\t\t"
  "\t\t\t<td class=\"action \"><a href=\"timers.html\?timerid=&action=toggle\"><img src=\"\" alt=\"\" ></img></a></td>\n"
  "\t\t\t\t\t<td class=\"action \"><a href=\"edit_timer.html\?timerid=\"><img src=\"\" alt=\"\" ></img></a></td>\n\t\t\t"
  "\t\t<td class=\"action rightcol \"><a href=\"timers.html\?timerid=&action=delete\"><img src=\"\" alt=\"\" ></img></a>"
  "</td>\n\t\t\t\t</tr>\n\t\t\t</table>\n\t\t</div>\n\t</body>\n</html>\n\n\n<a href=\"edit_timer.html\"></a>\n<span cla"
  "ss=\"sep\">|</span>\n<a href=\"timerconflicts.html\"></a>\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

#define SET_LANG(lang) \
     do \
     { \
       request.setLang(lang); \
       reply.setLocale(request.getLocale()); \
     } while (false)

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl),
    timer_actions(*this, "timer_actions")
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("timers " << qparam.getUrl());

  tnt::DataChunks data(rawData);

  // <%args>
string timerid = tnt::stringTo<string>("timerid", "string", qparam.param("timerid"), reply.out().getloc());
string action = tnt::stringTo<string>("action", "string", qparam.param("action"), reply.out().getloc());
  // </%args>

#line 24 "timers.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_GLOBAL_VAR(logged_in_type, logged_in, "bool logged_in", (false));   // <%session> bool logged_in(false)
#line 27 "timers.ecpp"
  typedef cTimer* timer_type;
  TNT_REQUEST_PAGE_VAR(timer_type, timer, "cTimer* timer", ());   // <%request> cTimer* timer
#line 28 "timers.ecpp"
  typedef TimerConflictNotifier timerNotifier_type;
  TNT_REQUEST_PAGE_VAR(timerNotifier_type, timerNotifier, "TimerConflictNotifier timerNotifier", ());   // <%request> TimerConflictNotifier timerNotifier
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_GLOBAL_VAR(pageTitle_type, pageTitle, "std::string pageTitle", ());   // <%request> std::string pageTitle
  // <%cpp>
  // <%include> page_init.eh
#line 11 "page_init.eh"

try {
	reply.setHeader("Expires", "Mon, 26 Jul 1997 05:00:00 GMT");
	tnt::Savepoint spoint( reply );

  // </%include>
#line 31 "timers.ecpp"

	if (!logged_in && LiveSetup().UseAuth()) return reply.redirect("login.html");

	pageTitle = trVDR("Timers");

	cMutexLock timersLock( &LiveTimerManager() );
	SortedTimers& timers = LiveTimerManager().GetTimers();

	timer = 0;
	if ( !timerid.empty() ) {
		string tId = SortedTimers::DecodeDomId(timerid);
		// dsyslog("DEBUG: TIMER: tId = %s", tId.c_str());
		timer = timers.GetByTimerId(tId);
		if ( timer == 0 )
			throw HtmlError( tr("Couldn't find timer. Maybe you mistyped your request?") );
		if (action == "delete") {
			LiveTimerManager().DelTimer(timer);
			timerNotifier.SetTimerModification();
		}
		if (action == "toggle") {
			LiveTimerManager().ToggleTimerActive(timer);
			timerNotifier.SetTimerModification();
		}
	}

	string previousDay = "";

  // <& pageelems.doc_type ...
  { 
#line 58 "timers.ecpp"
    tnt::QueryParams _tnt_cq0(qparam, false);
#line 58 "timers.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "doc_type"), request, reply, _tnt_cq0);
    // &>
  }
  reply.out() << data[0]; // \n<html>\n\t<head>\n\t\t<title>VDR-Live - 
#line 61 "timers.ecpp"
  reply.sout() << ( pageTitle );
  reply.out() << data[1]; // </title>\n\t\t
  // <& pageelems.stylesheets ...
  { 
#line 62 "timers.ecpp"
    tnt::QueryParams _tnt_cq1(qparam, false);
#line 62 "timers.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "stylesheets"), request, reply, _tnt_cq1);
    // &>
  }
  reply.out() << data[2]; // \n\t\t
  // <& pageelems.ajax_js ...
  { 
#line 63 "timers.ecpp"
    tnt::QueryParams _tnt_cq2(qparam, false);
#line 63 "timers.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_js"), request, reply, _tnt_cq2);
    // &>
  }
  reply.out() << data[3]; // \n\t</head>\n\t<body>\n\t\t
  // <& pageelems.logo ...
  { 
#line 66 "timers.ecpp"
    tnt::QueryParams _tnt_cq3(qparam, false);
#line 66 "timers.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "logo"), request, reply, _tnt_cq3);
    // &>
  }
  reply.out() << data[4]; // \n\t\t
  // <& menu ...
  { 
#line 67 "timers.ecpp"
    tnt::QueryParams _tnt_cq4(qparam, false);
#line 67 "timers.ecpp"
    _tnt_cq4.add( "active", tnt::toString(("timers"), reply.out().getloc() ) );
#line 67 "timers.ecpp"
    _tnt_cq4.add( "component", tnt::toString(("timers.timer_actions"), reply.out().getloc() ) );
#line 67 "timers.ecpp"
    callComp(tnt::Compident(std::string(), "menu"), request, reply, _tnt_cq4);
    // &>
  }
  reply.out() << data[5]; // \n\t\t<div class="inhalt">\n
#line 69 "timers.ecpp"
			if (timers.size() == 0) {

  reply.out() << data[6]; // \t\t\t\t
#line 70 "timers.ecpp"
  reply.sout() << ( tr("No timer defined") );
  reply.out() << data[7]; // \n
#line 71 "timers.ecpp"
			} else {

  reply.out() << data[8]; // \t\t\t<table class="listing" cellspacing="0" cellpadding="0">\n
#line 73 "timers.ecpp"

				EpgEvents epgEvents;
				// output of the timer list:
				for (SortedTimers::iterator timer = timers.begin(); timer != timers.end(); ++timer) {
				    EpgInfoPtr epgEvent;
					string longDescription;
					if (!timer->Event()) timer->SetEventFromSchedule();
					if (timer->Event())
					{
						epgEvent = EpgEvents::CreateEpgInfo(timer->Channel(), timer->Event());
						longDescription = StringEscapeAndBreak(SortedTimers::GetTimerInfo(*timer)) + "<hr>"
											+ StringEscapeAndBreak(StringWordTruncate(epgEvent->LongDescr(), maximumDescriptionLength))
											+ "<br/><br/>" + tr("Click to view details.");
					}
					string currentDay = SortedTimers::GetTimerDays(*timer);
					SortedTimers::iterator nextTimer = timer; ++nextTimer;
					bool bottom = false;
					if (nextTimer == timers.end())
						bottom = true;
					else {
						string nextDay = SortedTimers::GetTimerDays(*nextTimer);
						bottom = (currentDay != nextDay);
					}
					if (previousDay != currentDay) {
						if (!previousDay.empty()) {

  reply.out() << data[9]; // \t\t\t\t\t\t<tr class="spacer">\n\t\t\t\t\t\t\t<td colspan="8"/>\n\t\t\t\t\t\t</tr>\n
#line 102 "timers.ecpp"

						}
						previousDay = currentDay;

  reply.out() << data[10]; // \t\t\t\t<tr class="head">\n\t\t\t\t\t<td colspan="8">\n\t\t\t\t\t\t<div class="boxheader"><div><div>\n\t\t\t\t\t\t\t
#line 109 "timers.ecpp"
  reply.sout() << ( currentDay );
  reply.out() << data[11]; // \n\t\t\t\t\t\t</div></div></div>\n\t\t\t\t\t</td>\n\t\t\t\t</tr>\n\t\t\t\t<tr class="description">\n\t\t\t\t\t<td class="leftcol"><img src="/img/transparent.png" alt="" width="16px" height="16px" /></td>\n\t\t\t\t\t<td><div class="withmargin">
#line 115 "timers.ecpp"
  reply.sout() << ( trVDR("Channel") );
  reply.out() << data[12]; // </div></td>\n\t\t\t\t\t<td><div class="withmargin">
#line 116 "timers.ecpp"
  reply.sout() << ( trVDR("Start") );
  reply.out() << data[13]; // </div></td>\n\t\t\t\t\t<td><div class="withmargin">
#line 117 "timers.ecpp"
  reply.sout() << ( trVDR("Stop") );
  reply.out() << data[14]; // </div></td>\n\t\t\t\t\t<td><div class="withmargin">
#line 118 "timers.ecpp"
  reply.sout() << ( trVDR("File") );
  reply.out() << data[15]; // </div></td>\n\t\t\t\t\t<td class="action"><img src="/img/transparent.png" alt="" width="16px" height="16px" /></td>\n\t\t\t\t\t<td class="action"><img src="/img/transparent.png" alt="" width="16px" height="16px" /></td>\n\t\t\t\t\t<td class="action rightcol"><img src="/img/transparent.png" alt="" width="16px" height="16px" /></td>\n\t\t\t\t</tr>\n
#line 123 "timers.ecpp"

					}
					std::string timerStateImg = "transparent.png";
					std::string timerStateHint;
					if (timer->Recording()) {
						timerStateImg = "arrow_rec.gif";
						timerStateHint = tr("Timer is recording.");
					}
					else if (timer->Flags() & tfActive) {
						timerStateImg = "arrow.png";
						timerStateHint = tr("Timer is active.");
					}

  reply.out() << data[16]; // \t\t\t\t<tr>\n\n\t\t\t\t<td class="leftcol 
#line 138 "timers.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << data[17]; // "><img src="
#line 138 "timers.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", timerStateImg) );
  reply.out() << data[18]; // " alt="" 
#line 138 "timers.ecpp"
 if (!timerStateHint.empty()) { 
  // <& tooltip.hint ...
  { 
#line 138 "timers.ecpp"
    tnt::QueryParams _tnt_cq5(qparam, false);
#line 138 "timers.ecpp"
    _tnt_cq5.add( "text", tnt::toString((timerStateHint), reply.out().getloc() ) );
#line 138 "timers.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq5);
    // &>
  }
#line 138 "timers.ecpp"
 } 
  reply.out() << data[19]; // ></img></td>\n\t\t\t\t\t<td class="
#line 139 "timers.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << data[20]; // "><div class="withmargin"><a href="schedule.html\?channel=
#line 139 "timers.ecpp"
  reply.sout() << ( timer->Channel()->Number());
  reply.out() << data[21]; // ">
#line 139 "timers.ecpp"
  reply.sout() << ( timer->Channel()->Name() );
  reply.out() << data[22]; // </a></div></td>\n\t\t\t\t\t<td class="
#line 140 "timers.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << data[23]; // "><div class="withmargin">
#line 140 "timers.ecpp"
  reply.sout() << ( FormatDateTime(tr("%I:%M %p"), timer->StartTime()) );
  reply.out() << data[24]; // </div></td>\n\t\t\t\t\t<td class="
#line 141 "timers.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << data[25]; // "><div class="withmargin">
#line 141 "timers.ecpp"
  reply.sout() << ( FormatDateTime(tr("%I:%M %p"), timer->StopTime()) );
  reply.out() << data[26]; // </div></td>\n\t\t\t\t\t<td class="
#line 142 "timers.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << data[27]; // "><div class="withmargin"><a\n
#line 143 "timers.ecpp"
						if (!longDescription.empty()) {

  reply.out() << data[28]; // \t\t\t\t\t\t
  // <& tooltip.hint ...
  { 
#line 144 "timers.ecpp"
    tnt::QueryParams _tnt_cq6(qparam, false);
#line 144 "timers.ecpp"
    _tnt_cq6.add( "text", tnt::toString((longDescription), reply.out().getloc() ) );
#line 144 "timers.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq6);
    // &>
  }
  // <& tooltip.display ...
  { 
#line 144 "timers.ecpp"
    tnt::QueryParams _tnt_cq7(qparam, false);
#line 144 "timers.ecpp"
    _tnt_cq7.add( "domId", tnt::toString((epgEvent->Id()), reply.out().getloc() ) );
#line 144 "timers.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "display"), request, reply, _tnt_cq7);
    // &>
  }
  reply.out() << data[29]; // \n
#line 145 "timers.ecpp"
					}

  reply.out() << data[30]; // \t\t\t\t\t\t>
#line 146 "timers.ecpp"
  reply.sout() << ( timer->File() );
  reply.out() << data[31]; // </a></div>\n\t\t\t\t\t</td>\n\t\t\t\t\t<td class="action 
#line 148 "timers.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << data[32]; // "><a href="timers.html\?timerid=
#line 148 "timers.ecpp"
  reply.sout() << ( SortedTimers::EncodeDomId(timers.GetTimerId(*timer)) );
  reply.out() << data[33]; // &action=toggle"><img src="
#line 148 "timers.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", (timer->Flags() & tfActive) ? "active.png" : "inactive.png") );
  reply.out() << data[34]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 148 "timers.ecpp"
    tnt::QueryParams _tnt_cq8(qparam, false);
#line 148 "timers.ecpp"
    _tnt_cq8.add( "text", tnt::toString((tr("Toggle timer active/inactive")), reply.out().getloc() ) );
#line 148 "timers.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq8);
    // &>
  }
  reply.out() << data[35]; // ></img></a></td>\n\t\t\t\t\t<td class="action 
#line 149 "timers.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << data[36]; // "><a href="edit_timer.html\?timerid=
#line 149 "timers.ecpp"
  reply.sout() << ( SortedTimers::EncodeDomId(timers.GetTimerId(*timer)) );
  reply.out() << data[37]; // "><img src="
#line 149 "timers.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "edit.png") );
  reply.out() << data[38]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 149 "timers.ecpp"
    tnt::QueryParams _tnt_cq9(qparam, false);
#line 149 "timers.ecpp"
    _tnt_cq9.add( "text", tnt::toString((tr("Edit timer")), reply.out().getloc() ) );
#line 149 "timers.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq9);
    // &>
  }
  reply.out() << data[39]; // ></img></a></td>\n\t\t\t\t\t<td class="action rightcol 
#line 150 "timers.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << data[40]; // "><a href="timers.html\?timerid=
#line 150 "timers.ecpp"
  reply.sout() << ( SortedTimers::EncodeDomId(timers.GetTimerId(*timer)) );
  reply.out() << data[41]; // &action=delete"><img src="
#line 150 "timers.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "del.png") );
  reply.out() << data[42]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 150 "timers.ecpp"
    tnt::QueryParams _tnt_cq10(qparam, false);
#line 150 "timers.ecpp"
    _tnt_cq10.add( "text", tnt::toString((tr("Delete timer")), reply.out().getloc() ) );
#line 150 "timers.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq10);
    // &>
  }
  reply.out() << data[43]; // ></img></a></td>\n\t\t\t\t</tr>\n
#line 152 "timers.ecpp"

				}
			}

  reply.out() << data[44]; // \t\t\t</table>\n\t\t</div>\n\t</body>\n</html>\n
  // <%include> page_exit.eh
  reply.out() << data[45]; // \n
#line 5 "page_exit.eh"

	spoint.commit();
} catch ( vdrlive::HtmlError const& ex ) {
#if TNTVERSION >= 1606
	tnt::QueryParams param = qparam;
#else
	cxxtools::QueryParams param = qparam;
#endif
	param.add( "pageTitle", pageTitle );
	param.add( "errorMessage", ex.what() );
	callComp( "error", request, reply, param );
}

  // </%include>
  reply.out() << data[46]; // \n
  // <%/cpp>
  return HTTP_OK;
}

unsigned _component_::timer_actions_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("timers::timer_actions " << qparam.getUrl());
  tnt::DataChunks data(rawData);
  // <%args>
  // </%args>

#line 27 "timers.ecpp"
  typedef cTimer* timer_type;
  TNT_REQUEST_PAGE_VAR(timer_type, timer, "cTimer* timer", ());   // <%request> cTimer* timer
#line 28 "timers.ecpp"
  typedef TimerConflictNotifier timerNotifier_type;
  TNT_REQUEST_PAGE_VAR(timerNotifier_type, timerNotifier, "TimerConflictNotifier timerNotifier", ());   // <%request> TimerConflictNotifier timerNotifier
#line 24 "timers.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_GLOBAL_VAR(logged_in_type, logged_in, "bool logged_in", (false));   // <%session> bool logged_in(false)
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_GLOBAL_VAR(pageTitle_type, pageTitle, "std::string pageTitle", ());   // <%request> std::string pageTitle
  // <%cpp>
  reply.out() << data[47]; // <a href="edit_timer.html">
#line 163 "timers.ecpp"
  reply.sout() << ( tr("New timer") );
  reply.out() << data[48]; // </a>\n
#line 164 "timers.ecpp"
 if ( LiveFeatures< features::epgsearch >().Recent() ) {

  reply.out() << data[49]; // <span class="sep">|</span>\n<a href="timerconflicts.html">
#line 166 "timers.ecpp"
  reply.sout() << ( tr("Timer conflicts") );
  reply.out() << data[50]; // </a>\n
#line 167 "timers.ecpp"
 }

  // <%/cpp>
  return HTTP_OK;
}

} // namespace
