////////////////////////////////////////////////////////////////////////
// whats_on.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/convert.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.whats_on")

// <%pre>
#line 1 "whats_on.ecpp"

#include <vdr/plugin.h>
#include <vdr/channels.h>
#include <vdr/epg.h>
#include <vdr/config.h>
#include <vdr/i18n.h>
#include "livefeatures.h"
#include "setup.h"
#include "tools.h"
#include "epg_events.h"
#include "epgsearch.h"

using namespace std;
using namespace vdrlive;

static const size_t maximumDescriptionLength = 300;
static const size_t maximumTooltipHintLength = 150;


#line 1 "page_init.eh"

// do not add to Makefile
// and do not write a ecpp comment into this file. It must produce no
// html output not even a empty line.
#include <tnt/savepoint.h>
#include "exception.h"

#line 2 "page_exit.eh"

#include "exception.h"

// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    class whats_on_actions_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        whats_on_actions_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    whats_on_actions_type whats_on_actions;
};

static tnt::ComponentFactoryImpl<_component_> Factory("whats_on");

static const char* rawData = "H\001\000\000l\001\000\000w\001\000\000z\001\000\000:\002\000\000\371\002\000\000>\003"
  "\000\000A\003\000\000Y\003\000\000\340\003\000\000\002\004\000\000f\004\000\000h\004\000\000i\004\000\000\304\004\000"
  "\000\364\004\000\000\367\004\000\000\376\004\000\000 \005\000\000-\005\000\000Q\005\000\000|\005\000\000\255\005\000"
  "\000\264\005\000\000\333\005\000\000\334\005\000\000\353\005\000\000\014\006\000\000\030\006\000\0003\006\000\000p"
  "\006\000\000s\006\000\000z\006\000\000\234\006\000\000\251\006\000\000\331\006\000\000\001\007\000\000\007\007\000"
  "\000\010\007\000\000#\007\000\000D\007\000\000\211\007\000\000\314\007\000\000\316\007\000\000\317\007\000\000\355"
  "\007\000\000\371\007\000\000\023\010\000\000\024\010\000\000\025\010\000\000\027\010\000\000!\010\000\000I\010\000"
  "\000X\010\000\000\202\010\000\000\253\010\000\000\273\010\000\000\350\010\000\000\352\010\000\000Y\t\000\000b\t\000"
  "\000j\t\000\000m\t\000\000w\t\000\000\251\t\000\000\253\t\000\000\366\t\000\0003\n\000\000=\n\000\000f\n\000\000h\n"
  "\000\000\210\n\000\000\264\n\000\000\300\n\000\000\315\n\000\000\317\n\000\000\324\n\000\000\376\n\000\000\n\013\000"
  "\000\027\013\000\000\031\013\000\000\036\013\000\000\n<html>\n\t<head>\n\t\t<title>VDR-Live - </title>\n\t\t\n\t\t\n"
  "\t\t<script type=\"text/javascript\"><!--\n\t\tfunction showtime(selection)\n\t\t{\n\t\t\tif (selection.options[selec"
  "tion.selectedIndex].value != \"\")\n\t\t\t\twindow.location.href = \"whats_on.html\?type=at&mode=&fixtime=\" + select"
  "ion.options[selection.selectedIndex].value;\n\t\t}\n\t\tfunction showspectime(selection)\n\t\t{\n\t\t\tif (selection."
  "value != \"\")\n\t\t\t\twindow.location.href = \"whats_on.html\?type=at&mode=&attime=\" + selection.value;\n\t\t}\n\t"
  "\t//--></script>\n\t</head>\n\t<body>\n\t\t\n\t\t\n\t\t<div class=\"inhalt\">\n\t\t\t<table class=\"listing\" cellspa"
  "cing=\"0\" cellpadding=\"0\">\n\t\t\t\t<tr class=\"head\">\n\t\t\t\t\t<td colspan=\"8\"><div class=\"boxheader\"><div"
  "><div></div></div></div></td>\n\t\t\t\t</tr>\n\t\t\t<div class=\"event\">\n\t\t\t\t<div class=\"station\">\n\t\t\t\t"
  "\t<div><div><div><a href=\"schedule.html\?channel=\" ></a></div></div></div>\n\t\t\t\t</div>\n\t\t\t\t<div class=\"co"
  "ntent\">\n\t\t\t\t\t<div class=\"tools\">\n\t\t\t\t\t\t\n\t\t\t\t\t</div>\n\t\t\t\t\t<div>\n\t\t\t\t\t\t<div class=\""
  "info\"> - </div>\n\t\t\t\t\t\t\t<div class=\"progress\"><div></div></div>\n\t\t\t\t\t\t<div class=\"title withmargin"
  "\"></div>\n\t\t\t\t\t\t<div class=\"short withmargin\"></div>\n\t\t\t\t\t\t<div class=\"description withmargin\"></di"
  "v>\n\t\t\t\t\t\t\t<div class=\"more withmargin\"><a > ...</a></div>\n\t\t\t\t\t</div>\n\t\t\t\t</div>\n\t\t\t</div>\n"
  "\t\t\t<tr>\n\t\t\t\t\n\t\t\t\t<td class=\"topaligned \">\n\t\t\t\t\t<div class=\"withmargin\">\n\t\t\t\t\t\t<div clas"
  "s=\"nomargin\"> - </div>\n\t\t\t\t\t\t\t<div class=\"progress\"><div></div></div>\n\t\t\t\t\t</div>\n\t\t\t\t</td>\n"
  "\t\t\t\t<td class=\"topaligned \">\n\t\t\t\t\t<div class=\"more withmargin\"><a\n\t\t\t\t\t\t\n\t\t\t\t\t\t><span cla"
  "ss=\"title\"></span><br /><span class=\"short\"></span></a>\n\t\t\t\t\t</div>\n\t\t\t\t</td>\n\t\t\t\t<td class=\"top"
  "aligned rightcol \"><div class=\"station withmargin\"><a \t\thref=\"schedule.html\?channel=\" ></a></div>\n\t\t\t\t</"
  "td>\n\t\t\t</tr>\n\t\t\t</table>\n\t\t</div>\n\t</body>\n</html>\n\n\n\n\n<a class=\"\" href=\"whats_on.html\?type=no"
  "w&amp;mode=\" id=\"nowhref\"></a>\n<span class=\"sep\">|</span>\n<a class=\"\" href=\"whats_on.html\?type=next&amp;mo"
  "de=\" id=\"nexthref\"></a>\n<span class=\"sep\">|</span>\n<span class=\"\"></span>\n<select name=\"userdeftimes\" siz"
  "e=\"1\" id=\"userdeftimes\" onchange=\"showtime(this)\">\n\t<option value=\"0\"/>\n\t<option  value=\"\"> </option>\n"
  "</select>\n<span class=\"sep\">|</span>\n<span class=\"\"></span>\n<input type=\"text\" size=\"6\" name=\"spectime\" "
  "id=\"spectime\" value = \"\" onchange=\"showspectime(this)\"/>\n<span class=\"sep\">|</span>\n<a class=\"\" href=\"wh"
  "ats_on.html\?type=favs&amp;mode=\"></a>\n<span class=\"sep\">|</span>\n<a href=\"whats_on.html\?mode=detail&amp;type="
  "&amp;attime=&amp;fixtime=\"></a>\n<a href=\"whats_on.html\?mode=list&amp;type=&amp;attime=&amp;fixtime=\"></a>\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

#define SET_LANG(lang) \
     do \
     { \
       request.setLang(lang); \
       reply.setLocale(request.getLocale()); \
     } while (false)

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl),
    whats_on_actions(*this, "whats_on_actions")
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("whats_on " << qparam.getUrl());

  tnt::DataChunks data(rawData);

  // <%args>
std::string type = qparam.param("type", ( "now"));
string mode = tnt::stringTo<string>("mode", "string", qparam.param("mode"), reply.out().getloc());
string attime = tnt::stringTo<string>("attime", "string", qparam.param("attime"), reply.out().getloc());
string fixtime = tnt::stringTo<string>("fixtime", "string", qparam.param("fixtime"), reply.out().getloc());
  // </%args>

#line 27 "whats_on.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_GLOBAL_VAR(logged_in_type, logged_in, "bool logged_in", (false));   // <%session> bool logged_in(false)
#line 30 "whats_on.ecpp"
  typedef string current_type_type;
  TNT_REQUEST_PAGE_VAR(current_type_type, current_type, "string current_type", ());   // <%request> string current_type
#line 31 "whats_on.ecpp"
  typedef string current_mode_type;
  TNT_REQUEST_PAGE_VAR(current_mode_type, current_mode, "string current_mode", ());   // <%request> string current_mode
#line 32 "whats_on.ecpp"
  typedef string current_attime_type;
  TNT_REQUEST_PAGE_VAR(current_attime_type, current_attime, "string current_attime", ());   // <%request> string current_attime
#line 33 "whats_on.ecpp"
  typedef string current_fixtime_type;
  TNT_REQUEST_PAGE_VAR(current_fixtime_type, current_fixtime, "string current_fixtime", ());   // <%request> string current_fixtime
#line 34 "whats_on.ecpp"
  typedef string current_displaytime_type;
  TNT_REQUEST_PAGE_VAR(current_displaytime_type, current_displaytime, "string current_displaytime", ());   // <%request> string current_displaytime
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_GLOBAL_VAR(pageTitle_type, pageTitle, "std::string pageTitle", ());   // <%request> std::string pageTitle
  // <%cpp>
  // <%include> page_init.eh
#line 11 "page_init.eh"

try {
	reply.setHeader("Expires", "Mon, 26 Jul 1997 05:00:00 GMT");
	tnt::Savepoint spoint( reply );

  // </%include>
#line 37 "whats_on.ecpp"

if (!logged_in && LiveSetup().UseAuth()) return reply.redirect("login.html");


cSchedulesLock schedulesLock;
const cSchedules* Schedules = cSchedules::Schedules(schedulesLock);

string head;
time_t seektime = 0;
string displaytime;

if (mode.empty())
	mode = LiveSetup().GetLastWhatsOnListMode();
else
	LiveSetup().SetLastWhatsOnListMode(mode);

current_type = type;
current_mode = mode;
current_attime = attime;
current_fixtime = fixtime;

if (type == "now") {
	head = tr("What's running at")+string(" ")+FormatDateTime(tr("%I:%M %p"), time(0));
} else if (type == "next") {
	head = tr("What's on next?");
} else if (type == "at") {
	if (attime != "")
		displaytime = ExpandTimeString(attime);
	else if (fixtime != "")
		displaytime = ExpandTimeString(fixtime);
	current_displaytime = displaytime;

	seektime = GetTimeT(displaytime);
	if (seektime - time(0) + 3600 < 0) // if wanted time is past more then 1h, then use tomorrow
		seektime += SECSINDAY;
	head = tr("What's running at") + string(" ") + FormatDateTime(tr("%I:%M %p"), seektime) +string(" (") +FormatDateTime(tr("%a, %b %d"), seektime) + string(")");
} else if (type == "favs") {
	head = tr("Favorites");
}


  // <& pageelems.doc_type ...
  { 
#line 78 "whats_on.ecpp"
    tnt::QueryParams _tnt_cq0(qparam, false);
#line 78 "whats_on.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "doc_type"), request, reply, _tnt_cq0);
    // &>
  }
  reply.out() << data[0]; // \n<html>\n\t<head>\n\t\t<title>VDR-Live - 
#line 81 "whats_on.ecpp"
  reply.sout() << ( head );
  reply.out() << data[1]; // </title>\n\t\t
  // <& pageelems.stylesheets ...
  { 
#line 82 "whats_on.ecpp"
    tnt::QueryParams _tnt_cq1(qparam, false);
#line 82 "whats_on.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "stylesheets"), request, reply, _tnt_cq1);
    // &>
  }
  reply.out() << data[2]; // \n\t\t
  // <& pageelems.ajax_js ...
  { 
#line 83 "whats_on.ecpp"
    tnt::QueryParams _tnt_cq2(qparam, false);
#line 83 "whats_on.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_js"), request, reply, _tnt_cq2);
    // &>
  }
  reply.out() << data[3]; // \n\t\t<script type="text/javascript"><!--\n\t\tfunction showtime(selection)\n\t\t{\n\t\t\tif (selection.options[selection.selectedIndex].value != "")\n\t\t\t\twindow.location.href = "whats_on.html\?type=at&mode=
#line 88 "whats_on.ecpp"
  reply.sout() << ( current_mode );
  reply.out() << data[4]; // &fixtime=" + selection.options[selection.selectedIndex].value;\n\t\t}\n\t\tfunction showspectime(selection)\n\t\t{\n\t\t\tif (selection.value != "")\n\t\t\t\twindow.location.href = "whats_on.html\?type=at&mode=
#line 93 "whats_on.ecpp"
  reply.sout() << ( current_mode );
  reply.out() << data[5]; // &attime=" + selection.value;\n\t\t}\n\t\t//--></script>\n\t</head>\n\t<body>\n\t\t
  // <& pageelems.logo ...
  { 
#line 98 "whats_on.ecpp"
    tnt::QueryParams _tnt_cq3(qparam, false);
#line 98 "whats_on.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "logo"), request, reply, _tnt_cq3);
    // &>
  }
  reply.out() << data[6]; // \n\t\t
  // <& menu ...
  { 
#line 99 "whats_on.ecpp"
    tnt::QueryParams _tnt_cq4(qparam, false);
#line 99 "whats_on.ecpp"
    _tnt_cq4.add( "active", tnt::toString(("whats_on"), reply.out().getloc() ) );
#line 99 "whats_on.ecpp"
    _tnt_cq4.add( "component", tnt::toString(("whats_on.whats_on_actions"), reply.out().getloc() ) );
#line 99 "whats_on.ecpp"
    callComp(tnt::Compident(std::string(), "menu"), request, reply, _tnt_cq4);
    // &>
  }
  reply.out() << data[7]; // \n\t\t<div class="inhalt">\n
#line 101 "whats_on.ecpp"
			if (mode == "list") {

  reply.out() << data[8]; // \t\t\t<table class="listing" cellspacing="0" cellpadding="0">\n\t\t\t\t<tr class="head">\n\t\t\t\t\t<td colspan="8"><div class="boxheader"><div><div>
#line 104 "whats_on.ecpp"
  reply.sout() << ( head );
  reply.out() << data[9]; // </div></div></div></td>\n\t\t\t\t</tr>\n
#line 106 "whats_on.ecpp"
	    }

#line 107 "whats_on.ecpp"

	EpgEvents epgEvents;
	std::list<EpgInfoPtr> eventList;

	// collect the broadcasts
	if (type != "favs")
	{
		ReadLock channelsLock( Channels );
		if (channelsLock) {
			// int evntNr = 0;
			for (cChannel *Channel = Channels.First(); Channel && Channel->Number() <= LiveSetup().GetLastChannel(); Channel = Channels.Next(Channel)) {
				if (Channel->GroupSep()) {
					continue;
				}
				const cSchedule *Schedule = Schedules->GetSchedule(Channel);
				if (!Schedule) {
					continue;
				}
				const cEvent *Event = NULL;
				if (type == "now")
					Event = Schedule->GetPresentEvent();
				else if (type == "next")
					Event = Schedule->GetFollowingEvent();
				else if (type == "at")
					Event = Schedule->GetEventAround(seektime);
				if (!Event) {
					continue;
				}

				EpgInfoPtr epgEvent = EpgEvents::CreateEpgInfo(Channel, Event);
				eventList.push_back(epgEvent);
			}
		}
	}
	else // get favorite broadcasts from epgsearch
	{
		SearchResults results;
		SearchTimers timers;
		for (SearchTimers::iterator timer = timers.begin(); timer != timers.end(); ++timer) {
			if (!timer->UseInFavorites()) continue;
			SearchResults curresults;
			curresults.GetByID(timer->Id());
			results.merge(curresults);
		}
		time_t now = time(NULL);
		for (SearchResults::iterator result = results.begin(); result != results.end(); ++result) {
			long diff = result->StartTime() - now;
            if (labs(diff) >= 24*60*60) continue; // skip broadcasts more than a day away
			EpgInfoPtr epgEvent = EpgEvents::CreateEpgInfo(result->GetChannel(), result->GetEvent());
			eventList.push_back(epgEvent);
		}
	}

	// display broadcasts
	for(std::list<EpgInfoPtr>::iterator i = eventList.begin(); i != eventList.end(); ++i ) {
		EpgInfoPtr epgEvent = *i;

		bool truncated = false;
		string truncDescription = StringWordTruncate(epgEvent->LongDescr(), maximumTooltipHintLength, truncated);
		string longDescription = StringEscapeAndBreak(StringWordTruncate(epgEvent->LongDescr(), maximumDescriptionLength))
			+ "<br/><br/>" + tr("Click to view details.");
		const cChannel* Channel = epgEvent->Channel();
		if (!Channel) continue;
		int chNumber = Channel->Number();

		if (mode == "detail") {

  reply.out() << data[10]; // \t\t\t<div class="event">\n\t\t\t\t<div class="station">\n\t\t\t\t\t<div><div><div><a href="schedule.html\?channel=
#line 176 "whats_on.ecpp"
  reply.sout() << ( chNumber );
  reply.out() << data[11]; // " 
  // <& tooltip.hint ...
  { 
#line 176 "whats_on.ecpp"
    tnt::QueryParams _tnt_cq5(qparam, false);
#line 176 "whats_on.ecpp"
    _tnt_cq5.add( "text", tnt::toString((tr("View the schedule of this channel")), reply.out().getloc() ) );
#line 176 "whats_on.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq5);
    // &>
  }
  reply.out() << data[12]; // >
#line 176 "whats_on.ecpp"
  reply.sout() << ( (epgEvent->Caption()) );
  reply.out() << data[13]; // </a></div></div></div>\n\t\t\t\t</div>\n\t\t\t\t<div class="content">\n\t\t\t\t\t<div class="tools">\n\t\t\t\t\t\t
  // <& pageelems.epg_tool_box ...
  { 
#line 180 "whats_on.ecpp"
    tnt::QueryParams _tnt_cq6(qparam, false);
#line 180 "whats_on.ecpp"
    _tnt_cq6.add( "detail", tnt::toString((1), reply.out().getloc() ) );
#line 180 "whats_on.ecpp"
    _tnt_cq6.add( "endTime", tnt::toString((epgEvent->GetEndTime()), reply.out().getloc() ) );
#line 180 "whats_on.ecpp"
    _tnt_cq6.add( "epgid", tnt::toString((epgEvent->Id()), reply.out().getloc() ) );
#line 180 "whats_on.ecpp"
    _tnt_cq6.add( "startTime", tnt::toString((epgEvent->GetStartTime()), reply.out().getloc() ) );
#line 180 "whats_on.ecpp"
    _tnt_cq6.add( "title", tnt::toString((epgEvent->Title()), reply.out().getloc() ) );
#line 180 "whats_on.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "epg_tool_box"), request, reply, _tnt_cq6);
    // &>
  }
  reply.out() << data[14]; // \n\t\t\t\t\t</div>\n\t\t\t\t\t<div>\n\t\t\t\t\t\t<div class="info">
#line 183 "whats_on.ecpp"
  reply.sout() << ( (epgEvent->StartTime(tr("%I:%M %p"))) );
  reply.out() << data[15]; //  - 
#line 183 "whats_on.ecpp"
  reply.sout() << ( (epgEvent->EndTime(tr("%I:%M %p"))) );
  reply.out() << data[16]; // </div>\n
#line 184 "whats_on.ecpp"
						if (epgEvent->Elapsed() >= 0) {

  reply.out() << data[17]; // \t\t\t\t\t\t\t<div class="progress"><div>
  // <& pageelems.progressbar ...
  { 
#line 185 "whats_on.ecpp"
    tnt::QueryParams _tnt_cq7(qparam, false);
#line 185 "whats_on.ecpp"
    _tnt_cq7.add( "progress", tnt::toString((epgEvent->Elapsed()), reply.out().getloc() ) );
#line 185 "whats_on.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "progressbar"), request, reply, _tnt_cq7);
    // &>
  }
  reply.out() << data[18]; // </div></div>\n
#line 186 "whats_on.ecpp"
						}

  reply.out() << data[19]; // \t\t\t\t\t\t<div class="title withmargin">
#line 187 "whats_on.ecpp"
  reply.sout() << ( (epgEvent->Title()) );
  reply.out() << data[20]; // </div>\n\t\t\t\t\t\t<div class="short withmargin">
#line 188 "whats_on.ecpp"
  reply.sout() << ( (epgEvent->ShortDescr()) );
  reply.out() << data[21]; // </div>\n\t\t\t\t\t\t<div class="description withmargin">
#line 189 "whats_on.ecpp"
  reply.sout() << ( truncDescription );
  reply.out() << data[22]; // </div>\n
#line 190 "whats_on.ecpp"
						if (truncated) {

  reply.out() << data[23]; // \t\t\t\t\t\t\t<div class="more withmargin"><a 
  // <& tooltip.hint ...
  { 
#line 191 "whats_on.ecpp"
    tnt::QueryParams _tnt_cq8(qparam, false);
#line 191 "whats_on.ecpp"
    _tnt_cq8.add( "text", tnt::toString((longDescription), reply.out().getloc() ) );
#line 191 "whats_on.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq8);
    // &>
  }
  // <& tooltip.display ...
  { 
#line 191 "whats_on.ecpp"
    tnt::QueryParams _tnt_cq9(qparam, false);
#line 191 "whats_on.ecpp"
    _tnt_cq9.add( "domId", tnt::toString((epgEvent->Id()), reply.out().getloc() ) );
#line 191 "whats_on.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "display"), request, reply, _tnt_cq9);
    // &>
  }
  reply.out() << data[24]; // >
#line 191 "whats_on.ecpp"
  reply.sout() << ( 	tr("more") );
  reply.out() << data[25]; //  ...</a></div>\n
#line 192 "whats_on.ecpp"
						}

  reply.out() << data[26]; // \t\t\t\t\t</div>\n\t\t\t\t</div>\n\t\t\t</div>\n
#line 196 "whats_on.ecpp"

		} else { // mode == "list"
			std::list<EpgInfoPtr>::iterator last = i;
			bool lastCurrentChanel = (++last == eventList.end());

  reply.out() << data[27]; // \t\t\t<tr>\n\t\t\t\t
  // <& pageelems.epg_tool_box ...
  { 
#line 202 "whats_on.ecpp"
    tnt::QueryParams _tnt_cq10(qparam, false);
#line 202 "whats_on.ecpp"
    _tnt_cq10.add( "detail", tnt::toString((0), reply.out().getloc() ) );
#line 202 "whats_on.ecpp"
    _tnt_cq10.add( "endTime", tnt::toString((epgEvent->GetEndTime()), reply.out().getloc() ) );
#line 202 "whats_on.ecpp"
    _tnt_cq10.add( "epgid", tnt::toString((epgEvent->Id()), reply.out().getloc() ) );
#line 202 "whats_on.ecpp"
    _tnt_cq10.add( "lastCurrentChanel", tnt::toString((lastCurrentChanel ? 1 : 0), reply.out().getloc() ) );
#line 202 "whats_on.ecpp"
    _tnt_cq10.add( "startTime", tnt::toString((epgEvent->GetStartTime()), reply.out().getloc() ) );
#line 202 "whats_on.ecpp"
    _tnt_cq10.add( "title", tnt::toString((epgEvent->Title()), reply.out().getloc() ) );
#line 202 "whats_on.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "epg_tool_box"), request, reply, _tnt_cq10);
    // &>
  }
  reply.out() << data[28]; // \n\t\t\t\t<td class="topaligned 
#line 203 "whats_on.ecpp"
  if ( lastCurrentChanel )
    reply.sout() <<  "bottomrow";
  reply.out() << data[29]; // ">\n\t\t\t\t\t<div class="withmargin">\n\t\t\t\t\t\t<div class="nomargin">
#line 205 "whats_on.ecpp"
  reply.sout() << ( (epgEvent->StartTime(tr("%I:%M %p"))) );
  reply.out() << data[30]; //  - 
#line 205 "whats_on.ecpp"
  reply.sout() << ( (epgEvent->EndTime(tr("%I:%M %p"))) );
  reply.out() << data[31]; // </div>\n
#line 206 "whats_on.ecpp"
						if (epgEvent->Elapsed() >= 0) {

  reply.out() << data[32]; // \t\t\t\t\t\t\t<div class="progress"><div>
  // <& pageelems.progressbar ...
  { 
#line 207 "whats_on.ecpp"
    tnt::QueryParams _tnt_cq11(qparam, false);
#line 207 "whats_on.ecpp"
    _tnt_cq11.add( "progress", tnt::toString((epgEvent->Elapsed()), reply.out().getloc() ) );
#line 207 "whats_on.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "progressbar"), request, reply, _tnt_cq11);
    // &>
  }
  reply.out() << data[33]; // </div></div>\n
#line 208 "whats_on.ecpp"
						}

  reply.out() << data[34]; // \t\t\t\t\t</div>\n\t\t\t\t</td>\n\t\t\t\t<td class="topaligned 
#line 211 "whats_on.ecpp"
  if ( lastCurrentChanel )
    reply.sout() <<  "bottomrow";
  reply.out() << data[35]; // ">\n\t\t\t\t\t<div class="more withmargin"><a\n
#line 213 "whats_on.ecpp"
 						if (!longDescription.empty()) {

  reply.out() << data[36]; // \t\t\t\t\t\t
  // <& tooltip.hint ...
  { 
#line 214 "whats_on.ecpp"
    tnt::QueryParams _tnt_cq12(qparam, false);
#line 214 "whats_on.ecpp"
    _tnt_cq12.add( "text", tnt::toString((longDescription), reply.out().getloc() ) );
#line 214 "whats_on.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq12);
    // &>
  }
  // <& tooltip.display ...
  { 
#line 214 "whats_on.ecpp"
    tnt::QueryParams _tnt_cq13(qparam, false);
#line 214 "whats_on.ecpp"
    _tnt_cq13.add( "domId", tnt::toString((epgEvent->Id()), reply.out().getloc() ) );
#line 214 "whats_on.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "display"), request, reply, _tnt_cq13);
    // &>
  }
  reply.out() << data[37]; // \n
#line 215 "whats_on.ecpp"
						}

  reply.out() << data[38]; // \t\t\t\t\t\t><span class="title">
#line 216 "whats_on.ecpp"
  reply.sout() << ( (epgEvent->Title()) );
  reply.out() << data[39]; // </span><br /><span class="short">
#line 216 "whats_on.ecpp"
  reply.sout() << ( (epgEvent->ShortDescr()) );
  reply.out() << data[40]; // </span></a>\n\t\t\t\t\t</div>\n\t\t\t\t</td>\n\t\t\t\t<td class="topaligned rightcol 
#line 219 "whats_on.ecpp"
  if ( lastCurrentChanel )
    reply.sout() <<  "bottomrow";
  reply.out() << data[41]; // "><div class="station withmargin"><a \t\thref="schedule.html\?channel=
#line 219 "whats_on.ecpp"
  reply.sout() << ( chNumber );
  reply.out() << data[42]; // " 
  // <& tooltip.hint ...
  { 
#line 219 "whats_on.ecpp"
    tnt::QueryParams _tnt_cq14(qparam, false);
#line 219 "whats_on.ecpp"
    _tnt_cq14.add( "text", tnt::toString((tr("View the schedule of this channel")), reply.out().getloc() ) );
#line 219 "whats_on.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq14);
    // &>
  }
  reply.out() << data[43]; // >
#line 219 "whats_on.ecpp"
  reply.sout() << ( (epgEvent->Caption()) );
  reply.out() << data[44]; // </a></div>\n\t\t\t\t</td>\n\t\t\t</tr>\n
#line 222 "whats_on.ecpp"
   	}

#line 223 "whats_on.ecpp"

	}

#line 226 "whats_on.ecpp"
	if (mode == "list") {

  reply.out() << data[45]; // \t\t\t</table>\n
#line 228 "whats_on.ecpp"
   }

  reply.out() << data[46]; // \t\t</div>\n\t</body>\n</html>\n
  // <%include> page_exit.eh
  reply.out() << data[47]; // \n
#line 5 "page_exit.eh"

	spoint.commit();
} catch ( vdrlive::HtmlError const& ex ) {
#if TNTVERSION >= 1606
	tnt::QueryParams param = qparam;
#else
	cxxtools::QueryParams param = qparam;
#endif
	param.add( "pageTitle", pageTitle );
	param.add( "errorMessage", ex.what() );
	callComp( "error", request, reply, param );
}

  // </%include>
  reply.out() << data[48]; // \n
  reply.out() << data[49]; // \n\n
  // <%/cpp>
  return HTTP_OK;
}

unsigned _component_::whats_on_actions_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("whats_on::whats_on_actions " << qparam.getUrl());
  tnt::DataChunks data(rawData);
  // <%args>
  // </%args>

#line 30 "whats_on.ecpp"
  typedef string current_type_type;
  TNT_REQUEST_PAGE_VAR(current_type_type, current_type, "string current_type", ());   // <%request> string current_type
#line 31 "whats_on.ecpp"
  typedef string current_mode_type;
  TNT_REQUEST_PAGE_VAR(current_mode_type, current_mode, "string current_mode", ());   // <%request> string current_mode
#line 32 "whats_on.ecpp"
  typedef string current_attime_type;
  TNT_REQUEST_PAGE_VAR(current_attime_type, current_attime, "string current_attime", ());   // <%request> string current_attime
#line 33 "whats_on.ecpp"
  typedef string current_fixtime_type;
  TNT_REQUEST_PAGE_VAR(current_fixtime_type, current_fixtime, "string current_fixtime", ());   // <%request> string current_fixtime
#line 34 "whats_on.ecpp"
  typedef string current_displaytime_type;
  TNT_REQUEST_PAGE_VAR(current_displaytime_type, current_displaytime, "string current_displaytime", ());   // <%request> string current_displaytime
#line 27 "whats_on.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_GLOBAL_VAR(logged_in_type, logged_in, "bool logged_in", (false));   // <%session> bool logged_in(false)
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_GLOBAL_VAR(pageTitle_type, pageTitle, "std::string pageTitle", ());   // <%request> std::string pageTitle
  // <%cpp>
  reply.out() << data[50]; // <a class="
#line 237 "whats_on.ecpp"
  if ( current_type == "now" )
    reply.sout() <<  "active" ;
  reply.out() << data[51]; // " href="whats_on.html\?type=now&amp;mode=
#line 237 "whats_on.ecpp"
  reply.sout() << ( current_mode );
  reply.out() << data[52]; // " id="nowhref">
#line 237 "whats_on.ecpp"
  reply.sout() << ( tr("Now") );
  reply.out() << data[53]; // </a>\n<span class="sep">|</span>\n<a class="
#line 239 "whats_on.ecpp"
  if ( current_type == "next" )
    reply.sout() <<  "active" ;
  reply.out() << data[54]; // " href="whats_on.html\?type=next&amp;mode=
#line 239 "whats_on.ecpp"
  reply.sout() << ( current_mode );
  reply.out() << data[55]; // " id="nexthref">
#line 239 "whats_on.ecpp"
  reply.sout() << ( tr("Next") );
  reply.out() << data[56]; // </a>\n<span class="sep">|</span>\n<span class="
#line 241 "whats_on.ecpp"
  if ( current_type == "at" && current_fixtime != "" )
    reply.sout() <<  "active" ;
  reply.out() << data[57]; // ">
#line 241 "whats_on.ecpp"
  reply.sout() << ( tr("What's on") );
  reply.out() << data[58]; // </span>\n<select name="userdeftimes" size="1" id="userdeftimes" onchange="showtime(this)">\n\t<option value="0"/>\n
#line 244 "whats_on.ecpp"

	vector< string > parts = StringSplit( LiveSetup().GetTimes(), ';' );
	vector< string >::const_iterator part = parts.begin();
	for ( int i = 0; part != parts.end(); ++i, ++part ) {

  reply.out() << data[59]; // \t<option 
#line 249 "whats_on.ecpp"
 reply.out() << ( (current_fixtime != "" && *part == current_displaytime) ? "selected=\"selected\"" : "" ); 
  reply.out() << data[60]; //  value="
#line 249 "whats_on.ecpp"
  reply.sout() << ( *part );
  reply.out() << data[61]; // "> 
#line 249 "whats_on.ecpp"
  reply.sout() << ( tr("at") + string(" ") + *part );
  reply.out() << data[62]; // </option>\n
#line 250 "whats_on.ecpp"

	}

  reply.out() << data[63]; // </select>\n<span class="sep">|</span>\n<span class="
#line 255 "whats_on.ecpp"
  if ( current_type == "at" && current_fixtime == "" )
    reply.sout() <<  "active" ;
  reply.out() << data[64]; // ">
#line 255 "whats_on.ecpp"
  reply.sout() << ( tr("at") );
  reply.out() << data[65]; // </span>\n<input type="text" size="6" name="spectime" id="spectime" value = "
#line 256 "whats_on.ecpp"
  if ( current_attime != "" )
    reply.sout() <<  current_displaytime ;
  reply.out() << data[66]; // " onchange="showspectime(this)"/>\n<span class="sep">|</span>\n
#line 258 "whats_on.ecpp"
 if ( LiveFeatures< features::epgsearch >().Recent() ) {

  reply.out() << data[67]; // <a class="
#line 259 "whats_on.ecpp"
  if ( current_type == "favs" )
    reply.sout() <<  "active" ;
  reply.out() << data[68]; // " href="whats_on.html\?type=favs&amp;mode=
#line 259 "whats_on.ecpp"
  reply.sout() << ( current_mode );
  reply.out() << data[69]; // ">
#line 259 "whats_on.ecpp"
  reply.sout() << ( tr("Favorites") );
  reply.out() << data[70]; // </a>\n<span class="sep">|</span>\n
#line 261 "whats_on.ecpp"
 }

#line 262 "whats_on.ecpp"
 if ( current_mode == "list" ) {

  reply.out() << data[71]; // <a href="whats_on.html\?mode=detail&amp;type=
#line 263 "whats_on.ecpp"
  reply.sout() << ( current_type );
  reply.out() << data[72]; // &amp;attime=
#line 263 "whats_on.ecpp"
  reply.sout() << ( current_attime );
  reply.out() << data[73]; // &amp;fixtime=
#line 263 "whats_on.ecpp"
  reply.sout() << ( current_fixtime );
  reply.out() << data[74]; // ">
#line 263 "whats_on.ecpp"
  reply.sout() << ( tr("Details view") );
  reply.out() << data[75]; // </a>\n
#line 264 "whats_on.ecpp"
 } else {

  reply.out() << data[76]; // <a href="whats_on.html\?mode=list&amp;type=
#line 265 "whats_on.ecpp"
  reply.sout() << ( current_type );
  reply.out() << data[77]; // &amp;attime=
#line 265 "whats_on.ecpp"
  reply.sout() << ( current_attime );
  reply.out() << data[78]; // &amp;fixtime=
#line 265 "whats_on.ecpp"
  reply.sout() << ( current_fixtime );
  reply.out() << data[79]; // ">
#line 265 "whats_on.ecpp"
  reply.sout() << ( tr("List view") );
  reply.out() << data[80]; // </a>\n
#line 266 "whats_on.ecpp"
 }

  // <%/cpp>
  return HTTP_OK;
}

} // namespace
